
      SUBROUTINE OPTIMIZE(NDIM1,F,OBJ,GRADF,BETA1,EPS_BF1,IUSER)
C//////////////////////////////////////////////////////////////////////*
C  USE  SUBROUTINE LBFGS TO MAXIMIZE FUNCTION F         30 / 08 / 95   *
C//////////////////////////////////////////////////////////////////////*
c
      use parinclu2
c
      implicit none
c parameters for lbfgs
      real*8,allocatable :: w(:)       !W(NWORK)
      real*8,allocatable :: DIAG(:) !DIAG(NDIMAX) 
      real*8,allocatable :: STD(:)  !STD(NDIMAX2)	  
	  
      INTEGER NWORK,NSTATE,IUSER(3)
      REAL*8 DLDET,OBJ,BETA1(*),GRADF(*)
      REAL*8 F,XTOL,GTOL,STPMIN,STPMAX,EPS_BF1
      INTEGER IPRINT(2),IFLAG,ICALL,NDIM1,MP,LP,J,JJ
      INTEGER NSTATUS,NOPTION,JOB,ICODE
      REAL SECOND2,TIM0,TIM1
      CHARACTER*100 FILEBK
      LOGICAL DIAGCO
      EXTERNAL LB2
      COMMON /LB3/MP,LP,GTOL,STPMIN,STPMAX
C
      NWORK=NDIMAX*(2*MVEC_BF +1)+2*MVEC_BF    !NWORK changed from parameter to variable
      allocate(W(NWORK))
      allocate(DIAG(NDIMAX))
      allocate(STD(NDIMAX2))
	  
      IPRINT(1)= 1
      IPRINT(2)= 0
C
C     We do not wish to provide the diagonal matrices Hk0, and
C     therefore set DIAGCO to FALSE.
C
      DIAGCO= .FALSE.
      XTOL= 1.0D-16
      ICALL=1
      IFLAG=0
      JJ=0
      DO 202 J=1,MAXRAND
        IF (BOUND(J,1).GT.0.D0) JJ=J
  202 CONTINUE
      TIM0=SECOND2 ()
      IF (IUSER(3).EQ.-1) THEN
           TOTIM=0
           ITOEV=0
       ENDIF
c       CALL CHEKG(BETA1,NDIM1)
c
   20 CALL  FCOX(BETA1,F,GRADF,NDIM1,NSTATE,IUSER)
      IF (BACKUP.NE.' ') THEN
        ICODE=1
        FILEBK=BACKUP
        CALL RWBACKUP(ICODE,FILEBK)
      ENDIF
      CALL LBFGS(NDIM1,MVEC_BF,BETA1,F,GRADF,DIAGCO,DIAG,IPRINT,
     +           EPS_BF1,XTOL,W,IFLAG)
      IF(IFLAG.LE.0) GO TO 50
      ICALL=ICALL + 1
      ITOEV=ITOEV+1
C     We allow at most ITER_BF evaluations of F and GRADF
      IF(ICALL.GT.ITER_BF) GO TO 50
      GO TO 20
  50  CONTINUE
C
      NOPTION=1
      IF (NSTATUS.NE.1) NSTATUS=0
      TIM1= SECOND2()
      TIM0=TIM1 - TIM0
      TOTIM=TOTIM+TIM0
      TIM0=TIM1
      IF (IUSER(3).EQ.-1) RETURN
      CALL FCOX2(BETA1,F,GRADF,STD,DLDET,NSTATUS,NOPTION,NDIM1)
      OBJ = F+0.5D0*DLDET
      WRITE(6,310) F,DLDET,OBJ
      WRITE(12,310) F,DLDET,OBJ
      IF (IUSER(3).EQ.99) F=OBJ
      IF (IUSER(3).EQ.99) F=OBJ
      TIM1= SECOND2()
      TIM1=TIM1 - TIM0
      TOTIM=TOTIM+TIM1
 300  FORMAT(1X,A2,5F10.4)
 310  FORMAT(1X,' F = ',G18.10,'  DLDET = ',G18.10,'  OBJ = ',G18.10)
 
      deallocate(w)
      deallocate(DIAG,std)
      RETURN
c***********************************************************************
       END
	   
	   
      SUBROUTINE CHEKG(BETA1,NDIM1)
      use parinclu2
      implicit none
      real*8,allocatable :: GRADF(:),STD(:),GRADF0(:) !all NDIMAX  
	  
      INTEGER I,J,NDIM1,IUSER(3),NSTATE
      INTEGER NSTATUS,NOPTION
      REAL*8 DLDET,DF,BETA1(*)
      LOGICAL calhess
      REAL*8 F,F0,X
	  
      allocate(GRADF(NDIMAX),STD(NDIMAX),GRADF0(NDIMAX),H(NDIM1,NDIM1))
	  
       calhess=.FALSE.
c     calhess=.TRUE.
      IF (calhess) THEN
        CALL FCOX2(BETA1,F0,GRADF0,STD,DLDET,NSTATUS,NOPTION,NDIM1)
        CALL FCOX(BETA1,F0,GRADF0,NDIM1,NSTATE,IUSER)
      ELSE
        CALL FCOX(BETA1,F0,GRADF0,NDIM1,NSTATE,IUSER)
      ENDIF
      do 20 i=1,NDIM1
        BETA1(I) = BETA1(I) +1.D-6
        CALL  FCOX(BETA1,F,GRADF,NDIM1,NSTATE,IUSER)
         DF = 1.D+6* (F-F0)
         X = (DF-GRADF0(I))/MAX(1.D0,GRADF0(I))
         IF (DABS(X).GT.1.D-4) THEN
           write(6,*) 'GRAD ' ,I,' app= ',DF,' calc=',GRADF0(I)
         ELSE
           write(6,*) 'GRAD ' ,I,' app= ',DF,' calc=',GRADF0(I)
     +            ,' OK'
         ENDIF
         BETA1(I) = BETA1(I) - 1.D-6
   20 CONTINUE
      IF (calhess) THEN
      do 210 i=1,NDIM1
       do 220 j=i,NDIM1
        BETA1(J) = BETA1(J) +1.D-7
        CALL  FCOX(BETA1,F,GRADF,NDIM1,NSTATE,IUSER)
        F = 1.D+7 *(GRADF(I)-GRADF0(I))
        IF ((dabs(H(I,J)).LT.1.D-6).AND.(DABS(F).LT.1.D-5)) GOTO 225
        X = (F-H(I,J))/MAX(1.D0,H(I,J))
        IF (DABS(X).GT.1.D-4) THEN
          write(6,*)  'HESS' ,I,J,' app= ',F,' calc=',H(I,J)
        ELSE
           write(6,*) 'HESS ',I,J,F,' OK'
        ENDIF
 225    BETA1(J) = BETA1(J) - 1.D-7
 220   continue
 210  CONTINUE
      ENDIF
      
      deallocate(GRADF,STD,GRADF0,H)
      RETURN
      END
      FUNCTION FTOMIN(XC)
C***********************************************************************
C***********************************************************************
C  COMPUTE THE VALUE MINIMIZING F
      use parinclu2
      implicit none
      real*8,allocatable :: GRADF(:) !GRADF(NDIMAX)
      INTEGER I,J
      INTEGER IUSER(3)
      REAL*8 FC,OBJ,XC
      REAL*8 FTOMIN
c
      allocate(GRADF(NDIMAX))
c
      J=0
      DO 1 I=1,MAXRAND
        IF (BOUND(I,1).NE.0.D0)  J = I
  1   CONTINUE
      IF (IGAM(J,1).NE.0) THEN
        XGAM(J)=XC
      ELSE
        XNOR(J)=XC
      ENDIF
      IUSER(3)=99
      write(12,50) XC
      WRITE(6,50) XC
      CALL OPTIMIZE(NDIM,FC,OBJ,GRADF,BETA,EPS_BF,IUSER)
  50  FORMAT(1X,' EVALUATION AT VARIANCE PARAMETER = ',F10.5)
      FTOMIN = OBJ
      deallocate(GRADF)
      RETURN
C***********************************************************************
      END
	  
