      SUBROUTINE BACKSOL(BETA1,NDIM1,IBACKS)
C***********************************************************************
C  BACKSOL       *                                    *  05 / 12 /2000 *
C***********************************************************************
C  COMPUTE APPROXIMATE ESTIMATES FOR THE EFFECT INTEGRATED OUT         *
C***********************************************************************
c
      use parinclu
      implicit none
c
      integer,allocatable:: listr(:)   !LISTR(MXLVOUT)
      real*8,allocatable:: solhys(:)   !SOLHYS(MXLVOUT)
      real*8, allocatable :: temp(:)   !TEMP(MXEF)
	  
      integer,allocatable:: kfirst(:),klast(:),listys(:)  !all NDIMAX
c
      INTEGER NSTATE,IUSER(3)
C
      INTEGER NDIM1,LAST,LAST1
      INTEGER I,J,J1,J2,J3,JJ,K,KK,ICODE,IPRETIM,ITIM,IQ,IVALQ
      INTEGER IPRESTR,LTAB
      INTEGER I1,I2,ISTR,IDF,NDCOV0,NDCOV1,NDCOVP1,NHYS,NHYSF,IBACKS 
      INTEGER NDIMBPS
      INTEGER JPREV,ILIM,IP,IGP,JP,JGP
      INTEGER IDHYS,KK1,KANI,KANIPREV,NTROUP,IT
C
      INTEGER IDHERD,NH,N1,MAXYS,NLISTYS,NCOND,JSAME
      INTEGER IERR
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on October 20,2003
      CHARACTER*15 FILENAMC
      CHARACTER*8 EFFECT
C
      INTEGER ISEX
C
      REAL*8 GAMLOG,GAMVAR
      REAL*8 GAM0,XNQGAM,OMQGAM,R1GAM,OMEG,CONST
      REAL*8 F,U,W,W1,W2,W3,CUMRISK,XNS,XNQ,XCOV,X,DM1(7)
      REAL*8 BETA1(*)
      REAL*8 RHO,TRHO,TPRERHO,LRHO,DLTIM,DLPRETIM
      REAL*8 HYS,HYSTD,DELT,EPHI,OBS,CUMRISK2
      REAL*8 PHI_OLD,PHI_NEW,R,GA,EGA,POIDS,FPRIM,VAR,SIGM1,B,SP
      REAL*8 OBS2,SP2
C
      LOGICAL modsir,sinteg,modani
C
      CHARACTER*100 FILENAM,FILENAM2
C
      EQUIVALENCE(FILENAM,FILENAMC)
      DATA (DM1(I),I=1,7)/1.D0,1.33333333333333D0,2.D0,
     +  1.D0,1.3333333333D0,1.06666666667D0,1.4545454545455D0/
C 
      allocate( LISTR(MXLVOUT) )
      allocate( SOLHYS(MXLVOUT) )
      allocate( TEMP(MXEF) )
	  
      allocate( kfirst(NDIMAX),klast(NDIMAX),listys(NDIMAX) )
	 

C
C----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      IF (MOD(IBACKS,10).EQ.1) then
         sinteg = .true.
      ELSE
         sinteg = .false.
      ENDIF
      IF (IBACKS.GE.100) then
         modani = .true.
         modsir = .false.
      ELSE IF (IBACKS.GE.10) THEN 
         modani = .false.
         modsir = .true.
      ELSE
         modani = .false.
         modsir = .false.
      ENDIF
C
      ISEX =2 
      JGP=0
      If (modsir.OR.modani) then
      DO 70 K=1,IR2
         I = ITRAIT2(K) 
         J = IORDR2(K)+NCCOV
         IF (I.NE.0.AND.ISAME(I).NE.0) THEN
           JGP=J
         ELSE
           IF (INOR(I,1).GE.1) THEN
             IF (NRELMAT2.EQ.0) THEN
                if (modsir) then
                  SIGM1 = 1.D0 / (4.D0 * XNOR(I))
                else
                  SIGM1 = 1.D0 / XNOR(I)
                endif
                ILIM=IFIRST(I)-1
                JP = J
             ELSE IF (I.EQ.NRELMAT2) THEN
               if (modsir) then
                  SIGM1 = 1.D0 / (4.D0 * XNOR(NRELMAT2))  
               else
                  SIGM1 = 1.D0 / XNOR(NRELMAT2)
               endif
               JP = J
               ILIM=IFIRST(I)-1
             ENDIF
           ENDIF 
         ENDIF      
  70  CONTINUE
      OPEN(16,file=FILE(11),FORM='FORMATTED')
      endif
C
      if (sinteg) then
      IOLDCODE=0
      FILENAM2=TRIM(FILE(3))//'.backsol' 
      OPEN(15,file=FILENAM2,FORM='FORMATTED')
      OPEN(10,FILE=file(2),FORM='FORMATTED')
   5  READ(10,52,END=59) EFFECT,JJ,KK,J1,J2,J3,I,J
  52  FORMAT(1X,A8,I5,I2,3I10,2I8)
      IF (NRELMAT2.NE.0) THEN 
         IF (EFFECT.EQ.LABEL(NRELMAT2)) THEN
            IF (J.GT.0) THEN
               IRANK(J)=J1
            ELSE
               IRANK(ILIM-J)=J1
            ENDIF
         ENDIF
      ENDIF
      IF (EFFECT.EQ.LABEL(INTEGAM)) THEN
          IF (J.EQ.NDIMAX+1) THEN
            WRITE(15,53) JJ
            WRITE(6,53) JJ
  53        FORMAT(/1X,' ******** WARNING !!! ********',
     + /1X,' FOR A PROPER IDENTIFICATION OF ORIGINAL CODES FOR',
     + ' THE EFFECT INTEGRATED OUT',/1X,' NDIMAX SHOULD BE AT ',
     + 'LEAST EQUAL TO ',I8,/1X,' THE PROGRAM CONTINUES')
          ENDIF
         IOLDCODE(J,1)=J1
         IF (KK.GT.1) THEN
           IOLDCODE(J,2)=J2
           IF (KK.EQ.3) IOLDCODE(J,3)=J3 
         ENDIF
         KK1=KK
      ENDIF
      IF (NWITHIN.NE.0) THEN
         IF (EFFECT.EQ.LABEL(NWITHIN)) THEN
            IOLDCODE(J,4)=J1 
         ENDIF
      ENDIF
      GOTO 5
   59 CLOSE(10)
C 
      IF (NWITHIN.EQ.0) THEN
         WRITE(15,9000) LABEL(INTEGAM)
 9000    FORMAT(/7X,A8,'  (APPROXIMATE ',
     +       'SOLUTIONS AND (UNDESTIMATED) STANDARD ERRORS)'/) 
            WRITE(15,9030)
 9030       FORMAT(1X,' LEVEL                     ESTIMATE ',
     +      ' STANDARD  TOTAL  UNCENSORED',
     +      /40X,'ERROR  RECORDS   RECORDS') 
      ELSE
         WRITE(15,9005) LABEL(INTEGAM),LABEL(NWITHIN)
 9005    FORMAT(/7X,A8,' within ',A8,'  (APPROXIMATE ',
     +       'SOLUTIONS AND (UNDESTIMATED) STANDARD ERRORS)'/) 
            WRITE(15,9040)
 9040       FORMAT(1X,' LEVEL (within) LEVEL      ESTIMATE ',
     +      ' STANDARD  TOTAL  UNCENSORED',
     +      /40X,'ERROR  RECORDS   RECORDS') 
      ENDIF
C
      IF (INTEGAM.NE.0) THEN
        IF (NJOINT.EQ.0) THEN
          GAMVAR = XGAM(INTEGAM)
        ELSE
          GAMVAR=DEXP(BETA1(NDIM1))
        ENDIF
      ENDIF
      endif
C
      NDCOV0 = NCCOV + 1
      NDCOV1 = NCCOV + NDCOV
      NDCOVP1 = NDCOV1 + 1
      NDIMBPS= NDIMB + NSTRATA
      MAXYS=1000
c
C-----------------------------------------------------------------------
C  READ THE VALUE(S) OF RHO IF ICRHO=1
C-----------------------------------------------------------------------
      IF (ICRHO.EQ.1) THEN
        K = NSTRATA
        IF (NO_LOG.EQ.1) THEN
          DO 11 I=1,NSTRATA
            VALRHO(I) = BETA1(NDIMBPS+I)
            DLOGRHO(I) = DLOG(VALRHO(I))
  11      CONTINUE
        ELSE
          DO 12 I=1,NSTRATA
            DLOGRHO(I) = BETA1(NDIMBPS+I)
            VALRHO(I) = DEXP(DLOGRHO(I))
  12      CONTINUE
        ENDIF
      ELSE IF (ICRHO.EQ.99) THEN
        DO 16 I=1,NSTRATA
          DLOGRHO(I) = 0.D0
          VALRHO(I) =  1.D0
  16    CONTINUE
      ENDIF
c
      DO 13 I=1,NSTRATA
         VECEXP(1,I) =  1.D0
	 DO 14 J=2,MAXTIM(1)
          IF (ICRHO.EQ.99) THEN
             VECEXP(J,I)=DBLE(J)
          ELSE
            IF (VECLOG(J).NE.0.D0) THEN
              VECEXP(J,I) =  DEXP(VALRHO(I)*VECLOG(J))
	    ENDIF
	  ENDIF
  14     CONTINUE
  13  CONTINUE

C
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1) THEN
        IF (IOMODE.NE.4) THEN
           OPEN(4,file=FILE(9),FORM='UNFORMATTED')
c        ELSE
c           FILENAM=FILE(9)
c           CALL f77openr(IDFILE,FILENAMC)
c           IERR=1
        ENDIF
      ENDIF
C
C
      IQ = 0
      KANIPREV=0
      LAST = -1
      IPRETIM = 0
      IPRESTR=0
      NTROUP=0
      NHYS=0
      NHYSF=0
      DLPRETIM = 0.D0
      TPRERHO = 0.D0
      NCOND = NINTTDEP + NWITHIN + ITDEPSTR
C
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
C
  100 IF (NSTOR.NE.1) THEN
        IF (IOMODE.NE.4) THEN
           DO 766 I=1,NRECMAX
             DO 766 J=1,INTE_ST1
                blockb%info(I,J)=0
  766      CONTINUE
       READ(4,END=199) NREC,LTAB,
     + ((blockb%info(i,j),i=1,nrecmax),j=1,inte_st1),
     + ((blockb%idata(i,j),i=1,nrecmax),j=1,mxef_used),
     +	((blockb%xdata(i,j),i=1,nrecmax),j=1,mxef_used)
c       ELSE
c IOMODE = 4 <==> compressed
c           CALL f77cread(idfile,nrec,ltab,krec,ierr)
c          IF (ierr.EQ.0) GOTO 199
        ENDIF
      ENDIF
       if (sinteg) then
C
C  IF KEYWORD 'WITHIN' WAS USED WITH 'INTEGRATE_OUT', THIS PART
C  LOOKS AT THE TABLE OF RECORDS AND DETERMINES THE ORDER SUITABLE
C  FOR THE INTEGRATION: eg: year-season WITHIN herd. THIS ORDER IS
C  STORED IN blockb%info(*,KCOLWITH) AND blockb%info(*,KCOLINT) IS UPDATED
C  SO blockb%info(*,KCOLINT) CORRESPONDING
C  TO DIFFERENT 'herds' ARE DIFFERENT. IT IS ASSUMED THAT THERE ARE
C  LESS THAN MAXYS 'year-seasons' per 'herd'.
      IF (NWITHIN.NE.0) THEN
        IF (blockb%info(1,KCOLINT).GT.MAXYS) GOTO 909
        NH = MAXYS
        IDHERD = blockb%info(1,KCOLWITH)
        LISTR(1) = IDHERD
        JJ = blockb%info(1,KCOLINT)
        KFIRST(JJ) = 1
        KLAST=0
        KLAST(JJ) = 1
        NLISTYS= 1
        LISTYS(1)= JJ
        blockb%info(1,KCOLINT)= NH +  JJ
        DO 900 I=2, NREC
             IF (blockb%info(I,KCOLWITH).NE.IDHERD) THEN
              DO 910 I1 = 1,NLISTYS-1
                 JJ = LISTYS(I1)
                 KK = LISTYS(I1+1)
                 blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
                 KFIRST(KK) = 0
                 KLAST(JJ) = 0
  910         CONTINUE
              NH = NH + MAXYS
              IDHERD = blockb%info(I,KCOLWITH)
              LISTR(NH/MAXYS)=IDHERD
              KK = LISTYS(NLISTYS)
              blockb%info(KLAST(KK),KCOLWITH)= I
              KLAST(KK) = 0
              NLISTYS= 0
           ENDIF
           JJ = blockb%info(I,KCOLINT)
           blockb%info(I,KCOLINT)= NH + JJ
           K = KLAST(JJ)
           IF (K.GT.0) THEN
             blockb%info(K,KCOLWITH) = I
           ELSE
              NLISTYS= NLISTYS + 1
              LISTYS(NLISTYS)= JJ
              KFIRST(JJ)= I
           ENDIF
           KLAST(JJ)= I
 900    CONTINUE
        DO 930 I1 = 1,NLISTYS-1
          JJ = LISTYS(I1)
          KK = LISTYS(I1+1)
          blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
          KLAST(JJ) = 0
  930   CONTINUE
        KK = LISTYS(NLISTYS)
        blockb%info(KLAST(KK),KCOLWITH)= 0
        KLAST(KK) = 0
      ENDIF
C
      IDHYS = 1
 909  I=1
      DO 190 I1=1,NREC+1
        I2=I2+1
        IF (NWITHIN.EQ.0) THEN
          I=I1
        ELSE IF (I1.NE.1) THEN
          I = blockb%info(I,KCOLWITH)
        ENDIF
        IF (I1.LE.NREC) THEN
            KANI=blockb%info(I,KCOLNID)
            IVALQ = blockb%info(I,KCOLINT)
        ENDIF
C
        IF ((IQ.NE.0.AND.IVALQ.NE.IQ).OR.(I1.EQ.NREC+1)) THEN
C COMPUTE APPROXIMATE SOLUTIONS AND STE
         W = DBLE(NHYSF)+GAMVAR
         HYS= W/(CUMRISK+GAMVAR)
         HYSTD=DSQRT(1.D0/W)
         HYS=LOG(HYS)
         SOLHYS(IDHYS)=HYS
C PRINT SOLUTIONS
         IF (NWITHIN.EQ.0) THEN
           J= blockb%info(I-1,KCOLINT)
           IF (KK1.EQ.1) THEN
             WRITE(15,9045) IOLDCODE(J,1), 
     +               HYS,HYSTD,NHYS,NHYSF,CUMRISK
 9045         FORMAT(1X,I8,17X,F10.4,1X,F8.4,2I8,2X,G12.5)
           ELSE IF (KK1.EQ.2) THEN
             WRITE(15,9046) IOLDCODE(J,1),IOLDCODE(J,2), 
     +               HYS,HYSTD,NHYS,NHYSF,CUMRISK
 9046    FORMAT(1X,I7,' *',I7,9X,F10.4,1X,F8.4,2I8,2X,G12.5)
           ELSE 
             WRITE(15,9047) IOLDCODE(J,1),IOLDCODE(J,2),
     +       IOLDCODE(J,3),HYS,HYSTD,NHYS,NHYSF,CUMRISK
 9047    FORMAT(1X,I7,' *',I6,' *',I6,1X,F10.4,1X,F8.4,
     +          2I8,2X,G12.5)
           ENDIF
         ELSE
           IF (KK1.EQ.1) THEN
             WRITE(15,9050) IOLDCODE(MOD(JPREV,MAXYS),1), 
     +               IOLDCODE(LISTR(JPREV/MAXYS),4),
     +               HYS,HYSTD,NHYS,NHYSF,CUMRISK
 9050        FORMAT(1X,I7,' * ',I9,9X,F10.4,1X,F8.4,2I8,2X,G12.5)
           ELSE IF (KK1.GE.2) THEN
             WRITE(15,9052) (IOLDCODE(MOD(JPREV,MAXYS),KK),KK=1,2), 
     +               IOLDCODE(LISTR(JPREV/MAXYS),4),
     +               HYS,HYSTD,NHYS,NHYSF,CUMRISK
 9052        FORMAT(1X,I5,' *',I2,' *',I10,4X,F10.4,1X,F8.4,
     +            2I8,2X,G12.5)
           ENDIF
         ENDIF
         NTROUP = NTROUP + 1
         IDHYS = IDHYS+1
C
         IF (I1.EQ.NREC+1) GOTO 190
         CUMRISK=0.D0
         KANIPREV = 0
         NHYS = 0
         NHYSF = 0
        ENDIF
C
       JPREV = blockb%info(I,KCOLINT) 
       blockb%info(I,KCOLINT) = IDHYS

       ITIM =blockb%info(I,1)
       ICODE = blockb%info(I,2)
C
C
       IF (NSTRATA.GT.1) THEN                                    
          ISTR = blockb%info(I,KCOLSTR)
       ELSE
          ISTR=1
       ENDIF

       RHO = VALRHO(ISTR)
       IQ = IVALQ
C-----------------------------------------------------------------------
C     W1 = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C     FIRST, NCCOV CONTINUOUS COVARIATES, THEN NDCOV DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => W2 = EXP(W1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       W1 = 0.D0
       DO 25 J=1,NCCOV
           XCOV = blockb%xdata(I,J)
           W1 = W1 + BETA1(J) * XCOV
           IF (BETA1(J).LE.-999.D0) W1 = -999.9D0
   25  CONTINUE
       DO 30 J=NDCOV0,NDCOV1
           K = blockb%idata(I,J)
           IF (K.NE.0) W1 = W1 + BETA1(K)
   30  CONTINUE
       DO 31 J=1,NCOEF(0)
         JJ=NCOEF(J)
         K = blockb%idata(I,JJ)
         IF (K.NE.0) W1 = W1 + (XCOEF(JJ) - 1.D0) * BETA1(K)
   31  CONTINUE
       W1 = W1 + BETA1(NDIMB+ISTR)
C
C-----------------------------------------------------------------------
C   COMPUTE W2 = EXP(W1) AND W3 = W2 * (ITIM**RHO - IPRETIM**RHO)
C-----------------------------------------------------------------------
       W2 = 0.D0
C
       IF (W1.GT.-80.D0) W2 = DEXP(W1)
       TRHO = VECEXP(ITIM,ISTR)
      IF (ICODE.EQ.-2) THEN
         IPRETIM= ITIM
         TPRERHO = TRHO
         GOTO 190
      ENDIF
      IF (NCOND.NE.0) THEN
C
C BECAUSE THE ORDERING OF THE RECORDS DOES NOT PERMIT TO KEEP OLD
C VALUES OF TRHO, THEY HAVE TO BE RECALCULATED
C
       IF (NINTTDEP.NE.0.OR.ITDEPSTR.NE.0) THEN
          IPRETIM= blockb%info(I,KCOLPRE)
          IF (IPRETIM.EQ.0) THEN
              TPRERHO=0.D0
           ELSE
              TPRERHO=VECEXP(IPRETIM,ISTR)
           ENDIF
C <==> NWITHIN <> 0
        ELSE IF (NWITHIN.NE.0) THEN
          IF (I.EQ.1) THEN  
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).GE.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).LT.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO THE SAME ANIMAL
            IPRETIM= blockb%info(I-1,1)
            TPRERHO=VECEXP(IPRETIM,ISTR)
          ENDIF
C
         ENDIF
        ENDIF
        W3 = W2 * (TRHO - TPRERHO)
        CUMRISK=CUMRISK+W3
        IF (KANI.NE.KANIPREV) THEN
           NHYS = NHYS +1
           KANIPREV = KANI
        ENDIF
        IF (ICODE.EQ.1) NHYSF = NHYSF + 1
c
  189  IF (NCOND.EQ.0) THEN
         IF (ICODE.GE.0) THEN
           IPRETIM = 0
           TPRERHO = 0.D0
         ELSE
           IPRETIM = ITIM
           TPRERHO = TRHO
         ENDIF
       ENDIF
c
  190 CONTINUE
       endif
C========================================================
C START AGAIN FOR ANIMAL SOLUTIONS
C WORKS ONLY FOR INTEGRATE_OUT ... NWITHIN...
C========================================================
C
      if (modsir.or.modani) then
        KANIPREV=0
      DO 290 I=1,NREC+1
        IF (I.LE.NREC) KANI= blockb%info(I,KCOLNID)
C
C IF NEW ANIMAL, COMPUTE AND PRINT SOLUTION FOR PREVIOUS ANIMAL
C
        IF ((KANI.NE.KANIPREV.AND.KANIPREV.NE.0.AND.I.NE.1)
     +         .OR.(I.EQ.NREC+1)) THEN
          R = CUMRISK2
C
          if (modani) then
C added on October 18 2004: case where pseudo-records are computed directly from 
c an animal model (no need to compute approximate animal solutions).
             GA= BETA1(IP) 
             EGA=DEXP(GA)
             POIDS=  MAX(1.D-6,(R / EGA))
             OBS2 = DELT/MAX(1.D-6,R)+ GA - 1.D0 
             WRITE(16,47) KANIPREV,ISEX,
     +           R,OBS2,NINT(DELT),ITIM,GA
c    +           R,OBS2,NINT(DELT),IPRETIM,GA
 47          FORMAT(1X,I9,I2,2(1X,G11.5),I2,I5,1(1X,G11.5))
          else
           IF (IP.EQ.0) THEN
             SP2=0.d0
             IF (IGP.EQ.0) THEN
                B = SIGM1
                SP = 0.D0
             ELSE
                B = SIGM1 * DM1(6)
                SP = BETA1(IGP)
             ENDIF
            ELSE
             SP2 = BETA1(IP) 
             IF (IGP.EQ.0) THEN
               B = SIGM1 * DM1(5)
               SP = BETA1(IP)
             ELSE
               B = SIGM1 * DM1(7)
               SP = BETA1(IP) + 0.5D0* BETA1(IGP)
             ENDIF
           ENDIF
            
           IT = 0
           PHI_OLD=(DELT - R)/(B+R)
 15        EPHI = DEXP(PHI_OLD)
           F = R * EPHI + B * PHI_OLD - DELT
           FPRIM = R * EPHI + B
           VAR = F/FPRIM
           PHI_NEW = PHI_OLD - VAR
           IF (DABS(VAR).GT.1.D-6 .AND. IT.LT.20) THEN
            PHI_OLD = PHI_NEW
            IT = IT +1
            GOTO 15
           ELSE
            IF (IT.GE.20) WRITE(6,*) 'warning: 20 iterations for',
     +         KANIPREV
             GA= SP + PHI_NEW
             EGA=DEXP(GA)
             POIDS=  MAX(1.D-6,(R / EGA))
c            OBS = DELT/POIDS + GA - EGA
             OBS = DELT/MAX(1.D-6,R)+ SP2 - 1.D0 
             OBS2 = DELT/MAX(1.D-6,R)+ GA - 1.D0 
             IF (IP.GT.0) THEN
               IP = IRANK(IP -ILIM)
             ELSE IF (IP.LT.0) THEN
              IP = IRANK(ILIM-IP)
             ELSE 
              IP = 0
             ENDIF 
             IF (IGP.GT.0) THEN
              IGP = IRANK(IGP -ILIM)
             ELSE IF (IGP.LT.0) THEN
              IGP = IRANK(ILIM-IGP)
             ELSE 
              IGP = 0
             ENDIF 
             WRITE(16,46) KANIPREV,ISEX,IP,IGP,
     +           R,OBS2,NINT(DELT),ITIM,GA,PHI_NEW,OBS
c    +           R,OBS2,NINT(DELT),IPRETIM,GA,PHI_NEW,OBS
 46          FORMAT(1X,I9,I2,I9,I9,2(1X,G11.5),I2,I5,3(1X,G11.5))
            ENDIF
          ENDIF

C
C RE-INITIALIZE
C
          CUMRISK2=0.D0
          if (i.eq.nrec+1) goto 290
C
          IP=blockb%idata(I,JP)
          IF (JGP.NE.0) IGP = blockb%idata(I,JGP)
        ELSE IF (KANIPREV.EQ.0) THEN
          CUMRISK2=0.D0
          IP=blockb%idata(I,JP)
          IF (JGP.NE.0) IGP = blockb%idata(I,JGP)
        ENDIF
C
        IF (I.EQ.NREC+1) GOTO 290
        IQ = blockb%info(I,KCOLINT) 
C
C       IF (NCOND.NE.0.AND.ICODE.EQ.-2) GOTO 290
C
       KANIPREV = KANI
       ITIM =blockb%info(I,1)
       ICODE = blockb%info(I,2)
       IF (NSTRATA.GT.1) THEN                                     
          ISTR = blockb%info(I,KCOLSTR)
       ELSE
          ISTR=1
       ENDIF
C
       RHO = VALRHO(ISTR)
C-----------------------------------------------------------------------
C     W1 = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C     FIRST, NCCOV CONTINUOUS COVARIATES, THEN NDCOV DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => W2 = EXP(W1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       W1 = 0.D0
       DO 125 J=1,NCCOV
           XCOV = blockb%xdata(I,J)
           W1 = W1 + BETA1(J) * XCOV
           IF (BETA1(J).LE.-999.D0) W1 = -999.9D0
  125  CONTINUE
       DO 130 J=NDCOV0,NDCOV1
           K = blockb%idata(I,J)
           IF (K.NE.0) W1 = W1 + BETA1(K)
  130  CONTINUE
       DO 131 J=1,NCOEF(0)
          JJ=NCOEF(J)
           K = blockb%idata(I,JJ)
           IF (K.NE.0) W1 = W1 + (XCOEF(JJ) - 1.D0) * BETA1(K)
  131  CONTINUE
       IF (INTEGAM.NE.0) W1 = W1 + SOLHYS(IQ)		
       W1 = W1 + BETA1(NDIMB+ISTR)
C
C-----------------------------------------------------------------------
C   COMPUTE W2 = EXP(W1) AND W3 = W2 * (ITIM**RHO - IPRETIM**RHO)
C-----------------------------------------------------------------------
       W2 = 0.D0
       IF (W1.GT.-80.D0) W2 = DEXP(W1)
       TRHO = VECEXP(ITIM,ISTR)
      IF (ICODE.EQ.-2) THEN
         IPRETIM= ITIM
         TPRERHO = TRHO
         GOTO 290
      ENDIF
      IF (NCOND.NE.0) THEN
C
C BECAUSE THE ORDERING OF THE RECORDS DOES NOT PERMIT TO KEEP OLD
C VALUES OF TRHO, THEY HAVE TO BE RECALCULATED
C
       IF (NINTTDEP.NE.0.OR.ITDEPSTR.NE.0) THEN
          IPRETIM= blockb%info(I,KCOLPRE)
          IF (IPRETIM.EQ.0) THEN
              TPRERHO=0.D0
           ELSE
              TPRERHO=VECEXP(IPRETIM,ISTR)
           ENDIF
C <==> NWITHIN <> 0
        ELSE IF (NWITHIN.NE.0) THEN
          IF (I.EQ.1) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).GE.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).LT.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO THE SAME ANIMAL
            IPRETIM= blockb%info(I-1,1)
            TPRERHO=VECEXP(IPRETIM,ISTR)
          ENDIF
C
         ENDIF
        ENDIF
        W3 = W2 * (TRHO - TPRERHO)
        CUMRISK2=CUMRISK2+W3
        IF (ICODE.EQ.1) THEN  
          DELT = 1.D0
        ELSE
          DELT = 0.D0
        ENDIF
c
  289  IF (NCOND.EQ.0) THEN
         IF (ICODE.GE.0) THEN
           IPRETIM = 0
           TPRERHO = 0.D0
         ELSE
           IPRETIM = ITIM
           TPRERHO = TRHO
         ENDIF
       ENDIF
c
  290 CONTINUE
      endif
C
C END OF LOOP FOR RECORDS 1...NREC
C
      IF (NSTOR.NE.1) GOTO 100
  199 IF (NSTOR.NE.1) THEN
         IF (IOMODE.NE.4) THEN
           CLOSE(4)
c        ELSE
c          call f77close(idfile)
         ENDIF
      ENDIF
      if (modsir) then
        WRITE(6,9100) FILE(11)
        WRITE(12,9100) FILE(11)
 9100 FORMAT(/1X,' EACH LINE OF FILE ',A15,' CONTAINS:',/1X,
     +' ID  SEX SIRE MGS WEIGHT OBS CODE TIME SOLUTION PHI')
        CLOSE(16)
      else if (modani) then
        WRITE(6,9101) FILE(11)
        WRITE(12,9101) FILE(11)
 9101 FORMAT(/1X,' EACH LINE OF FILE ',A15,' CONTAINS:',/1X,
     +' ID  SEX WEIGHT OBS CODE TIME SOLUTION ')
        CLOSE(16)
      endif
C
      CLOSE(15)

      deallocate(listr,solhys,temp)
      deallocate(kfirst,klast,listys)
  
      RETURN
C***********************************************************************
      END
