package at.boku.survivalkit.skonstructor.form;

import java.awt.BorderLayout;

import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import java.awt.Font;

public class AboutFrame extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7232173164303113116L;
	private JPanel contentPane;

	

	/**
	 * Create the frame.
	 */
	public AboutFrame() {
		this.setTitle("SKonstructor");
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout(0, 0));
		
		JDesktopPane desktopPane = new JDesktopPane();
		desktopPane.setBackground(UIManager.getColor("Button.background"));
		panel.add(desktopPane, BorderLayout.CENTER);
		
		JLabel label = new JLabel("SKonstructor - Parameter file constructor for the Survival Kit");
		label.setFont(new Font("Tahoma", Font.BOLD, 13));
		label.setBounds(10, 23, 412, 14);
		desktopPane.add(label);
		
		JLabel label_1 = new JLabel("Authors:");
		label_1.setFont(new Font("Tahoma", Font.PLAIN, 13));
		label_1.setBounds(10, 54, 56, 14);
		desktopPane.add(label_1);
		
		JLabel label_2 = new JLabel("Dr. Gbor Mszros & Ing. Csaba Mszros");
		label_2.setBounds(93, 55, 270, 14);
		desktopPane.add(label_2);
		
		JLabel label_3 = new JLabel("University of Natural Resources and Life Sciences");
		label_3.setBounds(93, 103, 313, 14);
		desktopPane.add(label_3);
		
		JLabel label_4 = new JLabel("Division of Livestock Sciences");
		label_4.setBounds(93, 123, 313, 14);
		desktopPane.add(label_4);
		
		JLabel label_5 = new JLabel("Gregor-Mendel-Strae 33");
		label_5.setBounds(93, 143, 324, 14);
		desktopPane.add(label_5);
		
		JLabel label_6 = new JLabel("A-1180 Vienna, Austria");
		label_6.setBounds(93, 163, 270, 14);
		desktopPane.add(label_6);
		
		JLabel label_7 = new JLabel("Tel. (office): +43 1 47654 3259");
		label_7.setBounds(93, 200, 282, 14);
		desktopPane.add(label_7);
		
		JLabel label_8 = new JLabel("mail: gabor.meszaros@boku.ac.at");
		label_8.setBounds(93, 220, 282, 14);
		desktopPane.add(label_8);
		
		JLabel label_9 = new JLabel("Contact:");
		label_9.setFont(new Font("Tahoma", Font.PLAIN, 13));
		label_9.setBounds(10, 103, 56, 14);
		desktopPane.add(label_9);
		
		JLabel label_10 = new JLabel("Corresponding");
		label_10.setBounds(10, 70, 245, 14);
		desktopPane.add(label_10);
		
		JLabel label_11 = new JLabel("author:");
		label_11.setBounds(10, 85, 46, 14);
		desktopPane.add(label_11);
		
		JLabel label_12 = new JLabel("Dr. Gbor Mszros");
		label_12.setBounds(93, 79, 162, 14);
		desktopPane.add(label_12);
		contentPane.add(panel, BorderLayout.CENTER);
	}
}
