package at.boku.survivalkit.skonstructor.panels;

import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JDesktopPane;
import javax.swing.UIManager;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JButton;

import at.boku.survivalkit.skonstructor.form.ApplicationForm;
import at.boku.survivalkit.skonstructor.form.support.DialogUtils;
import at.boku.survivalkit.skonstructor.form.support.Utils;

public class Prepare2Panel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -6331603345654291651L;
	private JTextField filesTextField1;
	private JTextField filesTextField2;
	private JTextField filesTextField3;
	private JTextField filesTextField4;
	private JTextField inputTextField11;
	private JTextField inputTextField12;
	private JTextField inputTextField13;
	private JTextField inputTextField21;
	private JTextField inputTextField22;
	private JTextField inputTextField23;
	private JTextField inputTextField31;
	private JTextField inputTextField32;
	private JTextField inputTextField33;
	private JTextField inputTextField41;
	private JTextField inputTextField42;
	private JTextField inputTextField43;
	private JComboBox inputComboBox11;
	private JComboBox inputComboBox12;
	private JComboBox inputComboBox13;
	private JComboBox inputComboBox21;
	private JComboBox inputComboBox22;
	private JComboBox inputComboBox23;
	private JComboBox inputComboBox31;
	private JComboBox inputComboBox32;
	private JComboBox inputComboBox33;
	private JComboBox inputComboBox41;
	private JComboBox inputComboBox42;
	private JComboBox inputComboBox43;
	private JTextField timeTextField1;
	private JTextField timeTextField2;
	private JTextField timeTextField3;
	private JTextField idrecTextField;
	private JCheckBox idrecCheckBox;
	private JCheckBox classCheckBox;
	private JTextField classTextField11;
	private JTextField classTextField12;
	private JTextField classTextField13;
	private JTextField classTextField14;
	private JTextField classTextField21;
	private JTextField classTextField22;
	private JTextField classTextField23;
	private JTextField classTextField24;
	private JTextField classTextField31;
	private JTextField classTextField32;
	private JTextField classTextField33;
	private JTextField classTextField34;
	private JCheckBox timedepCheckBox;
	private JTextField timedepTextField11;
	private JComboBox timedepComboBox11;
	private JTextField timedepTextField12;
	private JComboBox timedepComboBox12;
	private JTextField timedepTextField13;
	private JComboBox timedepComboBox13;
	private JTextField timedepTextField21;
	private JComboBox timedepComboBox21;
	private JTextField timedepTextField22;
	private JComboBox timedepComboBox22;
	private JTextField timedepTextField23;
	private JComboBox timedepComboBox23;
	private JTextField timedepTextField31;
	private JComboBox timedepComboBox31;
	private JTextField timedepTextField32;
	private JComboBox timedepComboBox32;
	private JTextField timedepTextField33;
	private JComboBox timedepComboBox33;
	private JTextField outputTextField11;
	private JTextField outputTextField12;
	private JTextField outputTextField13;
	private JTextField outputTextField14;
	private JTextField outputTextField21;
	private JTextField outputTextField22;
	private JTextField outputTextField23;
	private JTextField outputTextField24;
	private JTextField outputTextField31;
	private JTextField outputTextField32;
	private JTextField outputTextField33;
	private JTextField outputTextField34;
	private JTextField censCodeTextField1;
	private JTextField censCodeTextField2;

	/**
	 * Create the panel.
	 */
	public Prepare2Panel(final ApplicationForm appForm) {
		setLayout(new BorderLayout(0, 0));

		JDesktopPane desktopPane = new JDesktopPane();
		desktopPane.setBackground(UIManager.getColor("Button.background"));
		add(desktopPane, BorderLayout.CENTER);

		JLabel filesLabel = new JLabel("FILES");
		filesLabel.setBounds(29, 37, 46, 14);
		desktopPane.add(filesLabel);

		filesTextField1 = new JTextField();
		filesTextField1.setBounds(108, 35, 91, 19);
		desktopPane.add(filesTextField1);
		filesTextField1.setColumns(10);

		filesTextField2 = new JTextField();
		filesTextField2.setBounds(205, 35, 91, 19);
		desktopPane.add(filesTextField2);
		filesTextField2.setColumns(10);

		filesTextField3 = new JTextField();
		filesTextField3.setBounds(302, 35, 91, 19);
		desktopPane.add(filesTextField3);
		filesTextField3.setColumns(10);

		filesTextField4 = new JTextField();
		filesTextField4.setBounds(399, 35, 91, 19);
		desktopPane.add(filesTextField4);
		filesTextField4.setColumns(10);

		JLabel inputLabel = new JLabel("INPUT");
		inputLabel.setBounds(29, 62, 46, 14);
		desktopPane.add(inputLabel);

		inputTextField11 = new JTextField();
		inputTextField11.setBounds(108, 60, 91, 19);
		desktopPane.add(inputTextField11);
		inputTextField11.setColumns(10);

		inputComboBox11 = new JComboBox();
		inputComboBox11.setBounds(205, 56, 46, 22);
		inputComboBox11.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox11);

		inputTextField12 = new JTextField();
		inputTextField12.setBounds(257, 58, 91, 19);
		desktopPane.add(inputTextField12);
		inputTextField12.setColumns(10);

		inputComboBox12 = new JComboBox();
		inputComboBox12.setBounds(354, 56, 46, 22);
		inputComboBox12.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox12);

		inputTextField13 = new JTextField();
		inputTextField13.setBounds(406, 58, 91, 19);
		desktopPane.add(inputTextField13);
		inputTextField13.setColumns(10);

		inputComboBox13 = new JComboBox();
		inputComboBox13.setBounds(503, 56, 46, 22);
		inputComboBox13.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox13);

		inputTextField21 = new JTextField();
		inputTextField21.setColumns(10);
		inputTextField21.setBounds(108, 87, 91, 19);
		desktopPane.add(inputTextField21);

		inputComboBox21 = new JComboBox();
		inputComboBox21.setBounds(205, 83, 46, 22);
		inputComboBox21.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox21);

		inputTextField22 = new JTextField();
		inputTextField22.setColumns(10);
		inputTextField22.setBounds(257, 85, 91, 19);
		desktopPane.add(inputTextField22);

		inputComboBox22 = new JComboBox();
		inputComboBox22.setBounds(354, 82, 46, 22);
		inputComboBox22.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox22);

		inputTextField23 = new JTextField();
		inputTextField23.setColumns(10);
		inputTextField23.setBounds(406, 85, 91, 19);
		desktopPane.add(inputTextField23);

		inputComboBox23 = new JComboBox();
		inputComboBox23.setBounds(503, 83, 46, 22);
		inputComboBox23.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox23);

		inputTextField31 = new JTextField();
		inputTextField31.setColumns(10);
		inputTextField31.setBounds(108, 114, 91, 19);
		desktopPane.add(inputTextField31);

		inputComboBox31 = new JComboBox();
		inputComboBox31.setBounds(205, 110, 46, 22);
		inputComboBox31.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox31);

		inputTextField32 = new JTextField();
		inputTextField32.setColumns(10);
		inputTextField32.setBounds(257, 112, 91, 19);
		desktopPane.add(inputTextField32);

		inputComboBox32 = new JComboBox();
		inputComboBox32.setBounds(354, 109, 46, 22);
		inputComboBox32.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox32);

		inputTextField33 = new JTextField();
		inputTextField33.setColumns(10);
		inputTextField33.setBounds(406, 112, 91, 19);
		desktopPane.add(inputTextField33);

		inputComboBox33 = new JComboBox();
		inputComboBox33.setBounds(503, 110, 46, 22);
		inputComboBox33.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox33);

		inputTextField41 = new JTextField();
		inputTextField41.setColumns(10);
		inputTextField41.setBounds(108, 141, 91, 19);
		desktopPane.add(inputTextField41);

		inputComboBox41 = new JComboBox();
		inputComboBox41.setBounds(205, 138, 46, 22);
		inputComboBox41.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox41);

		inputTextField42 = new JTextField();
		inputTextField42.setColumns(10);
		inputTextField42.setBounds(257, 139, 91, 19);
		desktopPane.add(inputTextField42);

		inputComboBox42 = new JComboBox();
		inputComboBox42.setBounds(354, 136, 46, 22);
		inputComboBox42.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox42);

		inputTextField43 = new JTextField();
		inputTextField43.setColumns(10);
		inputTextField43.setBounds(406, 139, 91, 19);
		desktopPane.add(inputTextField43);

		inputComboBox43 = new JComboBox();
		inputComboBox43.setBounds(503, 137, 46, 22);
		inputComboBox43.setModel(new DefaultComboBoxModel(new String[] { "I4",
				"R4", "D6", "D8" }));
		desktopPane.add(inputComboBox43);

		JLabel timeLabel = new JLabel("TIME");
		timeLabel.setBounds(29, 169, 46, 14);
		desktopPane.add(timeLabel);

		timeTextField1 = new JTextField();
		timeTextField1.setBounds(108, 166, 91, 19);
		desktopPane.add(timeTextField1);
		timeTextField1.setColumns(10);

		timeTextField2 = new JTextField();
		timeTextField2.setBounds(205, 167, 91, 19);
		desktopPane.add(timeTextField2);
		timeTextField2.setColumns(10);

		timeTextField3 = new JTextField();
		timeTextField3.setBounds(302, 166, 91, 19);
		desktopPane.add(timeTextField3);
		timeTextField3.setColumns(10);

		idrecCheckBox = new JCheckBox("idrec");
		idrecCheckBox.setBounds(29, 214, 56, 23);
		desktopPane.add(idrecCheckBox);

		idrecTextField = new JTextField();
		idrecTextField.setBounds(108, 216, 91, 19);
		desktopPane.add(idrecTextField);
		idrecTextField.setColumns(10);

		classCheckBox = new JCheckBox("class");
		classCheckBox.setBounds(29, 243, 56, 23);
		desktopPane.add(classCheckBox);

		classTextField11 = new JTextField();
		classTextField11.setColumns(10);
		classTextField11.setBounds(108, 241, 91, 19);
		desktopPane.add(classTextField11);

		classTextField12 = new JTextField();
		classTextField12.setColumns(10);
		classTextField12.setBounds(205, 241, 91, 19);
		desktopPane.add(classTextField12);

		classTextField13 = new JTextField();
		classTextField13.setColumns(10);
		classTextField13.setBounds(302, 241, 91, 19);
		desktopPane.add(classTextField13);

		classTextField14 = new JTextField();
		classTextField14.setColumns(10);
		classTextField14.setBounds(399, 241, 91, 19);
		desktopPane.add(classTextField14);

		classTextField21 = new JTextField();
		classTextField21.setColumns(10);
		classTextField21.setBounds(108, 266, 91, 19);
		desktopPane.add(classTextField21);

		classTextField22 = new JTextField();
		classTextField22.setColumns(10);
		classTextField22.setBounds(205, 266, 91, 19);
		desktopPane.add(classTextField22);

		classTextField23 = new JTextField();
		classTextField23.setColumns(10);
		classTextField23.setBounds(302, 266, 91, 19);
		desktopPane.add(classTextField23);

		classTextField24 = new JTextField();
		classTextField24.setColumns(10);
		classTextField24.setBounds(399, 266, 91, 19);
		desktopPane.add(classTextField24);

		classTextField31 = new JTextField();
		classTextField31.setColumns(10);
		classTextField31.setBounds(108, 291, 91, 19);
		desktopPane.add(classTextField31);

		classTextField32 = new JTextField();
		classTextField32.setColumns(10);
		classTextField32.setBounds(205, 291, 91, 19);
		desktopPane.add(classTextField32);

		classTextField33 = new JTextField();
		classTextField33.setColumns(10);
		classTextField33.setBounds(302, 291, 91, 19);
		desktopPane.add(classTextField33);

		classTextField34 = new JTextField();
		classTextField34.setColumns(10);
		classTextField34.setBounds(399, 291, 91, 19);
		desktopPane.add(classTextField34);

		timedepCheckBox = new JCheckBox("timedep");
		timedepCheckBox.setBounds(29, 316, 73, 23);
		desktopPane.add(timedepCheckBox);

		timedepTextField11 = new JTextField();
		timedepTextField11.setColumns(10);
		timedepTextField11.setBounds(108, 318, 91, 19);
		desktopPane.add(timedepTextField11);

		timedepComboBox11 = new JComboBox();
		timedepComboBox11.setBounds(205, 315, 46, 22);
		timedepComboBox11.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox11);

		timedepTextField12 = new JTextField();
		timedepTextField12.setColumns(10);
		timedepTextField12.setBounds(257, 318, 91, 19);
		desktopPane.add(timedepTextField12);

		timedepComboBox12 = new JComboBox();
		timedepComboBox12.setBounds(354, 315, 46, 22);
		timedepComboBox12.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox12);

		timedepTextField13 = new JTextField();
		timedepTextField13.setColumns(10);
		timedepTextField13.setBounds(406, 317, 91, 19);
		desktopPane.add(timedepTextField13);

		timedepComboBox13 = new JComboBox();
		timedepComboBox13.setBounds(503, 315, 46, 22);
		timedepComboBox13.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox13);

		timedepTextField21 = new JTextField();
		timedepTextField21.setColumns(10);
		timedepTextField21.setBounds(108, 347, 91, 19);
		desktopPane.add(timedepTextField21);

		timedepComboBox21 = new JComboBox();
		timedepComboBox21.setBounds(205, 344, 46, 22);
		timedepComboBox21.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox21);

		timedepTextField22 = new JTextField();
		timedepTextField22.setColumns(10);
		timedepTextField22.setBounds(257, 346, 91, 19);
		desktopPane.add(timedepTextField22);

		timedepComboBox22 = new JComboBox();
		timedepComboBox22.setBounds(354, 344, 46, 22);
		timedepComboBox22.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox22);

		timedepTextField23 = new JTextField();
		timedepTextField23.setColumns(10);
		timedepTextField23.setBounds(406, 346, 91, 19);
		desktopPane.add(timedepTextField23);

		timedepComboBox23 = new JComboBox();
		timedepComboBox23.setBounds(503, 344, 46, 22);
		timedepComboBox23.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox23);

		timedepTextField31 = new JTextField();
		timedepTextField31.setColumns(10);
		timedepTextField31.setBounds(108, 374, 91, 19);
		desktopPane.add(timedepTextField31);

		timedepComboBox31 = new JComboBox();
		timedepComboBox31.setBounds(205, 371, 46, 22);
		timedepComboBox31.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox31);

		timedepTextField32 = new JTextField();
		timedepTextField32.setColumns(10);
		timedepTextField32.setBounds(257, 373, 91, 19);
		desktopPane.add(timedepTextField32);

		timedepComboBox32 = new JComboBox();
		timedepComboBox32.setBounds(354, 371, 46, 22);
		timedepComboBox32.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox32);

		timedepTextField33 = new JTextField();
		timedepTextField33.setColumns(10);
		timedepTextField33.setBounds(406, 373, 91, 19);
		desktopPane.add(timedepTextField33);

		timedepComboBox33 = new JComboBox();
		timedepComboBox33.setBounds(503, 371, 46, 22);
		timedepComboBox33.setModel(new DefaultComboBoxModel(new String[] {
				"I4", "R4", "D6", "D8" }));
		desktopPane.add(timedepComboBox33);

		JLabel outputLabel = new JLabel("OUTPUT");
		outputLabel.setBounds(29, 401, 46, 14);
		desktopPane.add(outputLabel);

		outputTextField11 = new JTextField();
		outputTextField11.setColumns(10);
		outputTextField11.setBounds(108, 399, 91, 19);
		desktopPane.add(outputTextField11);

		outputTextField12 = new JTextField();
		outputTextField12.setColumns(10);
		outputTextField12.setBounds(205, 399, 91, 19);
		desktopPane.add(outputTextField12);

		outputTextField13 = new JTextField();
		outputTextField13.setColumns(10);
		outputTextField13.setBounds(302, 399, 91, 19);
		desktopPane.add(outputTextField13);

		outputTextField14 = new JTextField();
		outputTextField14.setColumns(10);
		outputTextField14.setBounds(399, 399, 91, 19);
		desktopPane.add(outputTextField14);

		outputTextField21 = new JTextField();
		outputTextField21.setColumns(10);
		outputTextField21.setBounds(108, 424, 91, 19);
		desktopPane.add(outputTextField21);

		outputTextField22 = new JTextField();
		outputTextField22.setColumns(10);
		outputTextField22.setBounds(205, 424, 91, 19);
		desktopPane.add(outputTextField22);

		outputTextField23 = new JTextField();
		outputTextField23.setColumns(10);
		outputTextField23.setBounds(302, 424, 91, 19);
		desktopPane.add(outputTextField23);

		outputTextField24 = new JTextField();
		outputTextField24.setColumns(10);
		outputTextField24.setBounds(399, 424, 91, 19);
		desktopPane.add(outputTextField24);

		outputTextField31 = new JTextField();
		outputTextField31.setColumns(10);
		outputTextField31.setBounds(108, 449, 91, 19);
		desktopPane.add(outputTextField31);

		outputTextField32 = new JTextField();
		outputTextField32.setColumns(10);
		outputTextField32.setBounds(205, 449, 91, 19);
		desktopPane.add(outputTextField32);

		outputTextField33 = new JTextField();
		outputTextField33.setColumns(10);
		outputTextField33.setBounds(302, 449, 91, 19);
		desktopPane.add(outputTextField33);

		outputTextField34 = new JTextField();
		outputTextField34.setColumns(10);
		outputTextField34.setBounds(399, 449, 91, 19);
		desktopPane.add(outputTextField34);

		JButton prepare2PanelNextButton = new JButton("Next");
		prepare2PanelNextButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (checkMandatoryInputs()) {
					appForm.getPrepareMainPanel().remove(
							appForm.getPrepare2Panel());
					appForm.getPrepareMainPanel().add(
							appForm.getPrepare3Panel(), BorderLayout.CENTER);
					appForm.getFrame().repaint();
				} else {
					DialogUtils.displayErrorMessageDialog(appForm
							.getPrepare2Panel(),
							"The CAPITALIZED inputs are mandatory!");
				}
			}
		});
		prepare2PanelNextButton.setBounds(501, 567, 89, 23);
		desktopPane.add(prepare2PanelNextButton);

		JButton prepare2PanelPrevButton = new JButton("Previous");
		prepare2PanelPrevButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				appForm.getPrepareMainPanel()
						.remove(appForm.getPrepare2Panel());
				appForm.getPrepareMainPanel().add(appForm.getPrepare1Panel(),
						BorderLayout.CENTER);
				appForm.getFrame().repaint();
			}
		});
		prepare2PanelPrevButton.setBounds(406, 567, 89, 23);
		desktopPane.add(prepare2PanelPrevButton);

		JLabel censcodeLabel = new JLabel("CENSCODE");
		censcodeLabel.setBounds(29, 194, 73, 14);
		desktopPane.add(censcodeLabel);

		censCodeTextField1 = new JTextField();
		censCodeTextField1.setBounds(108, 191, 91, 19);
		desktopPane.add(censCodeTextField1);
		censCodeTextField1.setColumns(10);

		censCodeTextField2 = new JTextField();
		censCodeTextField2.setBounds(205, 192, 91, 19);
		desktopPane.add(censCodeTextField2);
		censCodeTextField2.setColumns(10);

	}

	public Map<String, String> getAsMap() {
		Map<String, String> result = new LinkedHashMap<String, String>();
		result.put("FILES", getFilesValue());
		result.put("INPUT", getInputValue());
		result.put("TIME", getTimeValue());
		result.put("CENSCODE", getCensCodeValue());
		
		if (idrecCheckBox.isSelected()) {
			result.put(idrecCheckBox.getText(), idrecTextField.getText());
		}
		if (classCheckBox.isSelected()) {
			result.put(classCheckBox.getText(), getClassValue());
		}
		if (timedepCheckBox.isSelected()) {
			result.put(timedepCheckBox.getText(), getTimedepValue());
		}
		result.put("OUTPUT", getOutputValue());
		return result;
	}

	private String getCensCodeValue() {
		StringBuilder sb = new StringBuilder();
		if (Utils.isStringNotEmpty(censCodeTextField1.getText())) {
			sb.append(censCodeTextField1.getText());
		}
		if (Utils.isStringNotEmpty(censCodeTextField2.getText())) {
			sb.append(" " + censCodeTextField2.getText());
		}
		return sb.toString();
	}

	private String getTimeValue() {
		StringBuilder sb = new StringBuilder();
		if (Utils.isStringNotEmpty(timeTextField1.getText())) {
			sb.append(timeTextField1.getText());
		}
		if (Utils.isStringNotEmpty(timeTextField2.getText())) {
			sb.append(" " + timeTextField2.getText());
		}
		if (Utils.isStringNotEmpty(timeTextField3.getText())) {
			sb.append(" " + timeTextField3.getText());
		}
		return sb.toString();
	}

	private String getOutputValue() {
		StringBuilder sb = new StringBuilder();
		if (outputTextField11.getText() != null
				&& !outputTextField11.getText().equals("")) {
			sb.append(outputTextField11.getText());
		}
		if (outputTextField12.getText() != null
				&& !outputTextField12.getText().equals("")) {
			sb.append(" " + outputTextField12.getText());
		}
		if (outputTextField13.getText() != null
				&& !outputTextField13.getText().equals("")) {
			sb.append(" " + outputTextField13.getText());
		}
		if (outputTextField14.getText() != null
				&& !outputTextField14.getText().equals("")) {
			sb.append(" " + outputTextField14.getText());
		}
		if (outputTextField21.getText() != null
				&& !outputTextField21.getText().equals("")) {
			sb.append(" " + outputTextField21.getText());
		}
		if (outputTextField22.getText() != null
				&& !outputTextField22.getText().equals("")) {
			sb.append(" " + outputTextField22.getText());
		}
		if (outputTextField23.getText() != null
				&& !outputTextField23.getText().equals("")) {
			sb.append(" " + outputTextField23.getText());
		}
		if (outputTextField24.getText() != null
				&& !outputTextField24.getText().equals("")) {
			sb.append(" " + outputTextField24.getText());
		}
		if (outputTextField31.getText() != null
				&& !outputTextField31.getText().equals("")) {
			sb.append(" " + outputTextField31.getText());
		}
		if (outputTextField32.getText() != null
				&& !outputTextField32.getText().equals("")) {
			sb.append(" " + outputTextField32.getText());
		}
		if (outputTextField33.getText() != null
				&& !outputTextField33.getText().equals("")) {
			sb.append(" " + outputTextField33.getText());
		}
		if (outputTextField34.getText() != null
				&& !outputTextField34.getText().equals("")) {
			sb.append(" " + outputTextField34.getText());
		}
		return sb.toString();
	}

	private String getTimedepValue() {
		StringBuilder sb = new StringBuilder();
		if (timedepTextField11.getText() != null
				&& !timedepTextField11.getText().equals("")) {
			sb.append(timedepTextField11.getText() + " "
					+ timedepComboBox11.getSelectedItem());
		}
		if (timedepTextField12.getText() != null
				&& !timedepTextField12.getText().equals("")) {
			sb.append(" " + timedepTextField12.getText() + " "
					+ timedepComboBox12.getSelectedItem());
		}
		if (timedepTextField13.getText() != null
				&& !timedepTextField13.getText().equals("")) {
			sb.append(" " + timedepTextField13.getText() + " "
					+ timedepComboBox13.getSelectedItem());
		}
		if (timedepTextField21.getText() != null
				&& !timedepTextField21.getText().equals("")) {
			sb.append(" " + timedepTextField21.getText() + " "
					+ timedepComboBox21.getSelectedItem());
		}
		if (timedepTextField22.getText() != null
				&& !timedepTextField22.getText().equals("")) {
			sb.append(" " + timedepTextField22.getText() + " "
					+ timedepComboBox22.getSelectedItem());
		}
		if (timedepTextField23.getText() != null
				&& !timedepTextField23.getText().equals("")) {
			sb.append(" " + timedepTextField23.getText() + " "
					+ timedepComboBox23.getSelectedItem());
		}
		if (timedepTextField31.getText() != null
				&& !timedepTextField31.getText().equals("")) {
			sb.append(" " + timedepTextField31.getText() + " "
					+ timedepComboBox31.getSelectedItem());
		}
		if (timedepTextField32.getText() != null
				&& !timedepTextField32.getText().equals("")) {
			sb.append(" " + timedepTextField32.getText() + " "
					+ timedepComboBox32.getSelectedItem());
		}
		if (timedepTextField33.getText() != null
				&& !timedepTextField33.getText().equals("")) {
			sb.append(" " + timedepTextField33.getText() + " "
					+ timedepComboBox33.getSelectedItem());
		}
		return sb.toString();
	}

	private String getClassValue() {
		StringBuilder sb = new StringBuilder();
		if (classTextField11.getText() != null
				&& !classTextField11.getText().equals("")) {
			sb.append(classTextField11.getText());
		}
		if (classTextField12.getText() != null
				&& !classTextField12.getText().equals("")) {
			sb.append(" " + classTextField12.getText());
		}
		if (classTextField13.getText() != null
				&& !classTextField13.getText().equals("")) {
			sb.append(" " + classTextField13.getText());
		}
		if (classTextField14.getText() != null
				&& !classTextField14.getText().equals("")) {
			sb.append(" " + classTextField14.getText());
		}
		if (classTextField21.getText() != null
				&& !classTextField21.getText().equals("")) {
			sb.append(" " + classTextField21.getText());
		}
		if (classTextField22.getText() != null
				&& !classTextField22.getText().equals("")) {
			sb.append(" " + classTextField22.getText());
		}
		if (classTextField23.getText() != null
				&& !classTextField23.getText().equals("")) {
			sb.append(" " + classTextField23.getText());
		}
		if (classTextField24.getText() != null
				&& !classTextField24.getText().equals("")) {
			sb.append(" " + classTextField24.getText());
		}
		if (classTextField31.getText() != null
				&& !classTextField31.getText().equals("")) {
			sb.append(" " + classTextField31.getText());
		}
		if (classTextField32.getText() != null
				&& !classTextField32.getText().equals("")) {
			sb.append(" " + classTextField32.getText());
		}
		if (classTextField33.getText() != null
				&& !classTextField33.getText().equals("")) {
			sb.append(" " + classTextField33.getText());
		}
		if (classTextField34.getText() != null
				&& !classTextField34.getText().equals("")) {
			sb.append(" " + classTextField34.getText());
		}
		return sb.toString();
	}

	private String getInputValue() {
		StringBuilder sb = new StringBuilder();
		if (inputTextField11.getText() != null
				&& !inputTextField11.getText().equals("")) {
			sb.append(inputTextField11.getText() + " "
					+ inputComboBox11.getSelectedItem());
		}
		if (inputTextField12.getText() != null
				&& !inputTextField12.getText().equals("")) {
			sb.append(" " + inputTextField12.getText() + " "
					+ inputComboBox12.getSelectedItem());
		}
		if (inputTextField13.getText() != null
				&& !inputTextField13.getText().equals("")) {
			sb.append(" " + inputTextField13.getText() + " "
					+ inputComboBox13.getSelectedItem());
		}
		if (inputTextField21.getText() != null
				&& !inputTextField21.getText().equals("")) {
			sb.append(" " + inputTextField21.getText() + " "
					+ inputComboBox21.getSelectedItem());
		}
		if (inputTextField22.getText() != null
				&& !inputTextField22.getText().equals("")) {
			sb.append(" " + inputTextField22.getText() + " "
					+ inputComboBox22.getSelectedItem());
		}
		if (inputTextField23.getText() != null
				&& !inputTextField23.getText().equals("")) {
			sb.append(" " + inputTextField23.getText() + " "
					+ inputComboBox23.getSelectedItem());
		}
		if (inputTextField31.getText() != null
				&& !inputTextField31.getText().equals("")) {
			sb.append(" " + inputTextField31.getText() + " "
					+ inputComboBox31.getSelectedItem());
		}
		if (inputTextField32.getText() != null
				&& !inputTextField32.getText().equals("")) {
			sb.append(" " + inputTextField32.getText() + " "
					+ inputComboBox32.getSelectedItem());
		}
		if (inputTextField33.getText() != null
				&& !inputTextField33.getText().equals("")) {
			sb.append(" " + inputTextField33.getText() + " "
					+ inputComboBox33.getSelectedItem());
		}
		if (inputTextField41.getText() != null
				&& !inputTextField41.getText().equals("")) {
			sb.append(" " + inputTextField41.getText() + " "
					+ inputComboBox41.getSelectedItem());
		}
		if (inputTextField42.getText() != null
				&& !inputTextField42.getText().equals("")) {
			sb.append(" " + inputTextField42.getText() + " "
					+ inputComboBox42.getSelectedItem());
		}
		if (inputTextField43.getText() != null
				&& !inputTextField43.getText().equals("")) {
			sb.append(" " + inputTextField43.getText() + " "
					+ inputComboBox43.getSelectedItem());
		}
		return sb.toString();
	}

	private String getFilesValue() {
		StringBuilder sb = new StringBuilder();
		if (filesTextField1.getText() != null
				&& !filesTextField1.getText().equals("")) {
			sb.append(filesTextField1.getText());
		}
		if (filesTextField2.getText() != null
				&& !filesTextField2.getText().equals("")) {
			sb.append(" " + filesTextField2.getText());
		}
		if (filesTextField3.getText() != null
				&& !filesTextField3.getText().equals("")) {
			sb.append(" " + filesTextField3.getText());
		}
		if (filesTextField4.getText() != null
				&& !filesTextField4.getText().equals("")) {
			sb.append(" " + filesTextField4.getText());
		}
		return sb.toString();
	}

	private boolean checkMandatoryInputs() {
		boolean mandatoriesFilled = true;

		if (Utils.isStringEmpty(filesTextField1.getText())
				&& Utils.isStringEmpty(filesTextField2.getText())
				&& Utils.isStringEmpty(filesTextField3.getText())
				&& Utils.isStringEmpty(filesTextField4.getText())) {
			return false;
		}

		if (Utils.isStringEmpty(inputTextField11.getText())
				&& Utils.isStringEmpty(inputTextField12.getText())
				&& Utils.isStringEmpty(inputTextField13.getText())
				&& Utils.isStringEmpty(inputTextField21.getText())
				&& Utils.isStringEmpty(inputTextField22.getText())
				&& Utils.isStringEmpty(inputTextField23.getText())
				&& Utils.isStringEmpty(inputTextField31.getText())
				&& Utils.isStringEmpty(inputTextField32.getText())
				&& Utils.isStringEmpty(inputTextField33.getText())
				&& Utils.isStringEmpty(inputTextField41.getText())
				&& Utils.isStringEmpty(inputTextField42.getText())
				&& Utils.isStringEmpty(inputTextField43.getText())) {
			return false;
		}

		if (Utils.isStringEmpty(timeTextField1.getText())
				&& Utils.isStringEmpty(timeTextField2.getText())
				&& Utils.isStringEmpty(timeTextField3.getText())) {
			return false;
		}

		if (Utils.isStringEmpty(censCodeTextField1.getText())
				&& Utils.isStringEmpty(censCodeTextField2.getText())) {
			return false;
		}

		if (Utils.isStringEmpty(outputTextField11.getText())
				&& Utils.isStringEmpty(outputTextField12.getText())
				&& Utils.isStringEmpty(outputTextField13.getText())
				&& Utils.isStringEmpty(outputTextField14.getText())
				&& Utils.isStringEmpty(outputTextField21.getText())
				&& Utils.isStringEmpty(outputTextField22.getText())
				&& Utils.isStringEmpty(outputTextField23.getText())
				&& Utils.isStringEmpty(outputTextField24.getText())
				&& Utils.isStringEmpty(outputTextField31.getText())
				&& Utils.isStringEmpty(outputTextField32.getText())
				&& Utils.isStringEmpty(outputTextField33.getText())
				&& Utils.isStringEmpty(outputTextField34.getText())) {
			return false;
		}

		return mandatoriesFilled;
	}
}
