\name{GramChar}
\alias{GramChar}
\title{
GramChar
}
\description{
Function calculating values and plotting results for the Gram-Charlier approximation of the marginal posterior density.
}
\usage{
GramChar(mean, sd, skew, variable = "x", plot = TRUE, ...)
}
\arguments{
  \item{mean}{
The value for mean calculated using the MOMENTS statement of the Survival Kit.
}
  \item{sd}{
The value for standard deviation calculated using the MOMENTS statement of the Survival Kit.
}
  \item{skew}{
The value for skewness calculated using the MOMENTS statement of the Survival Kit.
}
  \item{variable}{
Name of the variable to be displayed on the plot
}
  \item{plot}{
If set to TRUE the plot will be created and displayed.
}
  \item{\dots}{
Additional parameters possible.
}
}
\author{
Gregor Gorjanc < gregor.gorjanc@bf.uni-lj.si >
}
