      SUBROUTINE RWBACKUP(ICODE,FILEBK)
C//////////////////////////////////////////////////////////////////////*
C  BACKUP        *                                    *  29 / 04 /1996 *
C//////////////////////////////////////////////////////////////////////*
c
      use parinclu2
c
      implicit none
      real*8,allocatable :: BETAPREV(:) !BETAPREV(NDIMAX)
c
      INTEGER I,II,J,JJ,K,KK,ICODE
      INTEGER NCOVMOD2
      INTEGER NDIM2,NDIMB2,NSTRATA2,JM,NEF
C
      REAL*8 X
      REAL*8 DIFF,SUM,NORM,CHMAX
C
      CHARACTER*8 LAB,DUMMY
      CHARACTER*100 FILEBK
C
      allocate(BETAPREV(NDIMAX))
C
      OPEN(14,FILE=FILEBK,FORM='FORMATTED')
c***********************************************************************
C
C IF ICODE = 1 , WRITE SOLUTIONS
C
      IF (ICODE.NE.1) GOTO 100
      WRITE(14,*) ' COX MODEL '
      WRITE(14,*) 'NUMBER OF STRATA'
      WRITE(14,*) NSTRATA
      WRITE(14,*) ' PROBLEM SIZE'
      WRITE(14,*) NDIM
c
      WRITE(14,*) 'SOLUTIONS (NOT SORTED) '
      WRITE(14,*) ' (SOL. FOR CONTINUOUS COVARIATES ARE STANDARDIZED) '
      DO 30 J=1,NCOVMOD
        II = IMOD(J)
        IF (ISAME(II).NE.0) GOTO 30
        JJ=ILAST(II)-IFIRST(II)+1
        SUM=0.D0
        NORM=0.D0
        NEF=0
        CHMAX=0.D0
        JM=0
        DO 32 K=IFIRST(II),ILAST(II)
          IF (BETA(K).NE.0.D0) THEN
            DIFF=BETA(K)-BETAPREV(K)
            IF (DABS(DIFF).GT.CHMAX) THEN
              CHMAX=DABS(DIFF)
              JM=K-IFIRST(II)+1
            ENDIF
            SUM=SUM+DABS(DIFF)
            NORM=NORM+DIFF*DIFF
            NEF=NEF+1
            BETAPREV(K)=BETA(K)
          ENDIF
  32    CONTINUE
        IF (ITOEV.GT.1) THEN
           SUM=SUM/MAX(1.D0,DBLE(NEF))
           NORM=DSQRT(NORM)/DBLE(NEF)
        ENDIF
        IF (CHMAX.GT.0.D0) THEN
         WRITE(14,94) LABEL(II),ICOVTYP(II),JJ,SUM,NORM,CHMAX,JM
         IF (DETAIL_IT)
     +     WRITE(6,94) LABEL(II),ICOVTYP(II),JJ,SUM,NORM,CHMAX,JM
        ELSE
         WRITE(14,*) LABEL(II),ICOVTYP(II),JJ
        ENDIF
  94    FORMAT(1X,A8,I2,I5,' ABS_CHANGE: ',D10.3,' NORM: ',D10.3,
     +   ' MAX: ',D10.3,' (',I4,')')
        WRITE(14,90) (BETA(K),K=IFIRST(II),ILAST(II))
  90    FORMAT(1X,6F12.6)
  30  CONTINUE
      WRITE(14,92) ITOEV
  92  FORMAT(1X,'F_EVAL ',I5,' 0')
C
      CLOSE(14)
      RETURN
C
C ICODE <> 1 ==> READ SOLUTIONS
c
  100 CONTINUE
c COX MODEL
      READ(14,*) dummy
C NUMBER OF STRATA
      READ(14,*) dummy
      READ(14,*) NSTRATA2
C
      READ(14,*) dummy
      READ(14,*) NDIM2
c
C SOLUTIONS (NOT SORTED)
      READ(14,*) dummy
      READ(14,*) dummy
  130 READ(14,*,END=199) LAB
      IF (LAB.EQ.'F_EVAL') GOTO 199
      II=0
      DO 140 J=1,NCOVMOD
        I=IMOD(J)
        IF (LABEL(I).EQ.LAB) II=I
  140 CONTINUE
      IF (II.NE.0) THEN
        IF (ISAME(II).NE.0) GOTO 130
        READ(14,90) (BETA(K),K=IFIRST(II),ILAST(II))
      ELSE
        READ(14,*) X
      ENDIF
      GOTO 130

  199 CLOSE(14)
  
      deallocate(BETAPREV)
      RETURN
c***********************************************************************
      END
      REAL FUNCTION SECOND2()
C***********************************************************************
C CPU time (for Risc6000 computers)
C***********************************************************************
!      INTEGER MCLOCK
!      SECOND2=MCLOCK()/10000.         !commented out as in Weibull
      second2=0
      RETURN
      END
