      SUBROUTINE INIT(NDIM1,NCTEST,NSTD,NPRINT,NBASE,NSURV,NCONS,
     +          NKAPLAN,NOLDS,BETA1)
C***********************************************************************
C  INIT          *                                    *  04 / 05 /1993 *
C***********************************************************************
C  READ MODEL SPECIFICATIONS, WRITE WORKING FILE FOR SUBROUTINE FCOX   *
C***********************************************************************
c
      use parinclu2
c
      implicit none
      integer,allocatable :: IRKC(:,:)  !IRKC(NDIMAX,4)
      integer,allocatable :: IWORK(:) !IWORK(3*NDIMAX)
      integer,allocatable :: IBEF(:),IAFT(:),IREC(:),ITIMDEP(:),JSAME(:) !all MXEF
      integer,allocatable :: ILEV(:),INCLUD(:),IREAD1(:),IREAD2(:)       !all MXEF
      integer,allocatable :: ITEMP(:),MA(:),MI(:)                        !all MXEF
      integer,allocatable :: IPOW(:,:)                                   !IPOW(MXEF,2)
      integer,allocatable :: KRR(:),ITABL(:,:) !KRR(MXEF*NRECMAX),ITABL(MXEF,NRECMAX)
      real,allocatable :: REC(:),TEMP(:),XMA(:),XMI(:)                   !all MXEF
      real,allocatable :: XTABL(:,:)                                     !XTABL(MXEF,NRECMAX)
      real*8,allocatable :: YCOEF(:)                                     !YCOEF(MXEF)
c
      INTEGER NFIG(0:MAXWORD),LFIG(0:MAXWORD),IFIG(MAXFIG),IFAIL
      INTEGER MA2(3),MI2(3),MODSPEC
      INTEGER I,II,J,JJ,JJ2,J1,J2,J3,K,KK,LL,IW,IUNIT,NWORD,NVAR,NLEF
      INTEGER NCONS,NRECW,NCEN,NUNC,NDIM1,WN1
      INTEGER IAD,IADSIRE,IADDAM,NINTEG,NOLDS,NBIN,NUNK
      INTEGER NSTD,NPRINT,NCTEST,NBASE,NSURV
      INTEGER IPEST,M1,M2
      INTEGER NKAPLAN,NCCOV,NDCOV,NCOVREAD,LTAB,NID,NPOW,JK,IC
      INTEGER ICOLSTR,ICOLTIM,ICOLCOD,ITIME,ICODE,ISTRATA
      INTEGER IPRESTR,ITOTSTR,IPRETIM,IPRECOD,IPRINT,IUZLES,IFOUND
      INTEGER NRR,NRRMAX,actual,firstVal,smaller,larger
      INTEGER posCrnd1,posCrnd2
C
      REAL XAV2(3),XNUM,PERC,W
      REAL XFIG(MAXFIG)
      REAL*8 beta1(*)
C
      CHARACTER WORD(MAXLENG,0:MAXWORD)
      CHARACTER TITLE(70) ,TEMPDIR2(100)
      CHARACTER*8 BEG,WNEXT
      CHARACTER*8 EFFECT,crndeff(2)
      CHARACTER*100 FILENAM
C
      logical rndflag
C
      EQUIVALENCE (FILENAM,TEMPDIR2(1))
 !     EQUIVALENCE (ITABL(1,1),KRR(1))
 !     EQUIVALENCE (XTABL(1,1),KRR(1))
!      EQUIVALENCE (INFO(1,1),KREC(1))
!      EQUIVALENCE (INFO2(1,1),KREC2(1))
!      EQUIVALENCE (IDATA(1,1),XDATA(1,1))
!      EQUIVALENCE (IDATA2(1,1),XDATA2(1,1))
	  
!LOCALS
      allocate(IRKC(NDIMAX,4),IWORK((3*NDIMAX)))
      allocate(IBEF(MXEF),IAFT(MXEF),IREC(MXEF),ITIMDEP(MXEF))
      allocate(JSAME(MXEF),ILEV(MXEF),INCLUD(MXEF),IREAD1(MXEF))
      allocate(IREAD2(MXEF),ITEMP(MXEF),MA(MXEF),MI(MXEF),IPOW(MXEF,2))
      allocate(KRR(MXEF*NRECMAX),ITABL(MXEF,NRECMAX))
      allocate(XTABL(MXEF,NRECMAX))
      allocate(REC(MXEF),TEMP(MXEF),XMA(MXEF),XMI(MXEF),YCOEF(MXEF))
c

      if (parmout.ne."NONE".and.parmout.ne." ")
     +       open(6,FILE=PARMOUT,FORM='FORMATTED')
C
C-----------------------------------------------------------------------
C CALL OF READPARM : READS COVARIATES SPECIFICATION
C-----------------------------------------------------------------------
      IUNIT=10
      CALL READPARM(IUNIT,NWORD,TITLE,WORD,NFIG,LFIG,IFIG,XFIG,parm1)
C
C-----------------------------------------------------------------------
C INITIALIZATION OR DEFAULT VALUES OF SOME PARAMETERS
C-----------------------------------------------------------------------
      NCOVREAD = 0
      MODSPEC=0
      IPRINT = 0
      IOMODE=1
      ICOLTIM = 1
      ICOLCOD = 2
      NBIN=0
      NLEF=0
      NSTOR = 1
      NSTRATA = 0
      NBASE = 0
      NKAPLAN = 0
      NUNK = 0
      NVAR = 0
      NSTD = 0
      NINTEG = 0
      NRULE = 0
      NRELMAT = 0
      NCTEST= 0
      NPRINT= 0
      NSURV = 0
      NSTIME = 0
      NALL_TIM = 0
      NOLDS=0
      EPS_BF = EPS_BFDEF
      NCONS = 0
      NCCOV=0
      NDCOV=0
      ICONS(0) = 0
      NPOW = 0
      BOUND=0
      IPEST=0
      wn = 0
      nrecmax2=1
      rndflag=.true.
      firstVal=0
C
C-----------------------------------------------------------------------
C INTERPRET THE (NWORD) WORDS FROM THE WORD LIST OBTAINED AFTER READING
C PARAMETER FILE (UNIT 1) WITH SUBROUTINE READPARM
C-----------------------------------------------------------------------
      WORD(1,NWORD+1)=';'
 35   wn=wn+1
      IF (wn.GT.NWORD.AND.MODSPEC.EQ.0) THEN
C-----------------------------------------------------------------------
C CALL OF READPARM : READS MODEL SPECIFICATION + OPTIONS
C-----------------------------------------------------------------------
       IUNIT=11
       MODSPEC=1
       CALL READPARM(IUNIT,NWORD,TITLE,WORD,NFIG,LFIG,IFIG,XFIG,parm2)
c        do 888 wn=1,nword
c          print *,wn,(word(k,wn),k=1,15)
c 888    continue
       wn=1
      ENDIF
      IF (wn.LE.NWORD) THEN
       IF (INDEX('ABCDEFGHIJKLMNOPQRSTUVWXYZ;.',WORD(1,wn)).EQ.0)
     +      then
c            PRINT *,' problem in reading word ',wn
            goto 35
       endif
       BEG=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +     //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
       IFOUND = 0
       DO 30 kn=1,NKEYC
C-----------------------------------------------------------------------
C CHECK IF FIRST 8 LETTERS OF THE ITH WORD CORRESPOND TO A KEYWORD
C-----------------------------------------------------------------------
       IF (BEG.EQ.KEYWORD(kn)) THEN
             IFOUND = 1
C-----------------------------------------------------------------------
C        *  KEYWORD = TIME
C kn = 1 *  ICOLTIM = ORDER OF THE TIME VARIABLE IN THE INPUT FILE
C        *  (DEFAULT VALUE = 1)
C-----------------------------------------------------------------------
             IF (kn.EQ.1) THEN
             ICOLTIM = IFIG(LFIG(wn))
             IF ((WORD(1,wn+1).NE.';').OR.(NFIG(wn).NE.1)) THEN
                   WRITE(6,9310)
 9310           FORMAT(1X,' ERROR IN THE "TIME"',
     +          ' STATEMENT',/1X,'SHOULD BE FOLLOWED BY ONE FIGURE ONLY'
     +            ,' OR THERE IS A SEMI-COLON MISSING',
     +            /1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = CODE
C kn = 2 *  ICOLCOD = ORDER OF THE CODE VARIABLE IN THE INPUT FILE
C        *  (DEFAULT VALUE = 2)
C-----------------------------------------------------------------------
             IF (kn.EQ.2) THEN
             ICOLCOD = IFIG(LFIG(wn))
             IF ((WORD(1,wn+1).NE.';').OR.(NFIG(wn).NE.1)) THEN
                   WRITE(6,9311)
 9311           FORMAT(1X,' ERROR IN THE "CODE"',
     +          ' STATEMENT',/1X,'SHOULD BE FOLLOWED BY ONE FIGURE ONLY'
     +            ,' OR THERE IS A SEMI-COLON MISSING',
     +            /1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = COVARIAT(E)
C kn = 3 *  NAME AND LOCATION OF COVARIATES IN INPUT FILE
C-----------------------------------------------------------------------
             IF (kn.EQ.3) THEN
   10           wn=wn+1
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS NOT ';' NOR A KEYWORD
C-----------------------------------------------------------------------
               IF (WORD(1,wn).EQ.';') GOTO 35
               WNEXT= WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
               DO 5 K=1,NKEYC
                 IF (WNEXT.EQ.KEYWORD(K)) THEN
                   WRITE(6,9312) WNEXT
 9312            FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE COVARIAT(ES)',
     +           '  STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +             1X,' CHECK PARAMETER FILE')
                   STOP
                 ENDIF
    5          CONTINUE
C-----------------------------------------------------------------------
C 'WNEXT'IS NOT A KEYWORD => IT'S A COVARIATE LABEL, STORED IN 'LABEL()'
C  IN THE INPUT FILE, WE HAVE : LABEL ILEV IBEF (IAFT)
C  ILEV = MAXIMUM NUMBER OF LEVELS (0 IF CONTINUOUS COVARIATE)
C  IBEF = ORDER OF THE VARIABLE BEFORE CHANGE AT TIME=T IN INPUT FILE
C  IAFT = ORDER OF THE VARIABLE AFTER CHANGE AT TIME=T IN INPUT FILE
C    IF IAFT IS OMITED OR IAFT=IBEF, ==> TIME-INDEPENDENT COVARIATE
C-----------------------------------------------------------------------
             NCOVREAD = NCOVREAD + 1
             LABEL(NCOVREAD) = WNEXT
             K = LFIG(wn)
             IF ((NFIG(wn).LT.2).OR.(NFIG(wn).GT.3)) THEN
             WRITE(6,9313) WNEXT,NFIG(wn)
 9313        FORMAT(1X,' ERROR IN THE "COVARIAT(ES)" STATEMENT',/1X,
     +       ' THE COVARIATE LABEL ',A8,' IS FOLLOWED BY ',I3,
     +       ' FIGURES INSTEAD OF THREE OR FOUR :'/1X,' IN THE INPUT ',
     +       ' FILE, WE SHOULD HAVE : LABEL ILEV IBEF (IAFT) ',/1X,
     +       ' WHERE : ',/1X,'ILEV = MAXIMUM NUMBER',
     +       ' OF LEVELS (0 IF CONTINUOUS COVAR.)',/1X,
     +       'IBEF = ORDER OF THE VARIABLE BEFORE CHANGE AT TIME=T',
     +       /1X,'IAFT = ORDER OF THE VARIABLE AFTER CHANGE AT TIME=T',
     +       ' IN INPUT FILE',/1X, 'IF IAFT IS OMITED OR IAFT=IBEF,',
     +       ' ==> TIME-INDEPENDENT COVARIATE',
     +       //1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             ILEV(NCOVREAD) = IFIG(K)
C-----------------------------------------------------------------------
C  IF LABEL IS FOLLOWED BY NO MORE THAN 2 FIGURES OR IF THE SECOND
C  AND THE THIRD  ARE THE SAME ==> TIME INDEPENDENT COVARIATE
C-----------------------------------------------------------------------
             IF ((NFIG(wn).EQ.2).OR.
     +             ((NFIG(wn).EQ.3).AND.(IFIG(K+1).EQ.IFIG(K+2)))) THEN
                   ITIMDEP(NCOVREAD)=0
                   IBEF(NCOVREAD)=IFIG(K+1)
                   NVAR = NVAR + 1
             ELSE
                   ITIMDEP(NCOVREAD)=1
                   IBEF(NCOVREAD)=IFIG(K+1)
                   IAFT(NCOVREAD)=IFIG(K+2)
                   NVAR = NVAR + 2
             ENDIF
             IF (ILEV(NCOVREAD).LE.0) THEN
                   ICOVTYP(NCOVREAD)=0
                   NINTEG = NINTEG + 1 + ITIMDEP(NCOVREAD)
             ELSE
                   ICOVTYP(NCOVREAD)=1
             ENDIF
             GOTO 10
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = STORAGE
C kn = 4 *  "DUMMY KEYWORD" (FIRST OUT OF TWO, IN 'STORAGE ON_DISK'
C        *   OR 'STORAGE IN_CORE')
C-----------------------------------------------------------------------
             IF (kn.EQ.4) THEN
             K=wn+1
             WNEXT=WORD(1,K)//WORD(2,K)//WORD(3,K)//WORD(4,K)
     +              //WORD(5,K)//WORD(6,K)//WORD(7,K)//WORD(8,K)
             IF (WNEXT.NE.KEYWORD(5).AND.WNEXT.NE.KEYWORD(6)) THEN
                   WRITE(6,9315)
 9315              FORMAT(1X,' ERROR IN STORAGE STATEMENT ',/
     +      1X,' THE  NEXT STATEMENT SHOULD BE "IN_CORE" OR "ON_DISK"'/
     +             1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = ON_DISK
C kn = 5 *  TEMPORARY STORAGE OF THE WORKING FILE (UNIT 3) ON DISK
C        *  BY BLOCK OF SIZE NRECMAX ELEMENTARY RECORDS (FOR FAST I/O)
C-----------------------------------------------------------------------
             IF (kn.EQ.5) THEN
             NSTOR=0
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = IN_CORE
C kn = 6 *  TEMPORARY STORAGE IN CORE
C-----------------------------------------------------------------------
             IF (kn.EQ.6) THEN
             NSTOR=1
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = STRATA
C kn = 7 *  NSTRATA = NUMBER OF STRATA
C        *  IF STRATIFICATION, ICOLSTR = ORDER OF THE VARIABLE INDICATING
C        *         STRATUM INFORMATION IN THE INPUT FILE
C-----------------------------------------------------------------------
            IF (kn.EQ.7) THEN
C-----------------------------------------------------------------------
C  CHECK THAT THE COVARIATE STATEMENT WAS FOUND BEFORE
C-----------------------------------------------------------------------
             IF (NCOVREAD.LE.0) THEN
                  WRITE(6,9322)
 9322              FORMAT(1X,' ERROR IN "STRATA" STATEMENT ',/
     +             1X,' THIS STATEMENT SHOULD APPEAR AFTER THE ',
     +            '"COVARIATE" STATEMENT',
     +             /1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
             wn=wn+1
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS NOT ';' NOR A KEYWORD
C-----------------------------------------------------------------------
             IF (WORD(1,wn).EQ.';') GOTO 35
             WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
             DO 852 K=1,NKEYC
                   IF (WNEXT.EQ.KEYWORD(K)) THEN
                   WRITE(6,9323) WNEXT
 9323            FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE STRATA ',
     +              'STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +               1X,' CHECK PARAMETER FILE')
                   STOP
                  ENDIF
  852           CONTINUE
C-----------------------------------------------------------------------
C 'WNEXT'IS NOT A KEYWORD => IT'S A COVARIATE LABEL; MUST BE IN'LABEL()'
C-----------------------------------------------------------------------
             JJ = 0
             DO 854 K=1,NCOVREAD+NPOW
               IF (WNEXT.EQ.LABEL(K)) JJ = K
  854        CONTINUE
c ISTRVAR=JJ added on November 24
             ISTRVAR=JJ
             IF (JJ.EQ.0) THEN
                  WRITE(6,9324) WNEXT
 9324             FORMAT(1X,'LABEL ',A8,' USED IN THE STRATA',
     +            ' STATEMENT WAS NOT FOUND IN THE COVARIATE LIST',/
     +               1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
c modified on November 24
             IF (ILEV(JJ).LE.0) THEN
c            IF (ILEV(JJ).LE.0.OR.ITIMDEP(JJ).NE.0) THEN
                  WRITE(6,9325) WNEXT
 9325             FORMAT(1X,'LABEL ',A8,' USED IN THE STRATA',
     +            ' STATEMENT IS NOT A CLASS VARIABLE ',/1X,
c    +            ' OR IS NOT TIME INDEPENDENT ',/
     +               1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
             NSTRATA = ILEV(JJ)
             IF (NSTRATA.GT.MXSTRA) THEN
                  WRITE(6,8082) NSTRATA,MXSTRA
 8082             FORMAT(1X,' THERE ARE MORE STRATA (',I3,') ',
     +            'THAN THE MAXIMUM SPECIFIED (',I3,')',/1X,
     +            ' INCREASE PARAMETER NSTRAMAX ')
                  STOP
             ENDIF
             ICOLSTR = IBEF(JJ)
             wn = wn+1
             GOTO 35
           ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = MODEL
C kn = 8 *  MODEL SPECIFICATION
C        *  THE (NCOVMOD) FOLLOWING WORDS (UNTIL ';' IS FOUND)
C        *            SPECIFY THE MODEL USED
C        *  ==> FIND THE CORRESPONDING LABEL IN VEC 'LABEL'
C        *      AND SWITCH THE INDICATOR VARIABLE INCLUD() TO 1
C        *      IF ILEV=0 ==> CONTINUOUS COVARIATE, ELSE DISCRETE
C-----------------------------------------------------------------------
             IF (kn.EQ.8) THEN
             DO 22 JJ=1,NCOVREAD
                  INCLUD(JJ)=0
   22           CONTINUE
             NCOVMOD = 0
   25        wn=wn+1
             IF (WORD(1,wn).EQ.';') GOTO 35
             DO 26 KK=2,MAXLENG-2
                  IF (WORD(KK,wn).EQ.'*') THEN
                   IF (WORD(KK+1,wn).EQ.'*'.AND.
     +                   INDEX('0123456789',WORD(KK+2,wn)).NE.0) THEN
                         NPOW = NPOW+1
                         IPOW(NPOW,2)=INDEX('123456789',WORD(KK+2,wn))
                         JJ = NCOVREAD + NPOW
                         IF (JJ.GT.MXEF) THEN
                         WRITE(6,9220) JJ,MXEF
                         STOP
                         ENDIF
                         LABEL(NCOVREAD+NPOW) =
     +                 WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)//
     +                 WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
                         WORD(KK,wn)=' '
                         WORD(KK+1,wn)=' '
                         WORD(KK+2,wn)=' '
                         EFFECT =
     +                 WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)//
     +                 WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
                         JJ=0
                         DO 27 LL=1,NCOVREAD
                         IF (LABEL(LL).EQ.EFFECT) JJ = LL
   27                    CONTINUE
                         IF (JJ.EQ.0.OR.ILEV(JJ).GT.0) THEN
                         WRITE(6,9328) EFFECT
 9328                  FORMAT(1X,' ERROR IN THE "MODEL / COVARIAT(E)"',
     +                 ' STATEMENTS',/1X,' THE LABEL ',A8,
     +                 ' WAS NOT FOUND IN THE (CONTINUOUS) COVARIATE',
     +                  /1X,' ITS POWER CANNOT BE TAKEN IN THE MODEL',
     +                   /1X,' CHECK PARAMETER FILE')
                         STOP
                         ENDIF
                         LL = NCOVREAD + NPOW
                         IPOW(NPOW,1) = JJ
                         ICOVTYP(LL)=-1
                         ITIMDEP(LL)= ITIMDEP(JJ)
                         IBEF(LL)= IBEF(JJ)
                         IAFT(LL)= IAFT(JJ)
                         INCLUD(LL)=1
                         NCOVMOD = NCOVMOD + 1
                         IMOD(NCOVMOD) = NCOVREAD + NPOW
                         NCCOV = NCCOV + 1
                         GOTO 25
                   ENDIF
                  ENDIF
   26           CONTINUE

             EFFECT = WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)//
     +                  WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
             JJ=0
             DO 20 KK=1,NCOVREAD
                   IF (LABEL(KK).EQ.EFFECT) THEN
                   INCLUD(KK)=1
                   NCOVMOD = NCOVMOD + 1
                   IMOD(NCOVMOD) = KK
                   JJ=1
                   IF (ILEV(KK).LE.0) THEN
                        NCCOV = NCCOV + 1
                   ELSE
                        NDCOV = NDCOV + 1
                   ENDIF
                   ENDIF
   20           CONTINUE
             IF (JJ.EQ.0) THEN
                   WRITE(6,9329) EFFECT
 9329              FORMAT(1X,' ERROR IN THE "MODEL / COVARIAT(ES)"',
     +             ' STATEMENTS',/1X,' THE LABEL ',A8,
     +             ' WAS NOT FOUND IN THE COVARIATE LIST',
     +             /1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             GOTO 25
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = BASELINE
C kn = 9 *  SPECIFIES THAT THE BASELINE CUMULATIVE HAZARD AND
C        *  THE BASELINE SURVIVOR FUNCTION SHOULD BE COMPUTED AND PRINTED
C        *  ( DEFAULT = NO)
C-----------------------------------------------------------------------
             IF (kn.EQ.9) THEN
             NBASE = NBASE + 1
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = KAPLAN
C kn =10 *  SPECIFIES THAT THE PRODUCT-LIMIT (=KAPLAN-MEIER) ESTIMATE
C        *  OF THE SURVIVOR FUNCTION SHOULD BE COMPUTED AND PRINTED
C        *  ( DEFAULT = NO)
C-----------------------------------------------------------------------
             IF (kn.EQ.10) THEN
             NKAPLAN = 1
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = TEST
C kn =11 *  "DUMMY KEYWORD" (FIRST OUT OF TWO, IN 'TEST GENERAL'
C        *   OR 'TEST SEQUENTIAL OR 'TEST LAST')
C-----------------------------------------------------------------------
             IF (kn.EQ.11) THEN
             K=wn+1
             WNEXT=WORD(1,K)//WORD(2,K)//WORD(3,K)//WORD(4,K)
     +              //WORD(5,K)//WORD(6,K)//WORD(7,K)//WORD(8,K)
             IF (WNEXT.NE.KEYWORD(12).AND.WNEXT.NE.KEYWORD(13)
     +        .AND.WNEXT.NE.KEYWORD(14).AND.WNEXT.NE.KEYWORD(15))THEN
                   WRITE(6,9345)
 9345              FORMAT(1X,' ERROR IN "TEST" STATEMENT ',/
     +   1X,' THE NEXT STATEMENT SHOULD BE "GENERAL" OR "SEQUENTIAL"',
     +      ' OR "LAST" OR "EFFECT"',/1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = GENERAL(=DEFAULT)
C kn =12 *  ONLY LIKELIHOOD RATIO TEST PERFORMED = FULL MODEL
C-----------------------------------------------------------------------
             IF (kn.EQ.12) THEN
             NCTEST = 0
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = EFFECT
C kn =13 *  LIKELIHOOD RATIO TESTS PERFORMED WHEN EFFECT(S) ARE EXCLUDED
C        *         NCTEST = 4 IF PARTICULAR EFFECTS + SEQUENTIAL
C        *         NCTEST = 5 IF PARTICULAR EFFECTS + LAST
C        *         NCTEST = 6 IF ONLY PARTICULAR EFFECTS TESTED
C-----------------------------------------------------------------------
             IF (kn.EQ.13) THEN
C-----------------------------------------------------------------------
C  CHECK THAT THE COVARIATE STATEMENT WAS FOUND BEFORE
C-----------------------------------------------------------------------
             IF (NCTEST.EQ.1) THEN
                   NCTEST = 5
             ELSE IF (NCTEST.EQ.2) THEN
                   NCTEST = 4
                   DO 848 K=1,NCOVREAD+NPOW
                     ITEST(K) = 0
  848              CONTINUE
             ELSE IF (NCTEST.NE.3) THEN
                   NCTEST = 6
             ENDIF
             IF (NCOVREAD.LE.0) THEN
                  WRITE(6,9402)
 9402              FORMAT(1X,' ERROR IN "TEST" STATEMENT ',/
     +             1X,' THIS STATEMENT SHOULD APPEAR AFTER THE ',
     +            '"COVARIATE" STATEMENT',
     +             /1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
   50           wn=wn+1
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS NOT ';' NOR A KEYWORD
C-----------------------------------------------------------------------
             IF (WORD(1,wn).EQ.';') GOTO 35
             WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
             DO 52 K=1,NKEYC
                   IF (WNEXT.EQ.KEYWORD(K)) THEN
                   WRITE(6,9412) WNEXT
 9412            FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE TEST ',
     +              'STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +               1X,' CHECK PARAMETER FILE')
                   STOP
                  ENDIF
   52           CONTINUE
C-----------------------------------------------------------------------
C 'WNEXT'IS NOT A KEYWORD => IT'S A COVARIATE LABEL; MUST BE IN'LABEL()'
C-----------------------------------------------------------------------
             JJ = 0
             DO 54 K=1,NCOVREAD+NPOW
                  IF (WNEXT.EQ.LABEL(K)) JJ = K
   54           CONTINUE
             IF (JJ.EQ.0) THEN
                  WRITE(6,9422) WNEXT
 9422             FORMAT(1X,'LABEL ',A8,' USED IN THE TEST',
     +            ' STATEMENT WAS NOT FOUND IN THE COVARIATE LIST',/
     +               1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
             ITEST(JJ) = 1
             GOTO 50
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = SEQUENTIAL
C kn =14 *  LIKELIHOOD RATIO TESTS PERFORMED INCLUDING EACH EFFECT
C        *  ONE AFTER THE OTHER IN THE ORDER GIVEN BY THE MODEL STATEMENT
C        *  CODE : NCTEST = 2
C        *         NCTEST = 3 IF SEQUENTIAL + LAST
C        *         NCTEST = 4 IF PARTICULAR EFFECTS + SEQUENTIAL
C-----------------------------------------------------------------------
             IF (kn.EQ.14) THEN
             IF (NCTEST.EQ.1.OR.NCTEST.EQ.5) THEN
                   NCTEST = 3
             ELSE
                   NCTEST = 2
             ENDIF
             DO 56 K=1,NCOVREAD
                   ITEST(K) = 1
   56        CONTINUE
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = LAST
C kn =15 *  LIKELIHOOD RATIO TEST PERFORMED EXCLUDING EACH EFFECT
C        *  ONE AFTER THE OTHER FROM THE FULL MODEL
C        *  CODE : NCTEST = 1
C        *         NCTEST = 3 IF SEQUENTIAL + LAST
C        *         NCTEST = 5 IF PARTICULAR EFFECTS + LAST
C-----------------------------------------------------------------------
             IF (kn.EQ.15) THEN
             IF (NCTEST.EQ.2.OR.NCTEST.EQ.4) THEN
                   NCTEST = 3
             ELSE
                   NCTEST = 1
             ENDIF
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = STD_ERROR   (or kn.EQ.59 : STD)
C kn =16 *  SPECIFIES THAT STANDARD ERRORS ARE TO BE COMPUTED
C        *  ( DEFAULT = NO)
C-----------------------------------------------------------------------
             IF (kn.EQ.16.OR.kn.EQ.59) THEN
             NSTD = 1
             wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = STORE_SOLU(TIONS)
C kn =17 *  SOLUTIONS AT CONVERGENCE ARE STORED
C-----------------------------------------------------------------------
             IF (kn.EQ.17) THEN
               IF (NOLDS.EQ.2) THEN
                 NOLDS=3
               ELSE
                 NOLDS=1
               ENDIF
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = READ_OLD_SOLU(TIONS)
C kn =18 *  A VECTOR OF OLD_SOLUTIONS IS USED AS STARTING VALUES
C-----------------------------------------------------------------------
             IF (kn.EQ.18) THEN
               IF (NOLDS.EQ.1) THEN
                  NOLDS=3
               ELSE
                  NOLDS=2
               ENDIF
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C kn = 19*  KEYWORD = SURVIVAL
C kn = 20*                     / RESIDUAL
C        *                 (the two are mutually exclusive)
C        *  COMPUTES THE SURVIVOR FUNCTION OR GENERALIZED RESIDUALS
C        *  ACCORDING TO PRESPECIFIED OPTIONS.
C        *  THE NEXT TWO WORDS ARE FILE NAMES. THEY ARE:
C        * ==> IF VALUES OF THE SURVIVOR FUNCTION ARE DESIRED:
C        *  1  THE RECODED FILE OF 'FUTURE' RECORDS (comes from PREPARE)
C        *  2  THE OUTPUT FILE FOR OUTPUT PROBABILITIES,
C        *  THEN THE NEXT WORD MUST BE EITHER 'QUANTILE(S)'
C        *     'ALL_TIME' 'EQUAL_SP(ACE)' OR 'SPECIFIC'.
C        * ==> IF RESIDUALS ARE DESIRED:
C        *  1  THE RECODED UNSORTED DATAFILE  (comes from PREPARE)
C        *  2  THE OUTPUT FILE FOR RESIDUALS,
C        *  THEN THE NEXT WORD MUST BE 'RESIDUAL(S)'
C-----------------------------------------------------------------------
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on October 2, 1997
             IF (kn.EQ.19.or.kn.EQ.20) THEN
                 IF (kn.EQ.19) THEN
                    IF (NSURV.EQ.2) THEN
                       WRITE(6,9354)
 9354          FORMAT(1X,' ERROR IN SURVIVAL /RESIDUALS STATEMENT',
     +         /1x,' BOTH STATEMENTS ARE MUTUALLY EXCLUSIVE ',/1x,
     +         ' CHECK PARAMETER FILE')
                       STOP
                    ENDIF
                    NSURV = 1
                 ELSE
                    IF (NSURV.EQ.1) THEN
                       WRITE(6,9354)
                       STOP
                    ENDIF
                    NSURV = 2
                 ENDIF
c----------------------------------------------------------------------
c PROCESS THE FILE NAMES
c----------------------------------------------------------------------
             DO 23 K=1,2
               wn=wn+1
c----------------------------------------------------------------------
c READ NAME OF VARIABLE
c----------------------------------------------------------------------
               WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +         //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
c CHECK IF NEW KEYWORD APPEARS BEFORE END OF STATEMENT
c----------------------------------------------------------------------
               IF (WORD(1,wn).EQ.';') THEN
                 IF (NSURV.EQ.1) THEN
                   WRITE(6,9355)
                 ELSE
                   WRITE(6,9356)
 9356          FORMAT(1X,' ERROR IN "RESIDUAL(S)" STATEMENT ',/1x,
     +         ' TWO FILE NAMES SHOULD APPEAR',/1X,' (recoded UNSORTED',
     +         ' dataset name from PREPARE and output file)',
     +            /1X,' CHECK PARAMETER FILE')
                   STOP
                 ENDIF
               ENDIF
               DO 29 JJ=1,NKEYC
                 IF (WNEXT.EQ.KEYWORD(JJ)) THEN
                   WRITE(6,9462) WNEXT
 9462              FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE SURVIVAL',
     +             ' / RESIDUALS STATEMENT',
     +              /1X,' THERE IS A FILE NAME MISSING',/
     +             1X,' CHECK PARAMETER FILE')
                   STOP
                 ENDIF
   29          CONTINUE
C----------------------------------------------------------------------
               JJ = K + 4
               FILE(JJ)=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +           //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
     +           //WORD(9,wn)//WORD(10,wn)//WORD(11,wn)//WORD(12,wn)
     +           //WORD(13,wn)//WORD(14,wn)//WORD(15,wn)
   23          CONTINUE
             IF (NSURV.EQ.2) THEN
               IF (WORD(1,wn+1).EQ.';') THEN
                 wn = wn+1
                 GOTO 35
               ELSE
                 WRITE(6,9356)
                 STOP
               ENDIF
             ENDIF
             K=wn+1
             WNEXT=WORD(1,K)//WORD(2,K)//WORD(3,K)//WORD(4,K)
     +           //WORD(5,K)//WORD(6,K)//WORD(7,K)//WORD(8,K)
             IF (WNEXT.NE.KEYWORD(24).AND.WNEXT.NE.KEYWORD(21)
     +         .AND.WNEXT.NE.KEYWORD(22).AND.WNEXT.NE.KEYWORD(23))THEN
               WRITE(6,9355)
 9355          FORMAT(1X,' ERROR IN "SURVIVAL" STATEMENT ',/1x,
     +         ' TWO FILE NAMES SHOULD APPEAR (recoded file from',
     +         ' PREPARE and output file for survival probabilities)'
     +         ,/1X,' THEN  NEXT STATEMENT SHOULD BE "QUANTILE" OR ',
     +         '"ALL_TIME(S)" OR "EQUAL_SP(ACE)" OR "SPECIFIC" ',
     +         /1X,' CHECK PARAMETER FILE')
               STOP
             ENDIF
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = ALL_TIME(S)
C kn =21 *  THE ESTIMATE OF THE SURVIVOR CURVE WILL BE COMPUTED
C        *      AT ALL TIMES (= FAILURE OR CHANGE IN TIME-DEPENDENT
C        *      COVARIATES) INDICATED FOR EACH ANIMAL IN FILE IN UNIT 3
C-----------------------------------------------------------------------
             IF (kn.EQ.21) THEN
               NALL_TIM = 1
               IF (WORD(1,wn+1).EQ.';') wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = EQUAL_SP(ACE)
C kn =22 *  THE ESTIMATE OF THE SURVIVOR CURVE WILL BE COMPUTED
C        *  AT EQUALLY SPACED TIMES FOR EACH ANIMAL IN FILE IN UNIT 3
C        *  TWO FIGURES ARE NEEDED: TIME INTERVAL AND TIME LIMIT
C        *  THESE VALUES ARE STORED IN VECTOR STIME()
C-----------------------------------------------------------------------
             IF (kn.EQ.22) THEN
             K=LFIG(wn)
             IF (NFIG(wn).NE.2) THEN
               WRITE(6,9365)
 9365          FORMAT(1X,' ERROR IN "EQUAL_SPACE" STATEMENT ',/1X,
     +         ' THIS STATEMENT SHOULD BE FOLLOWED BY TWO INTEGERS:',
     +         /1x,' THE TIME INTERVAL AND THE TIME LIMIT ',
     +         /1X,' CHECK PARAMETER FILE')
               STOP
             ENDIF
             IF (IFIG(K).GT.IFIG(K+1)) THEN
               WRITE(6,9366)
 9366          FORMAT(1X,' ERROR IN "EQUAL_SPACE" STATEMENT ',/2X,
     +         'THE TIME INTERVAL (FIRST INTEGER) SHOULD BE SMALLER',
     +         ' THAN THE TIME LIMIT (SECOND INTEGER)',
     +         /1X,' CHECK PARAMETER FILE')
               STOP
             ENDIF
             KK = IFIG(K)
   42        NSTIME = NSTIME + 1
             IF (NSTIME.GT.NSTIMAX) THEN
               WRITE(6,9358) 'NSTIMAX ',NSTIMAX,'NSTIMAX '
               STOP
             ENDIF
             ISTIME(NSTIME) = KK
             KK = KK + IFIG(K)
             IF (KK.LE.IFIG(K+1)) GOTO 42
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = SPECIFIC
C kn =23 *  THE ESTIMATE OF THE SURVIVOR CURVE WILL BE COMPUTED
C        *      AT THE SPECIFIED TIMES INDICATED AFTER THE STATEMENT
C        *      FOR EACH ANIMAL IN FILE IN UNIT 3
C-----------------------------------------------------------------------
             IF (kn.EQ.23) THEN
             K=LFIG(wn)
             DO 28 JJ=1,NFIG(wn)
               KK = K + JJ - 1
               IF (IFIG(KK).LE.0) THEN
                 WRITE(6,9370)
 9370            FORMAT(1X,' ERROR IN "SPECIFIC" STATEMENT ',/2X,
     +          'THE SPECIFIC TIME VALUES SHOULD BE STRICTLY POSITIVE',
     +           /1X,' CHECK PARAMETER FILE')
                 STOP
               ENDIF
               NSTIME = NSTIME + 1
               IF (NSTIME.GT.NSTIMAX) THEN
                 WRITE(6,9358) 'NSTIMAX ',NSTIMAX,'NSTIMAX '
                 STOP
               ENDIF
               ISTIME(NSTIME) = IFIG(KK)
   28        CONTINUE
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = QUANTILE(S)
C kn =24 *  THE ESTIMATE OF THE SURVIVOR CURVE WILL BE USED TO
C        *      COMPUTE TIMES AT WHICH SPECIFIC VALUES (QUANTILES)
C        *      ARE REACHED, FOR EACH ANIMAL IN FILE IN UNIT 3
C        *      THESE NQUANT VALUES ARE STORED IN VECTOR SQUANT()
C        *      THEY MUST BE (STRICTLY) BETWEEN 0 AND 100. E.G.:
C        *      SQUANT(1) = 25 ==> T SUCH THAT S(T) = 0.25 IS REQUIRED
C-----------------------------------------------------------------------
             IF (kn.EQ.24) THEN
             K=LFIG(wn)
             NQUANT=NFIG(wn)
             IF (NQUANT.GT.NSTIMAX) THEN
               WRITE(6,9358) 'NSTIMAX',NQUANT,'NSTIMAX'
 9358          FORMAT(1X,' THE PARAMETER ',A8,' = ',I8,
     +         ' IS TOO SMALL '/1X,
     +         ' CHECK PARAMETER FILE OR INCREASE THE VALUE OF ',A8)
               STOP
             ENDIF
             DO 32 JJ=1,NQUANT
               KK = K + JJ - 1
               IF (IFIG(K).LE.0.OR.IFIG(K).GE.100) THEN
                 WRITE(6,9360)
 9360            FORMAT(1X,' ERROR IN "QUANTILES" STATEMENT ',/1X,
     +      ' THE QUANTILE VALUES SHOULD BE INTEGERS BETWEEN 0 AND 100',
     +           /1X,' CHECK PARAMETER FILE')
                 STOP
               ENDIF
               SQUANT(JJ)=0.01D0 * DBLE(IFIG(KK))
   32        CONTINUE
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = CONSTRAI(NTS)
C kn =25 *  CONSTRAINTS
C        *   EITHER SUPPLIED BY THE USER (KEYWORD: IMPOSE)
C        *   OR FOUND BY THE PROGRAM (KEYWORD: FIND)
C        *   OR ARBITRARILY SET TO THE LAST LEVEL OF EACH EFFECT(K:LAST)
C        *   OR NONE (KEYWORD: NONE)
C-----------------------------------------------------------------------
             IF (kn.EQ.25) THEN
             K=wn+1
             WNEXT=WORD(1,K)//WORD(2,K)//WORD(3,K)//WORD(4,K)
     +           //WORD(5,K)//WORD(6,K)//WORD(7,K)//WORD(8,K)
             IF (WNEXT.NE.KEYWORD(26).AND.WNEXT.NE.KEYWORD(28)
     +         .AND.WNEXT.NE.KEYWORD(29).AND.WNEXT.NE.KEYWORD(30))THEN
               WRITE(6,9380)
 9380          FORMAT(1X,' ERROR IN "CONSTRAINTS" STATEMENT ',/
     +         1X,' THE  NEXT STATEMENT SHOULD BE "IMPOSE" OR ',
     +         '"FIND " OR "LARGEST" OR "NONE"',
     +         /1X,' CHECK PARAMETER FILE')
               STOP
             ENDIF
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = IMPOSE
C kn =26 *  IMPOSED CONSTRAINTS SUPPLIED BY THE USER
C        *    STORED IN ICONS FIRST AS LEVEL * MXEF + EFFECT NUMBER
C        *    (AS FOUND IN VECTOR LABEL())
C-----------------------------------------------------------------------
             IF (kn.EQ.26) THEN
             NCONS = NCONS + 1
C-----------------------------------------------------------------------
C  CHECK THAT THE COVARIATE STATEMENT WAS FOUND BEFORE
C-----------------------------------------------------------------------
             IF (NCOVREAD.LE.0) THEN
                  WRITE(6,9400)
 9400              FORMAT(1X,' ERROR IN "CONSTRAINTS" STATEMENT ',/
     +             1X,' THIS STATEMENT SHOULD APPEAR AFTER THE ',
     +            '"COVARIATE" STATEMENT',
     +             /1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
   60           wn=wn+1
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS NOT ';' NOR A KEYWORD (EXCEPT "CHECK")
C-----------------------------------------------------------------------
             IF (WORD(1,wn).EQ.';') GOTO 35
             WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
             IF (WNEXT.EQ.KEYWORD(27)) THEN
                  NCONS= NCONS + 1
                  GOTO 60
c                  IF (WORD(1,wn+1).EQ.';') wn = wn+1
c                  GOTO 35
             ENDIF
             DO 65 K=1,NKEYC
                   IF (WNEXT.EQ.KEYWORD(K)) THEN
                   WRITE(6,9410) WNEXT
 9410            FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE CONSTRAI(NTS)',
     +              '  STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +               1X,' CHECK PARAMETER FILE')
                   STOP
                  ENDIF
   65           CONTINUE
C-----------------------------------------------------------------------
C 'WNEXT'IS NOT A KEYWORD => IT'S A COVARIATE LABEL; MUST BE IN'LABEL()'
C-----------------------------------------------------------------------
             JJ = 0
             DO 70 K=1,NCOVREAD+NPOW
                  IF (WNEXT.EQ.LABEL(K)) JJ = K
   70           CONTINUE
             IF (JJ.EQ.0) THEN
                  WRITE(6,9420) WNEXT
 9420             FORMAT(1X,'LABEL ',A8,' USED IN THE CONSTRAI(NTS)',
     +            ' STATEMENT WAS NOT FOUND IN THE COVARIATE LIST',/
     +               1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
             DO 75 K=LFIG(wn),LFIG(wn) + NFIG(wn) - 1
                  ICONS(0) = ICONS(0) +1
                  IF (ICONS(0).GT.NDIMAX) THEN
                   WRITE(6,9260) ICONS(0),NDIMAX
                   STOP
                  ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on October 21, 1996
                  IF (IFIG(K).LT.0) THEN
                     ICONS(ICONS(0)) = IFIG(K)*MXEF - JJ
                  ELSE
                     ICONS(ICONS(0)) = IFIG(K) * MXEF + JJ
                  ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   75           CONTINUE
             GOTO 60
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = CHECK
C kn =27 *  CHECK THAT THE CONSTRAINTS SUPPLIED BY THE USER MAKE SENSE
C-----------------------------------------------------------------------
             IF (kn.EQ.27) THEN
             NCONS = NCONS + 1
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = FIND
C kn =28 *  THE PROGRAM WILL LOOK FOR LINEAR DEPENDENCIES IN A (DUMMY)
C        *    MATRIX OF SECOND DERIVATIVES AND IMPOSE CONSTRAINTS
C        *    EACH TIME IT FINDS ONE
C-----------------------------------------------------------------------
             IF (kn.EQ.28) THEN
             NCONS = -1
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = LARGEST
C kn =29 *  THE PROGRAM WILL SET TO ZERO THE LEVEL OF EACH DISCRETE
C        *  COVARIATE WITH THE LARGEST NUMBER OF UNCENSORED FAILURES
C        *  ( = DEFAULT)
C-----------------------------------------------------------------------
             IF (kn.EQ.29) THEN
             NCONS = 0
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = NONE
C kn =30 *  NO CONSTRAINTS SPECIFIED (BUT IMPLICITE ONES WILL APPEAR
C        *    IF STANDARD ERRORS ARE TO BE COMPUTED, I.E. A GENERALIZED
C        *    INVERSE OF THE HESSIAN WILL BE USED IF NEEDED
C-----------------------------------------------------------------------
             IF (kn.EQ.30) THEN
             NCONS = -2
             IF (WORD(1,wn+1).EQ.';') wn = wn+1
             GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = RANDOM
C kn =31 *  COVARIATES TREATED AS RANDOM
C        *  #############################
C        *  FIRST CASE : THE PARAMETER IS KNOWN
C        *   EITHER INDEPENDENT LOGGAMMA
C        *   <--> VARIABLE NAME + KEYWORD "LOGGAMMA" + GAMMA PARAMETER
C        *   OR INDEPENDENT NORMAL
C        *   <--> VARIABLE NAME + KEYWORD "NORMAL" + VARIANCE
C        *   OR MULTIVARIATE NORMAL
C        *   <--> VARIABLE NAME + KEYWORD "MULTINOR(MAL)"
C        *           + EITHER 'USUAL_RU(LES)' OR 'MGS_RULE(S)'
C        *            OR 'SIRE_DAM_(MODEL)' + VARIANCE
C        *      (IF KEYWORD JOINCODE HAS BEEN USED BEFORE
C        *       (in PREPARE.F) 2 VARIABLES NAMES CAN BE USED
C        *       IN THE NORMAL OR MULTINORMAL STATEMENT)
C        *  #############################
C        *  SECOND CASE : THE PARAMETER IS NOT KNOWN AND IS TO BE ESTIMATED
C        *   INSTRUCTIONS ARE SIMILAR TO THE ABOVE ONES, EXCEPT THAT:
C        *   THE KEYWORDS "ESTIMATE"  OR "ESTIMATE MOMENTS" (IF
C        *    MOMENTS OF THE POSTERIOR DISTRIBUTION ARE REQUIRED,
C        *    VIA NUMERICAL INTEGRATION) ARE USED BEFORE SPECIFYING
C        *    THE DISTRIBUTION (AFTER THE VARIABLE NAME)
C        *   THE PARAMETER VALUE IS REPLACED BY THREE VALUES:
C        *       LOWER BOUND, UPPER BOUND AND MAXIMUM TOLERANCE
C        *        (MAXIMUM DISTANCE BETWEEN THE LOWER AND UPPER LIMIT
C        *        OF THE ESTIMATE)
C        *
C        *   DEFAULT = NO RANDOM COVARIATES
C-----------------------------------------------------------------------
             IF (kn.EQ.31) THEN
c error flag for the CORRELATION keyword
             rndflag=.false.
C-----------------------------------------------------------------------
C  CHECK THAT THE COVARIATE STATEMENT WAS FOUND BEFORE
C-----------------------------------------------------------------------
             IF (NCOVREAD.LE.0) THEN
                  WRITE(6,9424)
 9424              FORMAT(1X,' ERROR IN "RANDOM" STATEMENT ',/
     +             1X,' THIS STATEMENT SHOULD APPEAR AFTER THE ',
     +            '"COVARIATE" STATEMENT',
     +             /1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
             DO 78 JJ=0,NCOVREAD
               IGAM(JJ,1)=0
               INOR(JJ,1)=0
   78        CONTINUE
             NRAND = 0
             IPEST=0
             MAXRAND = NCOVREAD
   80       wn=wn+1
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS NOT ';' NOR A KEYWORD
C-----------------------------------------------------------------------
             IF (WORD(1,wn).EQ.';') GOTO 35
             WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
             EFFECT = WNEXT
             DO 82 K=1,NKEYC
                  IF (WNEXT.EQ.KEYWORD(K)) THEN
                   WRITE(6,9430) WNEXT
 9430                FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE RANDOM',
     +              '  STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +               1X,' CHECK PARAMETER FILE')
                   STOP
                  ENDIF
   82           CONTINUE
C-----------------------------------------------------------------------
C 'WNEXT'IS NOT A KEYWORD => IT'S A COVARIATE LABEL; MUST BE IN'LABEL()'
C-----------------------------------------------------------------------
             JJ = 0
             DO 84 K=1,NCOVREAD
                  IF (WNEXT.EQ.LABEL(K)) JJ = K
   84           CONTINUE
             IF (JJ.EQ.0) THEN
                  WRITE(6,9435) WNEXT
 9435             FORMAT(1X,'LABEL ',A8,' USED IN THE RANDOM',
     +            ' STATEMENT WAS NOT FOUND IN THE COVARIATE LIST',/
     +               1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
C-----------------------------------------------------------------------
C 'WNEXT'IS A COVARIATE LABEL; MUST BE IN THE MODEL: INCLUD()=1
C-----------------------------------------------------------------------
             do i=1, ncovread
                if (WNEXT.eq.LABEL(i) .and. includ(i).ne.1) then
                  WRITE(6,9436) WNEXT
 9436             FORMAT(1X,'LABEL ',A8,' USED IN THE RANDOM',
     +            ' STATEMENT WAS NOT FOUND IN THE MODEL',/
     +               1X,' CHECK THE PARAMETER FILE')
                  stop
		        endif
		     enddo
C-----------------------------------------------------------------------
C THE NEXT WORD SHOULD BE EITHER KEYWORD "ESTIMATE","LOGGAMMA" OR "NORMAL"
C           OR "MULTINOR(MAL)" OR "MOMENTS"
C-----------------------------------------------------------------------
             LL=0
 8328        wn=wn+1
             WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C The following case was added on April 3, 2000 thanks to Anki Roxstrom
             IF (ISAME(0).NE.0.AND.LL.EQ.0) THEN
               DO 8327 K=1,NCOVMOD
                 IF (LABEL(IMOD(K)).EQ.WNEXT.AND.
     +                   ISAME(IMOD(K)).EQ.JJ) LL=K
 8327          CONTINUE
               IF (LL.NE.0) THEN
                 INOR(LL,1)=1
                 GOTO 8328
               ENDIF
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
             IF (WORD(1,wn).EQ.';'.OR.(WNEXT.NE.KEYWORD(32).AND.
     +            WNEXT.NE.KEYWORD(33).AND.WNEXT.NE.KEYWORD(34).AND.
     +             WNEXT.NE.KEYWORD(38).AND.WNEXT.NE.KEYWORD(39))) THEN
                  WRITE(6,9440) EFFECT
 9440             FORMAT(1X,' NO DISTRIBUTION WAS SPECIFIED FOR',
     +            ' EFFECT ',A8,1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
C-----------------------------------------------------------------------
C THE NEXT WORD IS "ESTIMATE"
C-----------------------------------------------------------------------
             IF (WNEXT.EQ.KEYWORD(38)) THEN
               IPEST=1
               NPEST = NPEST +1
               GOTO 8328
             ENDIF
C-----------------------------------------------------------------------
C THE NEXT WORD IS "MOMENTS"
C-----------------------------------------------------------------------
             IF (WNEXT.EQ.KEYWORD(39)) THEN
               IF (NPEST.EQ.0) THEN
                 WRITE(6,8329) EFFECT
 8329            FORMAT(1X,' KEYWORD "MOMENTS" WAS SPECIFIED FOR',
     +            ' EFFECT ',A8,/1X,' IT SHOULD APPEAR AFTER KEYWORD ',
     +            '"ESTIMATE"',/1X,' CHECK PARAMETER FILE')
                 STOP
               ENDIF
               NPEST=99+NPEST
               GOTO 8328
             ENDIF
C-----------------------------------------------------------------------
C THE NEXT WORD IS "MULTINOR(MAL)"
C   IT SHOULD BE FOLLOWED BY THE RULES TO APPLY TO CONSTRUCT A-1
C   EITHER 'USUAL_RU(LES)' OR 'MGS_RULE(S)' OR 'SIRE_DAM(_MODEL)'
C-----------------------------------------------------------------------
             IF (WNEXT.EQ.KEYWORD(34)) THEN
                  wn=wn+1
                  IF (file(4).eq.'               ') then
                   WRITE(6,9458)
 9458               FORMAT(1X,' NO PEDIGREE FILE WAS SPECIFIED ',/
     +              1X,' CHECK PARAMETER FILE')
                   STOP
                  ENDIF
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS A KEYWORD
C-----------------------------------------------------------------------
                  WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +                //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
                  IF (WNEXT.EQ.KEYWORD(35)) THEN
                   NRULE=1
                  ELSE IF (WNEXT.EQ.KEYWORD(36)) THEN
                   NRULE=2
                  ELSE IF (WNEXT.EQ.KEYWORD(37)) THEN
C   (change on April 19 2000: make SIRE_DAM_MODEL obsolete)
c                   NRULE=3
                    WRITE(6,8351)
 8351               FORMAT(1X,' THE KEYWORD "SIRE_DAM_MODEL" IS NOW ',
     +              'OBSOLETE ',
     +              /1X,' USE JOINCODE IN prepare.f INSTEAD ')
                   STOP
                  ELSE
                   WRITE(6,9441) EFFECT
 9441               FORMAT(1X,' NO RULE WAS SPECIFIED FOR ',
     +              'CONSTRUCTING THE RELATIONSHIP MATRIX FOR EFFECT ',
     +              A8,1X,' CHECK PARAMETER FILE')
                   STOP
                  ENDIF
                  IF (NRULE.GT.0) THEN
                   NRELMAT = 0
                   DO 86 K=1,NCOVMOD
                   IF (IMOD(K).EQ.JJ) NRELMAT = K
   86               CONTINUE
                   NRELMAT2 = JJ
                  ENDIF
             ENDIF
C
C-----------------------------------------------------------------------
C IF IPEST=0 THEN
C    THE NEXT FIGURE INDICATES THE VARIANCE TO BE USED
C ELSE
C    THE NEXT THREE FIGURES INDICATE THE LOWER AND THE UPPER BOUNDS
C    FOR THE PARAMETER TO BE ESTIMATED AND THE MAXIMUM WIDTH OF THE
C    INTERVAL WHICH WILL BRACKET THE TRUE VALUE
C-----------------------------------------------------------------------
             IF (IPEST.EQ.0) THEN
                IF ((NFIG(wn).EQ.0).OR.(NFIG(wn).GT.1)) THEN
                  WRITE(6,8360) EFFECT
 8360             FORMAT(1X,' NO VARIANCE PARAMETER WAS SPECIFIED FOR',
     +            ' EFFECT ',A8,' OR TOO MANY PARAMETERS',
     +            /1X,' CHECK PARAMETER FILE')
                  STOP
               ENDIF
             ENDIF
             IF (NFIG(wn).NE.3.AND.NFIG(wn).NE.1) THEN
                WRITE(6,8362) EFFECT
 8362           FORMAT(1X,' TO ESTIMATE THE VARIANCE PARAMETER ',
     +          'FOR EFFECT ',A8,' THE FOLLOWING INFORMATION ',/1x,
     +          'IS REQUIRED AFTER THE DISTRIBUTION SPECIFICATION',
     +          /1X,'AND AFTER THE RULES TO CONSTRUCT THE RELATIONSHIP',
     +          ' MATRIX (IF APPLICABLE):',/1X,' LOWER BOUND, UPPER',
     +          ' BOUND AND DESIRED MAXIMUM WIDTH OF THE INTERVAL',
     +          ' OF THE ESTIMATE (=3 VALUES)',/
     +          1X,' CHECK PARAMETER FILE')
                STOP
             ENDIF
             IF (ICOVTYP(JJ).NE.1) THEN
                  WRITE(6,8370) EFFECT
 8370           FORMAT(1X,' EFFECT ',A8,' IS DECLARED AS A CONTINUOUS',
     +       ' COVARIATE AND SHOULD NOT APPEAR IN THE RANDOM STATEMENT',
     +            /1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
             IF (WNEXT.EQ.KEYWORD(32)) THEN
                IGAM(0,1) = IGAM(0,1) + 1
                IGAM(JJ,1) = 1+IPEST
c               IF (IPEST.EQ.0) THEN
                  IF (XFIG(LFIG(wn)).NE.0.) THEN
                    XGAM(JJ) = XFIG(LFIG(wn))
                  ELSE
                    XGAM(JJ) = DBLE(IFIG(LFIG(wn)))
                  ENDIF
c               ENDIF
             ENDIF
             IF (WNEXT.EQ.KEYWORD(33).OR.WNEXT.EQ.KEYWORD(35)
     +          .OR.WNEXT.EQ.KEYWORD(36).OR.WNEXT.EQ.KEYWORD(37)) THEN
                  INOR(0,1) = INOR(0,1) + 1
                  INOR(JJ,1) = 1+IPEST
c                 IF (IPEST.EQ.0) THEN
                    IF (NFIG(wn).EQ.1) THEN
                      IF (XFIG(LFIG(wn)).NE.0.) THEN
                        XNOR(JJ) = XFIG(lfig(wn))
                      ELSE
                        XNOR(JJ) = DBLE(IFIG(LFIG(wn)))
                      ENDIF
                    ENDIF
c                 ENDIF
             ENDIF
             IF (IPEST.GT.0.AND.NFIG(wn).EQ.3) THEN
                DO 2305 K=LFIG(wn),LFIG(wn)+2
                  print*,'BOUND',JJ,K
                  IF (XFIG(K).GT.0.D0) THEN
                     BOUND(JJ,K-LFIG(wn)+1)= XFIG(K)
                  ELSE
                     BOUND(JJ,K-LFIG(wn)+1)= DBLE(IFIG(K))
                  ENDIF
 2305           CONTINUE
                IF (BOUND(JJ,1).GT.BOUND(JJ,2)) THEN
                  W = BOUND(JJ,2)
                  BOUND(JJ,2) = BOUND(JJ,1)
                  BOUND(JJ,1) = W
                ENDIF
                IF (BOUND(JJ,1).LE.0.D0) THEN
                  WRITE(6,8374) EFFECT
 8374           FORMAT(1X,' INCORRECT LOWER BOUND (<=0) FOR THE ',
     +         'ESTIMATION OF THE VARIANCE PARAMETER FOR EFFECT ',A8,
     +            /1X,' CHECK PARAMETER FILE')
                  STOP
                ENDIF
                IF (IGAM(JJ,1).GE.1) THEN
                  XGAM(JJ)= BOUND(JJ,2)
                ELSE
                  XNOR(JJ) = BOUND(JJ,1)
                ENDIF
             ENDIF
             GOTO 80
             ENDIF

C-----------------------------------------------------------------------
C        *  KEYWORD =  CONVERGE(NCE_CRITERION)
C kn =40 *  COLUMN WHERE THE IDENTIFICATION OF THE ANIMALS IS STORED
C-----------------------------------------------------------------------
             IF (kn.EQ.40) THEN
               IF ((WORD(1,wn+1).NE.';').OR.(NFIG(wn).NE.1)) THEN
                WRITE(6,8250)
 8250           FORMAT(1X,' ERROR IN THE "CONVERGENCE_CRITERION"',
     +          ' STATEMENT',/1X,'SHOULD BE FOLLOWED BY ONE FIGURE ONLY'
     +          ,' OR THERE IS A SEMI-COLON MISSING',
     +            /1X,' CHECK PARAMETER FILE')
                  STOP
               ENDIF
               IF (XFIG(LFIG(wn)).NE.0.) THEN
                 EPS_BF = XFIG(LFIG(wn))
               ELSE
                 EPS_BF = DBLE(IFIG(LFIG(wn)))
               ENDIF
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = STORE_BI(NARY)
C kn =41 *  THE MAIN INPUT FILE IS READ AS A FREE FORMATTED FILE AND
C        *  IS THEN WRITTEN AS A BINARY FILE WITH NAME = INITIAL NAME
C        *   + ".bin" (FOR FAST I/O when used later)
C-----------------------------------------------------------------------
             IF (kn.EQ.41) THEN
               NBIN=100
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = READ_BIN(ARY)
C kn =42 *  THE MAIN INPUT FILE IS READ AS A BINARY FILE (FOR FAST I/O)
C-----------------------------------------------------------------------
             IF (kn.EQ.42) THEN
               NBIN=1
               IOMODE=3
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD = ID
C kn =43 *  COLUMN WHERE THE IDENTIFICATION OF THE ANIMALS IS STORED
C-----------------------------------------------------------------------
             IF (kn.EQ.43) THEN
             NID = IFIG(LFIG(wn))
             IF ((WORD(1,wn+1).NE.';').OR.(NFIG(wn).NE.1)) THEN
                   WRITE(6,9375)
 9375           FORMAT(1X,' ERROR IN THE "ID "',
     +          ' STATEMENT',/1X,'SHOULD BE FOLLOWED BY ONE FIGURE ONLY'
     +            ,' OR THERE IS A SEMI-COLON MISSING',
     +            /1X,' CHECK PARAMETER FILE')
                   STOP
             ENDIF
             wn = wn+1
             GOTO 35
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C The following cases were added on October 21, 1996
C-----------------------------------------------------------------------
C        *  KEYWORD =  RHO_FIXED, DENSE_HESSIAN
C kn =44 *  THESE ARE KEYWORDS FOR THE WEIBULL PROGRAM ONLY ==> IGNORE
C  TO 45 *
C-----------------------------------------------------------------------
             IF (kn.GE.44.AND.kn.LE.45) THEN
               WRITE(6,8290) KEYWORD(kn)
 8290          FORMAT(1X,' THE KEYWORD ',A8,
     +          ' IS VALID WITH THE WEIBULL PROGRAM ONLY'
     +            /1X,' IT WILL BE IGNORED')
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        *  KEYWORD =  INTEGRATE_OUT, JOINT_MODE, INCLUDE_ONLY
C kn =46 *  THESE ARE KEYWORDS FOR THE WEIBULL PROGRAM ONLY ==> STOP
C  TO 51 *
C-----------------------------------------------------------------------
             IF (kn.GE.46.AND.kn.LE.51) THEN
               WRITE(6,8292) KEYWORD(kn)
 8292          FORMAT(1X,' THE KEYWORD ',A8,
     +          ' IS VALID WITH THE WEIBULL PROGRAM ONLY'
     +            /1X,' CHECK PARAMETER FILE')
               STOP
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C The following case was added on November 26, 1996
C-----------------------------------------------------------------------
C         *  KEYWORD = JOINCODE
C kn = 52 *  FOR SIRE - MGS MODELS : SIRES and MGS (for example)
C         *       are recoded together from 1 to n in prepare.f
C-----------------------------------------------------------------------
             IF (kn.EQ.52) THEN
               JJ2=0
 2360          wn=wn+1
               IF (WORD(1,wn).EQ.';') GOTO 35
               EFFECT =
     +           WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)//
     +           WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
               JJ=0
               DO 2362 LL=1,NCOVREAD
                 IF (LABEL(LL).EQ.EFFECT) JJ = LL
 2362          CONTINUE
               IF (JJ.EQ.0) THEN
                  WRITE(6,9403) EFFECT
 9403             FORMAT(1X,' ERROR IN THE "JOINCODE"',
     +            ' STATEMENT',/1X,' THE LABEL ',A8,
     +            ' WAS NOT FOUND IN THE LIST OF COVARIATES')
                   STOP
               ENDIF
               IF (JJ2.EQ.0) THEN
                 JJ2=JJ
                 GOTO 2360
               ELSE IF (WORD(1,wn+1).NE.';') THEN
                 WRITE(6,9405)
 9405            FORMAT(1X,' ERROR IN THE "JOINCODE" STATEMENT ',
     +           /1X,' THE KEYWORD SHOULD BE FOLLOWED BY THE NAME ',
     +           'OF TWO VARIABLES ',
     +           /1X,' IT IS LIKELY TO BE AN ERROR IN THE "PREPARE"',
     +           ' PROGRAM')
                 STOP
               ENDIF
               ISAME(0)=1
               ISAME(JJ)=JJ2
               wn = wn+1
               GOTO 35
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C The following case was added on November 26, 1996
C-----------------------------------------------------------------------
C         *  KEYWORD = COEFFICI(ENT)
C kn = 53 *  GIVES THE COEFFICIENT TO APPLY TO A PARTICULAR EFFECT
C         *  EXAMPLE: 0.5 TO MGS IN SIRE - MGS MODELS
C-----------------------------------------------------------------------
           IF (kn.EQ.53) THEN
             wn=wn+1
C-----------------------------------------------------------------------
C  CHECK THAT THE NEXT WORD IS NOT ';' NOR A KEYWORD
C-----------------------------------------------------------------------
 2363        IF (WORD(1,wn).EQ.';') GOTO 35
             WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +              //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
             EFFECT = WNEXT
             DO 2364 K=1,NKEYC
              IF (WNEXT.EQ.KEYWORD(K)) THEN
                WRITE(6,9408) WNEXT
 9408           FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE COEFFICIENT',
     +          '  STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +          1X,' CHECK PARAMETER FILE')
                STOP
              ENDIF
 2364       CONTINUE
C-----------------------------------------------------------------------
C 'WNEXT'IS NOT A KEYWORD => IT'S A COVARIATE LABEL; MUST BE IN 'LABEL()'
C-----------------------------------------------------------------------
             JJ = 0
             DO 2366 K=1,NCOVREAD
               IF (WNEXT.EQ.LABEL(K)) JJ = K
 2366        CONTINUE
             IF (JJ.EQ.0) THEN
               WRITE(6,9411) WNEXT
 9411          FORMAT(1X,'LABEL ',A8,' USED IN THE COEFFICIENT ',
     +          ' STATEMENT WAS NOT FOUND IN THE COVARIATE LIST',/
     +          1X,' CHECK PARAMETER FILE')
               STOP
             ENDIF
C-----------------------------------------------------------------------
C 'WNEXT'IS A COVARIATE LABEL; MUST BE IN THE MODEL: INCLUD()=1
C-----------------------------------------------------------------------
             do i=1, ncovread
                if (WNEXT.eq.LABEL(i) .and. includ(i).ne.1) then
                  WRITE(6,9437) WNEXT
 9437             FORMAT(1X,'LABEL ',A8,' USED IN THE COEFFICIENT',
     +            ' STATEMENT WAS NOT FOUND IN THE MODEL',/
     +               1X,' CHECK THE PARAMETER FILE')
                  stop
		        endif
		     enddo
C             IF ((WORD(1,wn+1).NE.';').OR.(NFIG(wn).NE.1)) THEN
             IF (NFIG(wn).NE.1) THEN
              WRITE(6,9413)
 9413         FORMAT(1X,' ERROR IN THE "COEFFICIENT"',
     +          ' STATEMENT',/1X,'SHOULD BE FOLLOWED BY A COVARIATE',
     +          ' NAME AND THEN ONE FIGURE ONLY',
     +            /1X,' CHECK PARAMETER FILE')
                  STOP
               ENDIF
               NCOEF(0)=NCOEF(0)+1
               NCOEF(NCOEF(0))=JJ
               IF (XFIG(LFIG(wn)).NE.0.) THEN
                 YCOEF(JJ) = DBLE(XFIG(LFIG(wn)))
               ELSE
                 YCOEF(JJ) = DBLE(IFIG(LFIG(wn)))
               ENDIF
               wn = wn+1
               GOTO 2363
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C The following cases were added on December 12, 1996
C-----------------------------------------------------------------------
C         *  KEYWORD = FREE_FORMAT
C kn = 54 *  SPECIFIES THAT THE DATA FILE (AND FUTURE FILE) IS (ARE) IN
C         *  FREE FORMAT
C         *  KEYWORD = FIXED_FORMAT
C kn = 55 *  SPECIFIES THAT THE DATA FILE (AND FUTURE FILE) IS (ARE) IN
C         *  FIXED FORMAT
C-----------------------------------------------------------------------
             IF (kn.EQ.54.OR.kn.EQ.55) THEN
               IOMODE=1
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         *  KEYWORD = UNFORMATTED
C kn = 56 *  SPECIFIES THAT THE DATA FILE (AND FUTURE FILE) IS (ARE)
C         *  UNFORMATTED (BINARY)
C-----------------------------------------------------------------------
             IF (kn.EQ.56) THEN
               IOMODE=2
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         *  KEYWORD = BLOCKED_UNFORMATTED
C kn = 57 *  SPECIFIES THAT THE DATA FILE (AND FUTURE FILE) IS (ARE)
C         *  UNFORMATTED (BINARY) AND WRITTEN BY BLOCK OF RECORDS
C         *  WARNING : THIS PREVENTS FROM SORTING THE DATA FILE
C-----------------------------------------------------------------------
             IF (kn.EQ.57) THEN
               IOMODE=3
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         *  KEYWORD = COMPRESSED
C kn = 58 *  SPECIFIES THAT THE DATA FILE (AND FUTURE FILE) IS (ARE)
C         *  UNFORMATTED (BINARY), WRITTEN BY BLOCK OF gz
C         *       COMPRESSED RECORDS
C         *  NOT ACCEPTED WITH THIS VERSION OF COX
C-----------------------------------------------------------------------
             IF (kn.EQ.58) THEN
               WRITE(6,9415) WNEXT
 9415          FORMAT(1X,A8,' NOT ACCEPTED WITH COX ',
     +          /1X,' CHECK PARAMETER FILE')
               STOP
c               IOMODE=4
c               wn = wn+1
c               GOTO 35
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


C-----------------------------------------------------------------------
C        *  KEYWORD = files
C kn =60 *  reads the name of >=3 (up to 6) files
C----------------------------------------------------------------------
c it has the following form:
c
c files filename1 filename2 filename3 (filename4 filename7 filename8);
c
c where
c filename1 is the name of the recoded data file (must exist in your
c           directory)
c filename2 is the name of the file containing the original and new
c           codes for each class effect.
c filename3 is the name of the output file
c filename4 is the (recoded) pedigree file (if needed)
c filename7 is the name of the file including old solutions
c filename8 is the name of the file including new solutions
c
C**********************************************************************
             IF (kn.EQ.60) THEN
C
             DO 391 K=1,8
                  FILE(K)='                                          '
  391          CONTINUE
c----------------------------------------------------------------------
c PROCESS THE 3 / 4 / 6 FILE NAMES
c----------------------------------------------------------------------
             DO 393 K=1,6
               wn=wn+1
               KK=K
               IF (K.GE.5) KK=K+2
c----------------------------------------------------------------------
c READ NAME OF VARIABLE
c----------------------------------------------------------------------
                  WNEXT=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +            //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
C----------------------------------------------------------------------
c CHECK IF NEW KEYWORD APPEARS BEFORE END OF STATEMENT
c----------------------------------------------------------------------
             IF (WORD(1,wn).EQ.';') THEN
                   IF (K.GE.4) THEN
                   GOTO 35
                   ELSE
                   WRITE(6,9450) K
9450                 FORMAT(1X,' ERROR IN THE "file"',
     +            ' STATEMENT',/1X,' ONLY ',I3,' FILES NAMES READ',/1X
     +               ,' THERE MAY BE A SEMI-COLON MISSING',
     +               /1X,' CHECK PARAMETER FILE')
                   STOP
                   ENDIF
             ENDIF
             DO 397 JJ=1,NKEYC
                   IF (WNEXT.EQ.KEYWORD(JJ)) THEN
                   WRITE(6,9452) WNEXT
 9452                FORMAT(1X,'KEYWORD ',A8,' FOUND IN THE FILES',
     +              '  STATEMENT',/1X,' THERE IS A SEMI-COLON MISSING',
     +               1X,' CHECK PARAMETER FILE')
                   STOP
                   ENDIF
  397            CONTINUE
C----------------------------------------------------------------------
                 FILENAM=' '
                 IW=0
                 DO 394 JJ=1,MAXLENG
                   IF (WORD(JJ,wn).EQ.' ') IW=1
                   IF (IW.EQ.1) GOTO 394
                   TEMPDIR2(JJ) = WORD(JJ,wn)
  394            CONTINUE
                 FILE(KK)= FILENAM
  393           CONTINUE
C----------------------------------------------------------------------
C NEXT WORD HAS TO BE ';'
c----------------------------------------------------------------------
             wn=wn+1
             IF (WORD(1,wn).NE.';') THEN
             WRITE(*,9454)
 9454            FORMAT(1X,'ERROR IN FILES STATEMENT'/
     +           1X,'ONLY 6 ARGUMENTS TO STATEMENT ADMISSIBLE'/
     +           1X,'CHECK PARAMETER FILE')
             STOP
             ENDIF
             goto 35
             endif
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C The following case was added on January 22, 1999
C-----------------------------------------------------------------------
C         *  KEYWORD = DISCRETE_SCALE
C kn = 61 *  THIS KEYWORD IS FOR THE WEIBULL PROGRAM ONLY ==> STOP
C-----------------------------------------------------------------------
             IF (kn.EQ.61) THEN
               WRITE(6,8297) KEYWORD(kn)
 8297          FORMAT(1X,' THE KEYWORD ',A8,
     +          ' IS VALID WITH THE WEIBULL PROGRAM ONLY'
     +            /1X,' COMMENT IT OUT FROM THE FIRST PARAMETER FILE',
     +            /1X,' OR USE WEIBULL')
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NTIMMAX
C kn = 62 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.62) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NSTIMAX
C kn = 63 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.63) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NVEC_BF
C kn = 64 * default value in MODULE PARINCLU MVEC_BF
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.64) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NPGAUSS
C kn = 65 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.65) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NITER_GA(USS)
C kn = 66 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.66) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NRECMAX
C kn = 67 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.67) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NLEVMAX
C kn = 68 * default value in MODULE PARINCLU MXEF
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.68) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NSTRAMAX
C kn = 69 * default value in MODULE PARINCLU MXSTRA
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.69) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NDIMAX
C kn = 70 * default value in MODULE PARINCLU
C         * with keyword in the parameter file it is changable by user
C-----------------------------------------------------------------------		   
             IF (kn.EQ.70) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = NO_HESSI(AN)
C kn = 71 * default value at beginning of main
C         * sets NDIMAX2=1 i.e. Hessian martix not needed
C-----------------------------------------------------------------------
             IF (kn.EQ.71) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = LOGFILE
C kn = 72 * specifies if the name of the output file should be given at
C         *   runtime or pre-specified by the user in the parameter file
C         * interacts with variables SUPPLY_OUTPUT and parmout
C-----------------------------------------------------------------------
             IF (kn.EQ.72) THEN
                 if (outflag.eq.0) wn = wn+1
                 if (outflag.eq.1) wn = wn+2
                 GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = USE_R 
C kn = 73 * specifies if the user wants to use the R interface (available 
C         *   from v6.07. This creates additional files which can be 
C         *   plotted using the R function
C-----------------------------------------------------------------------
             IF (kn.EQ.73) THEN
                 wn = wn+1
                 GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = CORRELAT(ION)
C kn = 74 *  in case of two correlated RANDOM effects
C         *  
C-----------------------------------------------------------------------
             IF (kn.EQ.74) THEN
c flag variable for the CORRELATION
            corrflag=.true.
c check if appears after RANDOM statement
            if (rndflag) then
               WRITE(6,9555)
 9555          FORMAT(1X,' Error in the CORRELATION statement',
     +               /1X,' It should appear after RANDOM statement',
     +               /1X,' Check parameter file')
               STOP
            endif
c Check if the names of two corelated random effects appear
         IF (WORD(1,wn+1).EQ.';' .or. WORD(1,wn+2).EQ.';') THEN
             WRITE(6,9556)
 9556        FORMAT(1X,' Error in the CORRELATION statement',
     +             /1X,' The names of the 2 correlated random',
     +             /1X,' effects shoud be specified',
     +             /1X,' Check parameter file')
             STOP
         ENDIF
c Reads in the first correlated random effect
       wn=wn+1	
       crndeff(1)=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +     //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
c Reads in the second correlated random effect
       wn=wn+1	
       crndeff(2)=WORD(1,wn)//WORD(2,wn)//WORD(3,wn)//WORD(4,wn)
     +     //WORD(5,wn)//WORD(6,wn)//WORD(7,wn)//WORD(8,wn)
! variable not in the covariate list
           do i=1,2
             JJ = 0
             DO K=1,NCOVREAD
               IF (crndeff(i).EQ.LABEL(K)) then
		 JJ = K
               endif
             ENDDO
             IF (JJ.EQ.0) THEN
                WRITE(6,9439) crndeff(i)
 9439           FORMAT(1X,'LABEL ',A8,' USED FOR THE CORRELATION',/
     +         1X,' STATEMENT WAS NOT FOUND IN THE COVARIATE LIST',/
     +         1X,' CHECK PARAMETER FILE')
                  STOP
             ENDIF
           enddo
! initialize matrix
       do j=1,2
        do i=1,MAXRAND
            ICORR(i,j)=0
        enddo
       enddo
! finds if the variable in the CORRELATION statement is normally distributed
!  if yes, assigns its position to ICORR(), otherwise prints error message	   
       do j=1,2
        do i=1,MAXRAND
  ! not a (MULTI)NORMAL distribution for the random variable
          if (crndeff(j).eq.label(i) .and. INOR(i,1).eq. 0) then
             WRITE(6,9438) crndeff(j)
 9438        FORMAT(1X,'VARIABLE ',A8,' USED IN THE CORRELATION',/
     +         1X,' IS NOT A RANDOM EFFECT WITH NORMAL DISTRIBUTION',/
     +         1X,' CHECK THE PARAMETER FILE')
                  stop
          endif
  ! everything ok, assigns the value
  !  in the first cycle stores the value in a temporary variable
	      if (j.eq.1 .and. crndeff(j).eq.label(i) .and. 
     +    INOR(i,1).ge.1) then
              firstVal = i
          endif	
  !  in the second cycle writes out values to ICORR()
	      if (j.eq.2 .and. crndeff(j).eq.label(i) .and. 
     +    INOR(i,1).ge.1) then
            larger=max(firstVal,i)
            smaller=min(firstVal,i)
! the IDEL should be positive in FCOX, so specific positions are forced
! IDEL positive in this case
              ICORR(smaller,1)=smaller
              ICORR(larger,1)=-larger
              ICORR(smaller,2)=larger
              ICORR(larger,2)=smaller

          endif	
        enddo
       enddo

c checks whether the next word is 'ESTIMATE'
          wn1=wn+1
          WNEXT=WORD(1,wn1)//WORD(2,wn1)//WORD(3,wn1)//WORD(4,wn1)
     +      //WORD(5,wn1)//WORD(6,wn1)//WORD(7,wn1)//WORD(8,wn1)
C-----------------------------------------------------------------------
C THE NEXT WORD IS "ESTIMATE"
C-----------------------------------------------------------------------
             IF (WNEXT.EQ.KEYWORD(38)) THEN
               estcor=.true. 
               NPEST = NPEST +1
               wn=wn+1
             ENDIF
c reads in new value specified by user
         if (nfig(wn) .gt. 0) then
             actual = lfig(wn)
             if (xfig(actual) .ne. 0.d0) then
                 corr = xfig(actual)
c                 print*,'The CORRELATION was set to ',corr
             endif
         endif
c the value entered must be between (-1,1)
            if (corr.le.-1.d0 .or. corr.ge.1.d0) then
               WRITE(6,9557)
 9557          FORMAT(1X,' The value in the CORRELATION statement',
     +               /1X,' should be between -1 and 1 ',
     +               /1X,' Check parameter file')
               STOP
            endif
c next word has to be ";"
         IF (WORD(1,wn+1).NE.';') THEN
             WRITE(6,9510)
 9510        FORMAT(1X,' Error in the CORRELATION statement',
     +             /1X,' There is a semi-colon missing',
     +             /1X,' Check parameter file')
             STOP
         ENDIF
!!!!!
! using the correlation specified by the user
! first we assume that the correlation is known
!!!!!
! transformation the value of corr (-1,1) to a value between +-infinity
        zeta=log((1-corr)/(2*(1+corr)))
      
!!!!!
                 wn = wn+1
                 GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C         * KEYWORD = PRECISIO(N)
C kn = 75 * This keyword is to increase or decrease the precision of 
C         *  the variance of the random effects when using the simplex 
C         *  subroutine AND the estimated correlation coefficient when 
C         *  estimating correlated random effects. At the same time it 
C         *  also increases or decreases computional time. 
C         *  Permitted real numbers are between 0 and 100, with values below 
C         *  and above 1 increasing/decreasing the precision. If you going 
C         *  to estimate the correlaton coefficient, DO NOT decrease the 
C         *  precision more than 10 times, preferably not at all, 
C         *  as this would lead to incorrect results. 
C         *  Use this keyword at your own risk.
C
C  variance:    DELMIN(NPARMI)=0.0001*(1.d0/precorr_mul)
C  correlation: DELMIN(NPARMI)=0.01*(1.d0/precorr_mul)
C
C Values above 1 increase precision, values below 1 decrease precision. 
C Usage: PRECISION value;
C-----------------------------------------------------------------------
             IF (kn.EQ.75) THEN
               wn = wn+1
               GOTO 35
             ENDIF
C-----------------------------------------------------------------------
C        * KEYWORD = 
C kn =   *
C-----------------------------------------------------------------------
       ENDIF
   30    CONTINUE
      ENDIF
      IF (IFOUND.EQ.0) THEN
       WRITE(6,9600) BEG
 9600   FORMAT(1X,' ERROR : STATEMENT ',A8,' IS NOT RECOGNIZED',
     +             /1X,' CHECK PARAMETER FILE')
       STOP
      ENDIF
C
C-----------------------------------------------------------------------
C  REORDER APPROPRIATE VECTORS
C-----------------------------------------------------------------------
      IFAIL = 0
      IF (NSTIME.GT.0) CALL  JSORT(ISTIME,NSTIME,ISTIME,IWORK,'A')
C formerly   M01CBF(ISTIME,1,NSTIME,'A',IFAIL)
      IF (NQUANT.GT.0) CALL XSORT(SQUANT,NQUANT,SQUANT,IWORK,'D')
C formerly M01CAF(SQUANT,1,NQUANT,'D',IFAIL)
C
C-----------------------------------------------------------------------
C  PRINT GENERAL CHARACTERISTICS IN 'RUNLOG' FILE (= UNIT 6)
C      + IN 'RESULTS' FILE (= UNIT 12)
C      + IN 'RESULTS FOR FUTURE RECORDS' FILE (= UNIT 13) IF RELEVANT
C-----------------------------------------------------------------------
      IUNIT=6
  92  WRITE(IUNIT,9999)
      WRITE(IUNIT,9000) (TITLE(K),K=1,70)
      WRITE(IUNIT,9999)
      WRITE(IUNIT,9001) (FILE(K),K=1,3)
      IF (NRULE.NE.0) WRITE(IUNIT,9002) FILE(4)
      IF (NOLDS.EQ.2.OR.NOLDS.EQ.3) WRITE(IUNIT,9003) FILE(7)
      IF (NOLDS.EQ.1.OR.NOLDS.EQ.3) WRITE(IUNIT,9004) FILE(8)
      IF (NSURV.EQ.1) WRITE(IUNIT,9006) FILE(5),FILE(6)
      IF (NSURV.EQ.2) WRITE(IUNIT,9007) FILE(5),FILE(6)
      WRITE(IUNIT,9999)
      IF (NSTRATA.LT.1) THEN
        WRITE(IUNIT,9005)
      ELSE
       WRITE(IUNIT,9010) NSTRATA,ICOLSTR
      ENDIF
      WRITE(IUNIT,9015) ICOLTIM,ICOLCOD
      IF (NID.NE.0) WRITE(IUNIT,9016) NID
      J=NCOVREAD-NCCOV-NDCOV+NPOW
      WRITE(IUNIT,9020) NCOVREAD,NCCOV,NDCOV,J,NPOW
      IF (NCCOV.NE.0) WRITE(IUNIT,9206)
      IF (IUNIT.EQ.6) THEN
       IUNIT = 12
       OPEN(12,file=file(3),status='unknown',form='formatted',
     +            recl=132)
       GOTO 92
      ELSE IF (IUNIT.EQ.12.AND.NSURV.NE.0) THEN
       IUNIT = 13
       OPEN(13,file=file(6),status='unknown',form='formatted',
     +            recl=132)
       IF (NSURV.EQ.1) GOTO 92
      ENDIF
C
C-----------------------------------------------------------------------
C  PRINT MODEL SPECIFICATION AND INITIALIZE VECTORS WHICH ARE USED
C  IN SUBROUTINE FCOX : IREAD*, IPLUS*
C  WHERE *=1 FOR CONTINUOUS AND =2 FOR DISCRETE COVARIATES
C-----------------------------------------------------------------------
      J = 0
      IR1=0
      IR2=0
      ITOTSTR=0
      IPRESTR=0
      DO 40 I=1,NCOVREAD+NPOW
       IF ((ICOVTYP(I).LE.0).AND.(INCLUD(I).EQ.1)) THEN
       IF (ITIMDEP(I).EQ.0) THEN
            IR1=IR1+1
            IREAD1(IR1)=IBEF(I)
            ITRAIT1(IR1)=I
            IPLUS1(IR1)=0
       ELSE
            IR1=IR1+1
            IREAD1(IR1)=IBEF(I)
            ITRAIT1(IR1)=I
            IPLUS1(IR1)=1
            IR1=IR1+1
            IREAD1(IR1)=IAFT(I)
            ITRAIT1(IR1)=I
            IPLUS1(IR1)=-1
       ENDIF
       ELSE IF ((ICOVTYP(I).EQ.1).AND.(INCLUD(I).EQ.1)) THEN
       IF (ITIMDEP(I).EQ.0) THEN
            IR2=IR2+1
            IREAD2(IR2)=IBEF(I)
            ITRAIT2(IR2)=I
            IPLUS2(IR2)=0
       ELSE
            IR2=IR2+1
            IREAD2(IR2)=IBEF(I)
            ITRAIT2(IR2)=I
            IPLUS2(IR2)=1
            IR2=IR2+1
            IREAD2(IR2)=IAFT(I)
            ITRAIT2(IR2)=I
            IPLUS2(IR2)=-1
       ENDIF
       ENDIF
   40 CONTINUE
   
       MXEF_USED=ir1+ir2
!GLOBALS
      allocate( blockb%info(3,NRECMAX) )
      allocate( blockb%idata(MXEF_USED,NRECMAX) )
      allocate( blockb%xdata(MXEF_USED,NRECMAX) )
C-----------------------------------------------------------------------
C  PRINT MODEL CHARACTERISTICS IN 'RUNLOG' FILE (= UNIT 8)
C      + IN 'RESULTS' FILE (= UNIT 12)
C      + IN 'RESULTS FOR FUTURE RECORDS' FILE (= UNIT 13) IF RELEVANT
C-----------------------------------------------------------------------
      IUNIT=6
   94 IF (NCOVMOD.EQ.0) WRITE(IUNIT,9029)
      DO 45 J=1,NCOVMOD
       I = IMOD(J)
       IF (ICOVTYP(I).EQ.0) THEN
         IF (ITIMDEP(I).EQ.0) THEN
           WRITE(IUNIT,9030) J,LABEL(I),IBEF(I)
         ELSE
           WRITE(IUNIT,9031) J,LABEL(I),IBEF(I),IAFT(I)
         ENDIF
       ELSE IF (ICOVTYP(I).GT.0) THEN
         IF (ITIMDEP(I).EQ.0) THEN
            WRITE(IUNIT,9032) J,LABEL(I),IBEF(I)
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on November 26, 1996
          IF (ISAME(I).NE.0) THEN
            WRITE(IUNIT,9038) LABEL(I),LABEL(ISAME(I))
            IF (INCLUD(ISAME(I)).EQ.0) THEN
              WRITE(IUNIT,9040) LABEL(I)
              STOP
            ENDIF
            LL=0
            DO 2422 JJ=1,NCOVMOD
              IF (IMOD(JJ).EQ.ISAME(I)) THEN
                JSAME(JJ)=J
                JSAME(J)=JJ
                LL=1
              ENDIF
 2422       CONTINUE
C the variables coded together are not in the model together
            IF (LL.EQ.0) THEN
              ISAME(I)=0
              ISAME(0)=ISAME(0)-1
            ENDIF
          ENDIF
        ELSE
          WRITE(IUNIT,9033) J,LABEL(I),IBEF(I),IAFT(I)
        ENDIF
       ELSE
         II = I - NCOVREAD
         IF (ITIMDEP(I).EQ.0) THEN
         WRITE(IUNIT,9034) J,LABEL(I),IPOW(II,2),LABEL(IPOW(II,1))
         ELSE
         WRITE(IUNIT,9035) J,LABEL(I),IPOW(II,2),LABEL(IPOW(II,1))
         ENDIF
       ENDIF
  45  CONTINUE
      ICOEF(0) = NCOEF(0)
      DO 2424 I=1,NCOEF(0)
        WRITE(IUNIT,9042) LABEL(NCOEF(I)),YCOEF(NCOEF(I))
 2424 CONTINUE
      IF (NOLDS.EQ.2.OR.NOLDS.EQ.3) THEN
          IF (INDEX(FILE(7),' ').LE.1) THEN
            WRITE(6,9055)
            STOP
         ELSE
            WRITE(IUNIT,9065) FILE(7)
          ENDIF
      ENDIF
      IF (NOLDS.EQ.1.OR.NOLDS.EQ.3) THEN
          IF (INDEX(FILE(8),' ').LE.1) THEN
            WRITE(6,9050)
            STOP
          ELSE
            WRITE(IUNIT,9060) FILE(8)
          ENDIF
      ENDIF
      IF (IUNIT.EQ.6) THEN
       IUNIT = 12
       GOTO 94
      ELSE IF (IUNIT.EQ.12.AND.NSURV.NE.0) THEN
       IUNIT = 13
       IF (NSURV.EQ.1) GOTO 94
      ENDIF
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C update vectors used to account for coefficients <>1
C Added on September 26, 1997
      DO 2428 I=1,NCOEF(0)
        LL=0
        DO 2426 J=1,IR2
           IF (LL.NE.0) GOTO 2426
          IF (ITRAIT2(J).EQ.NCOEF(I)) THEN
            JJ = IR1 + J
            XCOEF(JJ)=YCOEF(NCOEF(I))
            NCOEF(I)=JJ
            ICOEF(JJ)=1
            LL=1
          ENDIF
 2426   CONTINUE
 2428 CONTINUE
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C
C-----------------------------------------------------------------------
C FIRST READING OF THE INPUT FILE
C   ==> COMPUTES ELEMENTARY STATISTICS
C  (NUMBER OF CENSORED, UNCENSORED RECORDS...)
C  (MIN, MAX, AVERAGE FOR CONTINUOUS COVAR.; MIN, MAX LEVEL FOR OTHERS)
C   ==> CHECK ORDERING OF ELEMENTARY RECORDS + COUNTS NUMBER OF STRATA
C-----------------------------------------------------------------------
C
      DO 48 I=1,NCOVMOD
       XMA(I)=-1.
       XMI(I)=10000.
       MA(I)=-1
       MI(I)=10000
   48 CONTINUE
      MA2(1) = -1
      MI2(1) = 10000
      MA2(2) = -1
      MI2(2) = 10000
      MA2(3) = -1
      MI2(3) = 10000
C
c      NVAR = NVAR + 2 + MIN(NSTRATA,1)
c      Modified March 1 95
c
      NVAR = NVAR + 2
      IF (NID.NE.0) NVAR = NVAR +1
      NINTEG = NVAR - NINTEG
c
      IF (NVAR.GT.MXEF) THEN
       WRITE(6,9220) NVAR,MXEF
       STOP
      ENDIF
      NREC = 0
      NCEN = 0
      NUNC = 0
      IPRETIM = 0
      IPRECOD = 0
C
C-----------------------------------------------------------------------
C  IF NBIN=100: THE INPUT FILE (2) IS READ AS A FREE FORMATTED FILE
C  AND IMMEDIATELY WRITTEN AS A BINARY FILE (NAMED .bin)
C  FOR FASTER I/O WHEN USED LATER. THEN THE PROGRAM STOPS
C-----------------------------------------------------------------------
      IF (NBIN.EQ.100) THEN
        OPEN(2,file=file(1),status='old',form='formatted')
        FILENAM=file(1)
        I=INDEX(FILENAM,' ')
        TEMPDIR2(I)='.'
        TEMPDIR2(I+1)='b'
        TEMPDIR2(I+2)='i'
        TEMPDIR2(I+3)='n'
        OPEN(4,file=FILENAM,status='unknown',form='unformatted')
	  NRR=0
     	  NRRMAX=NRECMAX
	  LTAB=NRRMAX*MXEF
   90   NRR=NRR+1
	  READ(2,*,END=99) (ITABL(I,NRR),I=1,NINTEG),
     +         (XTABL(I,NRR),I=NINTEG+1,NVAR)
	  NREC=NREC+1
        IF (NRR.EQ.NRRMAX) THEN
	  WRITE(4) NRR,LTAB,(KRR(I),I=1,LTAB)
          NRR=0
	ENDIF
        GOTO 90
C
C LAST RECORD (BLOCK)
C
   99   NRR= NRR-1
	WRITE(4) NRR,LTAB,(KRR(I),I=1,LTAB)
	CLOSE(4)
	CLOSE(2)
C END OF FILE
	WRITE(6,8410) nrec,file(1),FILENAM
 8410   FORMAT(/1X,' FOR FAST I/O IN THE FUTURE, THE ',I7,
     +  ' RECORDS OF THE FREE FORMATTED FILE :',/1X,A70,/1X,
     +  ' HAVE BEEN COPIED INTO A BINARY FILE WITH NAME :',/10X,
     +  A70,/1X,' FOR EFFICIENT USE,',
     +  'START AGAIN THE PROGRAM AFTER REPLACING',/1X,
     +  ' THE "STORE_BINARY" STATEMENT BY "READ_BINARY"',/1X,
     +  ' AND AFTER CORRECTING THE NAME OF THE INPUT FILE',/1X,
     +  ' (THE "OLD" INPUT FILE CAN BE DELETED)')
	STOP
      ENDIF
C
C-----------------------------------------------------------------------
C UNIT 2 = INPUT FILE
C-----------------------------------------------------------------------
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26, 1997
      IF (IOMODE.EQ.1) THEN
        OPEN(2,file=file(1),status='old',form='formatted')
      ELSE IF (IOMODE.EQ.4) THEN
        FILENAM=FILE(1)
C
C THIS VERSION DOES NOT ALLOW THE USE OF THE C SUBROUTINES TO
C READ WRITE AND COMPRESS THE FILES
C ==> STOP
C
        WRITE(6,887)
 887    FORMAT(//1X,' THIS VERSION DOES NOT ALLOW THE USE OF THE ',
     +   'C SUBROUTINES TO',/,
     +   1X,'READ AND WRITE AND COMPRESS FILES ==> STOP')
      STOP
c        CALL f77openr(IDFILE(1),FILENAMC)
c        IERR=1
      ELSE
        OPEN(2,file=FILE(1),status='old',form='unformatted')
      ENDIF
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C
      IF (NSTOR.EQ.0) THEN
        IF (TEMPDIR.EQ.' ') THEN
          FILE(9)='tmp'
          IF (NSURV.GT.0) FILE(10)='tmp2'
        ELSE
          FILENAM=TEMPDIR
          I=INDEX(TEMPDIR,' ')
          TEMPDIR2(I)='/'
          TEMPDIR2(I+1)='t'
          TEMPDIR2(I+2)='m'
          TEMPDIR2(I+3)='p'
          FILE(9)=FILENAM
          IF (NSURV.EQ.0) THEN
            WRITE(6,9425) FILE(9)
          ELSE
            TEMPDIR2(I+4)='2'
            FILE(10)=FILENAM
            IF (NSURV.EQ.1) THEN
              WRITE(6,9426) FILE(9),FILE(10)
            ELSE
              WRITE(6,9427) FILE(9),FILE(10)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C
      NRR=0
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26, 1997
C IOMODE = TYPE OF FILE (FREE or FIXED FORMAT, UNFORMATTED, BLOCKED
C          UNFORMATTED OR COMPRESSED
  100 IF (IOMODE.EQ.1) THEN
        READ(2,*,END=199) (IREC(I),I=1,NINTEG),(REC(I),I=NINTEG+1,NVAR)
      ELSE IF (IOMODE.EQ.2) THEN
        READ(2,END=199) (IREC(I),I=1,NINTEG),(REC(I),I=NINTEG+1,NVAR)
      ELSE
        IF (NRR.EQ.0) THEN
          IF (IOMODE.EQ.3) THEN
c IOMODE = 3 <==> BLOCKED UNFORMATTED
            READ(2,END=199) NRRMAX,LTAB,(KRR(I),I=1,LTAB)
          ENDIF
        ENDIF
        NRR=NRR+1
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        DO 104 I=1,NINTEG
           IREC(I)=ITABL(I,NRR)
  104   CONTINUE
        DO 106 I=NINTEG+1,NVAR
           REC(I)=XTABL(I,NRR)
  106   CONTINUE
        IF (NRR.EQ.NRRMAX) NRR=0
      ENDIF
C
      NREC = NREC + 1
      ITIME=MAX(1,IREC(ICOLTIM))
      ICODE=IREC(ICOLCOD)
      IF (NSTRATA.NE.0) ISTRATA=MAX(IREC(ICOLSTR),1)
      DO 110 I=1,IR1
       TEMP(I)=REC(IREAD1(I))
       IF (ITRAIT1(I).GT.NCOVREAD) THEN
       II= ITRAIT1(I) - NCOVREAD
       II = IPOW(II,2)
       TEMP(I) = TEMP(I) ** II
       ENDIF
  110 CONTINUE
      DO 111 I=1,IR2
       ITEMP(I)=IREC(IREAD2(I))
  111 CONTINUE
C
C-----------------------------------------------------------------------
C CHECK IF NEW STRATUM
C-----------------------------------------------------------------------
      IF (ISTRATA.NE.IPRESTR) THEN
       IPRESTR = ISTRATA
       ITOTSTR = ITOTSTR + 1
       IPRETIM = 0
      ENDIF
C-----------------------------------------------------------------------
C CHECK IF TIMES ARE IN THE RIGHT ORDERING
C-----------------------------------------------------------------------
      IF ((ITIME.GT.IPRETIM).AND.(IPRETIM.NE.0)) THEN
       WRITE(6,9100) ISTRATA,ITIME,IPRETIM
       STOP
      ELSE IF (ITIME.EQ.IPRETIM) THEN
       IF (ICODE.LT.IPRECOD) THEN
       WRITE(6,9110) ISTRATA,ITIME,ICODE,IPRECOD
       STOP
       ENDIF
      ELSE
       IPRETIM = ITIME
       IPRECOD = ICODE
      ENDIF
C-----------------------------------------------------------------------
C
      IF (ICODE.EQ.0) THEN
       MA2(1) = MAX(MA2(1),ITIME)
       MI2(1) = MIN(MI2(1),ITIME)
       XAV2(1) = XAV2(1) + DBLE(ITIME)
       NCEN = NCEN + 1
      ELSE IF (ICODE.GT.0) THEN
       MA2(3) = MAX(MA2(3),ITIME)
       MI2(3) = MIN(MI2(3),ITIME)
       XAV2(3) = XAV2(3) + DBLE(ITIME)
       NUNC = NUNC + 1
      ELSE IF (ICODE.LE.-2) THEN
       MA2(2) = MAX(MA2(2),ITIME)
       MI2(2) = MIN(MI2(2),ITIME)
       XAV2(2) = XAV2(2) + DBLE(ITIME)
       NLEF = NLEF + 1
      ENDIF
C-----------------------------------------------------------------------
C   FOR CONTINUOUS COVARIATES, MIN, MAX, AVER
C   FOR DISCRETE COVARIATES, MIN, MAX
C-----------------------------------------------------------------------
      IF (ICODE.NE.-2) THEN
       DO 120 I=1,IR1
       IF (IPLUS1(I).GE.0) THEN
             J=0
             DO 125 JJ=1,NCOVMOD
               IF (IMOD(JJ).EQ.ITRAIT1(I)) J = JJ
  125        CONTINUE
             W = TEMP(I)
             XMA(J) =MAX(XMA(J),W)
             XMI(J) =MIN(XMI(J),W)
             IF (ICODE.GE.0.) THEN
                XAV(J) = XAV(J) + W
                XSQ(J) = XSQ(J) + W * W
             ENDIF
       ENDIF
  120   CONTINUE
       DO 121 I=1,IR2
! storing position of the two correlated random effects
           if (label(i).eq.crndeff(1)) posCrnd1=i
           if (label(i).eq.crndeff(2)) posCrnd2=i	
! 		   
       IF (IPLUS2(I).GE.0) THEN
             J=0
             DO 126 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT2(I)) J = JJ
  126        CONTINUE
             IW = ITEMP(I)
             MA(J) =MAX(MA(J),IW)
             MI(J) =MIN(MI(J),IW)
		 
       ENDIF
  121   CONTINUE
	
      ENDIF
! if CORRELATED random effects are used, we are interested in all levels in both covariates
! "posCrnd1" and "posCrnd2" are the positions of the two random effects

! TEST THIS !!!  74 -- label() signs "larger" and "smaller" refer to different variables!!! -- corrected??
          if (corrflag) then
            MA(posCrnd1)=MAX(MA(posCrnd1),MA(posCrnd2))
            MI(posCrnd1)=MIN(MI(posCrnd1),MI(posCrnd2))
            MA(posCrnd2)=MA(posCrnd1)
            MI(posCrnd2)=MI(posCrnd1)
			
          endif  
C
      GOTO 100
  199 CLOSE(2)
 
C
C-----------------------------------------------------------------------
C UNIT 9 = PEDIGREE FILE READ
c---------------------------------------------------------------------
      IF (NRELMAT.GT.0) THEN
       OPEN(9,file=file(4),status='old',form='formatted')
       NANI = 1
C
  130   READ(9,*,END=139) (IPEDIG(I,NANI),I=1,4)
       II =IPEDIG(1,NANI)
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 16, 1996
       IF (IPEDIG(1,NANI).LT.0) NUNK= NUNK+1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       MA(NRELMAT) =MAX(MA(NRELMAT),II)
       NANI = NANI + 1
       GOTO 130
  139   CLOSE(9)
       NANI = NANI - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21 , 1996
       MA(NRELMAT) = MA(NRELMAT)+NUNK
       DO 137 I=1,MAXRAND
         IF (ICORR(I,1).NE.0) then
           MA(I) =MA(NRELMAT)
         ENDIF
  137  CONTINUE
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ENDIF
C
C-----------------------------------------------------------------------
C COMPUTE GENERAL STATISTICS
C-----------------------------------------------------------------------
      ITOTSTR = MAX(ITOTSTR,1)
      IF (NCEN.NE.0) XAV2(1) = XAV2(1) / DBLE(NCEN)
      IF (NLEF.NE.0) XAV2(2) = XAV2(2) / DBLE(NLEF)
      IF (NUNC.NE.0) XAV2(3) = XAV2(3) / DBLE(NUNC)
      IW = 0
      NDIM1 = NCCOV
      DO 220 I=1,NCOVREAD + NPOW
       IF (INCLUD(I).EQ.1) THEN
       J=0
       DO 223 JJ=1,NCOVMOD
         IF (IMOD(JJ).EQ.I) J = JJ
  223  CONTINUE
C-----------------------------------------------------------------------
C   STATISTICS FOR CONTINUOUS COVARIATES
C-----------------------------------------------------------------------
       NTOT =NCEN + NUNC
       IF (ICOVTYP(I).LE.0) THEN
            XNUM =DBLE(NTOT)
            XAV(J) = XAV(J) / XNUM
            XSQ(J) = DSQRT((XSQ(J) -XNUM*XAV(J) *XAV(J))/ (XNUM -1.D0))
c             XSQ(J)=1.D0
            IW = IW + 1
            IFIRST(I) = IW
            ILAST(I) = IW
       ELSE
C-----------------------------------------------------------------------
C   STATISTICS FOR DISCRETE COVARIATES
C   IND()= FOR EACH (DISCRETE) COVARIATE, NUMBER OF PRECEDING LEVELS
C                     IN VECTOR 'BETA1'
C-----------------------------------------------------------------------
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c condition added on September 26, 1997
         IF (ISAME(I).EQ.0) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            IFIRST(I) = NDIM1 + 1
            NDIM1 = NDIM1 + MA(J)
            ILAST(I) = NDIM1
         ENDIF
       ENDIF
       ENDIF
  220 CONTINUE
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c  added on September 26, 1997
      IF (ISAME(0).NE.0) THEN
         DO 221 I=1,NCOVREAD
           IF (ISAME(I).NE.0) THEN
              IFIRST(I) = IFIRST(ISAME(I))
              ILAST(I) = ILAST(ISAME(I))
           ENDIF
  221    CONTINUE
      ENDIF
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C-----------------------------------------------------------------------
C   CHARACTERISTICS OF RANDOM COVARIATES
C-----------------------------------------------------------------------
      IF (IGAM(0,1).NE.0) THEN
       DO 240 I=1,NCOVREAD
         IGAM(I,2) = IFIRST(I)
         IGAM(I,3) = ILAST(I)
  240  CONTINUE
      ENDIF
      IF (INOR(0,1).NE.0) THEN
       DO 242 I=1,NCOVREAD
         INOR(I,2) = IFIRST(I)
         INOR(I,3) = ILAST(I)
  242  CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C   UPDATE OF THE PEDIGREE FILE FOR LATER USE
C-----------------------------------------------------------------------
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This whole part was added / modified on October 21, 1996
C IPEDIG(2,K)=-1 <==> IPEDIG(1,K)=group of unknown parents
C IPEDIG(3,K) or IPEDIG(4,K)<0 : parent unknown
C      IF NRULE=2 SIRE-MGS CASE: IC  = 4 SIRE + MGS UNKNOWN
C           = 5  SIRE ONLY   6= MGS ONLY  7= BOTH KNOWN
C-----------------------------------------------------------------------
      IF (NRELMAT2.GT.0) THEN
         IAD = IFIRST(NRELMAT2)-1
         DO 246 K =1,NANI
           IC = 1
           IF (NRULE.EQ.2) IC=4
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  modified on October 21, 1996
           IF (IPEDIG(1,K).GT.0) THEN
               IPEDIG(1,K) = IPEDIG(1,K) + IAD
           ELSE
               IPEDIG(1,K) = NANI+1+IPEDIG(1,K) + IAD
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           IF (IPEDIG(3,K).GT.0) THEN
             IPEDIG(3,K) = IPEDIG(3,K) + IAD
             IC = IC + 1
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on October 21, 1996
           ELSE IF (IPEDIG(3,K).LT.0) THEN
             IPEDIG(3,K) = NANI+1+IPEDIG(3,K) + IAD
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           ENDIF
           IF (IPEDIG(4,K).GT.0) THEN
             IPEDIG(4,K) = IPEDIG(4,K) + IAD
             IC = IC + 1
             IF (NRULE.EQ.2) THEN
               IF (IPEDIG(3,K).EQ.0.OR.IPEDIG(3,K).GE.NANI-NUNC) THEN
                 IC = 6
               ELSE
                 IC = 7
               ENDIF
             ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on October 21, 1996
           ELSE IF (IPEDIG(4,K).LT.0) THEN
             IPEDIG(4,K) = NANI+1+IPEDIG(4,K) + IAD
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  modified on October 21, 1996
C  corrected on April 3, 2000 (thanks, Anki !)
           IF (IPEDIG(2,K).GE.0) IPEDIG(2,K) = IC
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  246     CONTINUE
      ENDIF
      IUNIT = 6
      IF (EPS_BF.NE.EPS_BFDEF) THEN
         WRITE(IUNIT,9248) EPS_BF
      ELSE
         WRITE(IUNIT,9249) EPS_BF
      ENDIF
C-----------------------------------------------------------------------
C   PRINT STATISTICS ACCORDING TO CENSORING STATUS IN 'RUNLOG' FILE (=8)
C      + IN 'RESULTS' FILE (= UNIT 12)
C      + IN 'RESULTS FOR FUTURE RECORDS' FILE (= UNIT 13) IF RELEVANT
C-----------------------------------------------------------------------
   96 WRITE(IUNIT,9150) ITOTSTR,NREC
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c corrected on October 16, 1995 (included NLEF)
      LL= NCEN +  NUNC
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      PERC=100.* FLOAT(NCEN)/FLOAT(LL)
      IF (NCEN.GT.0) WRITE(IUNIT,9200) NCEN,PERC,MI2(1),MA2(1),XAV2(1)
      PERC=100.* FLOAT(NLEF)/FLOAT(LL)
      IF (NLEF.GT.0) WRITE(IUNIT,9201) NLEF,PERC,MI2(2),MA2(2),XAV2(2)
      WRITE(IUNIT,9202) NUNC,MI2(3),MA2(3),XAV2(3)
C
      DO 250 J=1,NCOVMOD
       I=IMOD(J)
       IF (ICOVTYP(I).LE.0) THEN
       WRITE(IUNIT,9210) LABEL(I),XMI(J),XMA(J),XAV(J),XSQ(J)
       ELSE
       WRITE(IUNIT,9212) LABEL(I),MI(J),MA(J)
       ENDIF
  250 CONTINUE

  
      WRITE(IUNIT,*) ' '
      IF (IGAM(0,1).NE.0) THEN
       DO 255 JJ=1,NCOVMOD
          I = IMOD(JJ)
          IF (IGAM(I,1).GE.1) WRITE(IUNIT,9265) LABEL(I),XGAM(I)
  255  CONTINUE
      ENDIF
      IF (INOR(0,1).NE.0) THEN
       DO 260 JJ=1,NCOVMOD
         I=IMOD(JJ)
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c condition added on September 26, 1997
         IF (ISAME(I).NE.0) GOTO 260
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         IF (INOR(I,1).GE.1) THEN
           IF (ICORR(I,1).GT.0) THEN
             WRITE(IUNIT,9273) LABEL(I),XNOR(I),
     +          LABEL(ICORR(I,2)),XNOR(ICORR(I,2))
                WRITE(IUNIT,9274) CORR
             IF (NRELMAT.NE.0) THEN
                IF (NRULE.EQ.1) WRITE(IUNIT,9275) NANI
                IF (NRULE.EQ.2) WRITE(IUNIT,9276) NANI
             ENDIF
           ELSE IF (ICORR(I,1).EQ.0) THEN
             WRITE(IUNIT,9270) LABEL(I),XNOR(I)
             IF (NRELMAT.EQ.JJ) THEN
               IF (NRULE.EQ.1) WRITE(IUNIT,9271) NANI
               IF (NRULE.EQ.2) WRITE(IUNIT,9272) NANI
             ENDIF
           ENDIF
           IF (NPEST.EQ.100) WRITE(IUNIT,9290) NPGAUSS
         ENDIF
         IF (BOUND(I,2).GT.0.D0) WRITE(IUNIT,9280) (BOUND(I,J),J=1,3)
  260   CONTINUE
      ENDIF
      IF (IUNIT.EQ.6) THEN
       IUNIT = 12
       GOTO 96
      ELSE IF (IUNIT.EQ.12.AND.NSURV.NE.0) THEN
       IUNIT = 13
       IF (NSURV.EQ.1) GOTO 96
      ENDIF
C-----------------------------------------------------------------------
C   NDIM1 = SIZE OF VECTOR 'BETA1'
C-----------------------------------------------------------------------
       DO 280 J=1,IR2
       KK = ITRAIT2(J)
       IND(J) = IFIRST(KK)-1
  280  CONTINUE
       IF (NDIM1.GT.NDIMAX) THEN
        WRITE(6,9250) NDIM1,NDIMAX
        STOP
       ENDIF
C
C-----------------------------------------------------------------------
C   SECOND READING OF THE INPUT FILE (UNIT = 2)
C   'FINAL' STORAGE OF THE DATA AS USED IN SUBROUTINE FCOX
C      IN CORE IF NSTOR = 1
C      IN WORKING FILE IN UNIT 4 IF NSTOR =0
C-----------------------------------------------------------------------
      NREC=0
      NRECW = 0
      IF (IPRINT.GT.0) WRITE(12,9890)
      IF (NSTOR.NE.1)
     +    OPEN(4,file=FILE(9),FORM='UNFORMATTED')
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26, 1997
      IF (IOMODE.EQ.1) THEN
        OPEN(2,file=file(1),status='old',form='formatted')
c      ELSE IF (IOMODE.EQ.4) THEN
c        FILENAMC=FILE(1)
c        CALL f77openr(IDFILE(1),FILENAMC)
c        IERR=1
      ELSE
        OPEN(2,file=FILE(1),status='old',form='unformatted')
      ENDIF
C
  300 IF (IOMODE.EQ.1) THEN
        READ(2,*,END=399) (IREC(I),I=1,NINTEG),(REC(I),I=NINTEG+1,NVAR)
      ELSE IF (IOMODE.EQ.2) THEN
        READ(2,END=399) (IREC(I),I=1,NINTEG),(REC(I),I=NINTEG+1,NVAR)
      ELSE
	IF (NRR.EQ.0) THEN
          READ(2,END=399) NRRMAX,LTAB,(KRR(I),I=1,LTAB)
        ENDIF
        NRR=NRR+1
        DO 304 I=1,NINTEG
          IREC(I)=ITABL(I,NRR)
  304   CONTINUE
        DO 306 I=NINTEG+1,NVAR
          REC(I)=XTABL(I,NRR)
  306   CONTINUE
        IF (NRR.EQ.NRRMAX) NRR=0
       ENDIF
C
      NREC = NREC + 1
C-----------------------------------------------------------------------
C   VARIABLE 1 = TIME
C   VARIABLE 2 = CODE (1 = UNCENSORED RECORD, 0 = RIGHT CENSORED RECORD
C    -1 = TIME-DEPENDENT COVARIATE CHANGE,
C    -2 = LEFT TRUNCATED RECORD (PARTICULAR CASE OF PREVIOUS SITUATION)
C   VARIABLE 3 = STRATUM
C-----------------------------------------------------------------------
      ICODE = MIN(IREC(ICOLCOD),1)
      blockb%info(1,NREC)=MAX(1,IREC(ICOLTIM))
      blockb%info(2,NREC)=ICODE
      IF (NSTRATA.NE.0) blockb%info(3,NREC)=IREC(ICOLSTR)
      K = 0
      IUZLES=0
C-----------------------------------------------------------------------
C   IR1 FOLLOWING VARIABLES : CONTINUOUS COVARIATES
C        IPLUS1 = 0 FOR TIME-INDEPENDENT COVARIATES
C        IPLUS1 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C        IPLUS1 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C   THE AVERAGE VALUE OF THE CONTINUOUS COVARIATE IS SUBSTRACTED
C   NFAIL = NUMBER OF UNCENSORED FAILURES
C-----------------------------------------------------------------------
      DO 310 I=1,IR1
       IF (IPLUS1(I).GT.0) THEN
       K = K + 1
       IF (ICODE.GT.0) NFAIL(K) = NFAIL(K)+1
       IF (ICODE.GE.-1) THEN
             W = REC(IREAD1(I))
             IF (ITRAIT1(I).GT.NCOVREAD) THEN
             II= ITRAIT1(I) - NCOVREAD
             II = IPOW(II,2)
             W = W ** II
             ENDIF
             JK=0
             DO 311 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT1(I)) JK= JJ
  311        CONTINUE
             blockb%xdata(I,NREC)= (W - XAV(JK))/ XSQ(JK)
       ELSE
             blockb%xdata(I,NREC)= 0.D0
       ENDIF
       ELSE IF (IPLUS1(I).EQ.0) THEN
       K = K + 1
       W = REC(IREAD1(I))
       IF (ITRAIT1(I).GT.NCOVREAD) THEN
             II= ITRAIT1(I) - NCOVREAD
             II = IPOW(II,2)
             W = W ** II
       ENDIF
       JK=0
       DO 312 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT1(I)) JK= JJ
  312      CONTINUE
       blockb%xdata(I,NREC)= (W - XAV(JK))/ XSQ(JK)
       IF (ICODE.GT.0) NFAIL(K) = NFAIL(K)+1
       ELSE
       IF (ICODE.LE.-1) THEN
             W = REC(IREAD1(I))
             IF (ITRAIT1(I).GT.NCOVREAD) THEN
             II= ITRAIT1(I) - NCOVREAD
             II = IPOW(II,2)
             W = W ** II
             ENDIF
             JK=0
             DO 313 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT1(I)) JK= JJ
  313        CONTINUE
             blockb%xdata(I,NREC)= (W - XAV(JK))/ XSQ(JK)
       ELSE
             blockb%xdata(I,NREC)= 0.D0
       ENDIF
       IF (blockb%xdata(I,NREC).NE.blockb%xdata(I-1,NREC))
     + 	   IUZLES=IUZLES+1
       ENDIF
  310 CONTINUE
C-----------------------------------------------------------------------
C   IR2 FOLLOWING VARIABLES : DISCRETE COVARIATES
C        IPLUS2 = 0 FOR TIME-INDEPENDENT COVARIATES
C        IPLUS2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C        IPLUS2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C   THE LEVEL OF EACH EFFECT, INITIALLY NUMBERED 1 TO MAXLEVEL
C            ARE RENUMBERED BY ADDING IND(I)
C   NFAIL = NUMBER OF UNCENSORED FAILURES
C-----------------------------------------------------------------------
      DO 316 I=1,IR2
       II = I + IR1
       IF (IREAD2(I).NE.0) THEN
       K=IREC(IREAD2(I))
       IF (K.GT.0) THEN
           K = IREC(IREAD2(I)) + IND(I)
           IF (ICODE.GT.0) NFAIL(K) = NFAIL(K)+1
       ENDIF
       blockb%idata(II,NREC)=K
       IF (IPLUS2(I).LT.0) THEN
            IF (blockb%idata(II,NREC).NE.blockb%idata(II-1,NREC))
     +          IUZLES=IUZLES+1
       ENDIF
       ENDIF
  316 CONTINUE
      IF (IUZLES.EQ.0.AND.ICODE.EQ.-1) THEN
       NREC = NREC-1
       GOTO 300
      ENDIF
C-----------------------------------------------------------------------
C   PRINT ALL ELEMENTARY RECORDS
C-----------------------------------------------------------------------
C     IF ((IPRINT.GT.0).AND.(IPRINT.GE.NREC)) THEN
      IF (NREC.EQ.1) WRITE(6,*) ' DATA :'
      IF (NREC.LT.10) THEN
c       WRITE(6,*) NREC,(blockb%info(K,NREC),K=1,3),IR1,IR2,
c     +  (blockb%idata(K,NREC),K=1+IR1,IR2+IR1),
c     +  (blockb%xdata(K,NREC),K=1,IR1)
            WRITE(6,*) NREC,' | ',(blockb%info(K,NREC),K=1,3),' | ',
     +  (blockb%idata(K,NREC),K=1+NCCOV,NDCOV+NCCOV),
     +  (blockb%xdata(K,NREC),K=1,NCCOV)
      ENDIF
C
C-----------------------------------------------------------------------
C   STORAGE ON DISK IF NSTOR = 1 AND BLOCK LENGTH = NRECMAX
C   WITH FAST I/O
C-----------------------------------------------------------------------
      IF ((NSTOR.NE.1).AND.(NREC.EQ.NRECMAX)) THEN
        LTAB = (3+MXEF_USED)*NREC
        WRITE(4) NREC,LTAB,
     +  ((blockb%info(i,j),i=1,3),j=1,nrecmax),
     +  ((blockb%idata(i,j),i=1,mxef_used),j=1,nrecmax),
     +	((blockb%xdata(i,j),i=1,mxef_used),j=1,nrecmax)
        NRECW = NRECW + NREC
        NREC=0
      ENDIF
      IF ((NSTOR.EQ.1).AND.(NREC.GT.NRECMAX)) THEN
         WRITE(6,9204) NREC,NRECMAX
         STOP
      ENDIF
C
      GOTO 300
  399 CLOSE(2)
C
C-----------------------------------------------------------------------
C   STORAGE ON DISK IF NSTOR = 1 AND LAST BLOCK
C-----------------------------------------------------------------------
      NRECW = NRECW + NREC
      IF (NSTOR.NE.1) THEN
C       WRITE(4) NREC,((blockb%info(J,I),J=1,3),I=1,NREC),
C    +                ((blockb%idata(J,I),J=1,IR2),I=1,NREC),
C    +                ((blockb%xdata(J,I),J=1,IR1),I=1,NREC)
       LTAB = (3+MXEF_USED)*NRECMAX
       IF (NREC.NE.0) WRITE(4) NREC,LTAB,
     +  ((blockb%info(i,j),i=1,3),j=1,nrecmax),
     +  ((blockb%idata(i,j),i=1,mxef_used),j=1,nrecmax),
     +	((blockb%xdata(i,j),i=1,mxef_used),j=1,nrecmax)
       IF ((NSTOR.EQ.1).AND.(NRECW.GT.NRECMAX)) THEN
       WRITE(6,9204) NRECW,NRECMAX
       STOP
       ENDIF
       CLOSE(4)
      ENDIF
      WRITE(6,9230) NRECW
      WRITE(12,9230) NRECW
C
C-----------------------------------------------------------------------
C   READING OF THE INPUT FILE (UNIT = 3) FOR THE COMPUTATION OF
C   THE SURVIVOR CURVE (I.E. IF NSURV = 1) OR RESIDUALS (NSURV = 2)
C      IN CORE IF NSTOR = 1
C      IN WORKING FILE IN UNIT 7 IF NSTOR =0
C-----------------------------------------------------------------------
      IF (NSURV.NE.0) THEN
C
      NRECMAX2=NRECMAX
      allocate( blockb2%info2(4,NRECMAX2) )
      allocate( blockb2%idata2(MXEF_USED,NRECMAX2) )
      allocate( blockb2%xdata2(MXEF_USED,NRECMAX2) )  	  
C
       IF (NVAR.GT.MXEF) THEN
       WRITE(6,9220) NVAR,MXEF
       STOP
       ENDIF
       NREC2=0
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26, 1997
       IF (IOMODE.EQ.1) THEN
         OPEN(3,file=file(5),status='old',FORM='FORMATTED')
       ELSE
         OPEN(3,file=file(5),status='old',FORM='UNFORMATTED')
       ENDIF
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF (NSTOR.NE.1) OPEN(7,file=FILE(10),FORM='UNFORMATTED')
  400  IF (IOMODE.EQ.1) THEN
        READ(3,*,END=499) (IREC(I),I=1,NINTEG),(REC(I),I=NINTEG+1,NVAR)
       ELSE IF (IOMODE.EQ.2) THEN
        READ(3,END=499) (IREC(I),I=1,NINTEG),(REC(I),I=NINTEG+1,NVAR)
      ELSE
cc##################################################
        IF (NRR.EQ.0) THEN
          IF (IOMODE.EQ.3) THEN
c IOMODE = 3 <==> BLOCKED UNFORMATTED
            READ(3,END=499) NRRMAX,LTAB,(KRR(I),I=1,LTAB)
c          ELSE
c IOMODE = 4 <==> compressed
c            CALL f77cread(idfile(1),nrrmax,ltab,krr,ierr)
c            IF (IERR.EQ.0) GOTO 499
          ENDIF
        ENDIF
        NRR=NRR+1
        DO 404 I=1,NINTEG
           IREC(I)=ITABL(I,NRR)
  404   CONTINUE
        DO 406 I=NINTEG+1,NVAR
           REC(I)=XTABL(I,NRR)
  406   CONTINUE
        IF (NRR.EQ.NRRMAX) NRR=0
      ENDIF
cc##################################################
       NREC2 = NREC2 + 1
       IF (NSTOR.EQ.1.AND.NREC2.GT.NRECMAX2) THEN
         WRITE(6,9205) NREC2,NRECMAX2
         STOP
       ENDIF
C-----------------------------------------------------------------------
C   VARIABLE 1 = TIME
C   VARIABLE 2 = CODE (1 = UNCENSORED RECORD, 0 = RIGHT CENSORED RECORD
C    -1 = TIME-DEPENDENT COVARIATE CHANGE)
C   VARIABLE 3 = STRATUM
C   VARIABLE 4 = ANIMAL IDENTIFICATION
C-----------------------------------------------------------------------
       ICODE = MIN(IREC(ICOLCOD),1)
       blockb2%info2(1,NREC2)=MAX(1,IREC(ICOLTIM))
       blockb2%info2(2,NREC2)=ICODE
       IF (ICODE.EQ.-2) THEN
       WRITE(6,9120) IREC(NID)
        STOP
       ENDIF
       IF (NSTRATA.NE.0) blockb2%info2(3,NREC2)=IREC(ICOLSTR)
       blockb2%info2(4,NREC2)=IREC(NID)
       K = 0
C-----------------------------------------------------------------------
C   IR1 FOLLOWING VARIABLES : CONTINUOUS COVARIATES
C        IPLUS1 = 0 FOR TIME-INDEPENDENT COVARIATES
C        IPLUS1 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C        IPLUS1 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C   THE AVERAGE VALUE OF THE CONTINUOUS COVARIATE IS SUBSTRACTED
C-----------------------------------------------------------------------
       DO 410 I=1,IR1
       IF (IPLUS1(I).GT.0) THEN
             K = K + 1
             W = REC(IREAD1(I))
             IF (ITRAIT1(I).GT.NCOVREAD) THEN
             II= ITRAIT1(I) - NCOVREAD
             II = IPOW(II,2)
             W = W ** II
             ENDIF
             JK = 0
             DO 411 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT1(I)) JK= JJ
  411        CONTINUE
             blockb2%xdata2(I,NREC2)= (W - XAV(JK))/ XSQ(JK)
       ELSE IF (IPLUS1(I).EQ.0) THEN
             K = K + 1
             W = REC(IREAD1(I))
             IF (ITRAIT1(I).GT.NCOVREAD) THEN
             II= ITRAIT1(I) - NCOVREAD
             II = IPOW(II,2)
             W = W ** II
             ENDIF
             JK = 0
             DO 412 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT1(I)) JK= JJ
  412        CONTINUE
             blockb2%xdata2(I,NREC2)= (W - XAV(JK))/ XSQ(JK)
       ELSE
             IF (ICODE.EQ.-1) THEN
             W = REC(IREAD1(I))
             IF (ITRAIT1(I).GT.NCOVREAD) THEN
             II= ITRAIT1(I) - NCOVREAD
             II = IPOW(II,2)
             W = W ** II
             ENDIF
             JK = 0
             DO 413 JJ=1,NCOVMOD
             IF (IMOD(JJ).EQ.ITRAIT1(I)) JK= JJ
  413          CONTINUE
             blockb2%xdata2(I,NREC2)= (W - XAV(JK))/ XSQ(JK)
             ELSE
             blockb2%xdata2(I,NREC2)= 0.D0
             ENDIF
       ENDIF
  410   CONTINUE
C-----------------------------------------------------------------------
C   IR2 FOLLOWING VARIABLES : DISCRETE COVARIATES
C        IPLUS2 = 0 FOR TIME-INDEPENDENT COVARIATES
C        IPLUS2 = +1 FOR TIME-DEPENDENT (BEFORE CHANGE)
C        IPLUS2 = -1 FOR TIME-DEPENDENT (AFTER CHANGE)
C   THE LEVEL OF EACH EFFECT, INITIALLY NUMBERED 1 TO MAXLEVEL
C            ARE RENUMBERED BY ADDING IND(I)
C-----------------------------------------------------------------------
       DO 416 I=1,IR2
       II = I + IR1
       IF (IREAD2(I).NE.0) THEN
          K=IREC(IREAD2(I))
          IF (K.GT.0) K = K + IND(I)
          blockb2%idata2(II,NREC2)=K
       ENDIF
  416   CONTINUE
C-----------------------------------------------------------------------
C   PRINT ALL ELEMENTARY RECORDS
C-----------------------------------------------------------------------
C       IF ((IPRINT.GT.0).AND.(IPRINT.GE.NREC2)) THEN
c       IF (NREC2.LT.50) THEN
c       WRITE(6,*) NREC2,(blockb2%info2(K,NREC2),K=1,4),
c     +      (blockb2%idata2(K,NREC2),K=1+IR1,IR2+IR1),
c     +      (blockb2%xdata2(K,NREC2),K=1,IR1)
c       ENDIF
C
c-----------------------------------------------------------------------
C   STORAGE ON DISK IF NSTOR = 1 AND BLOCK LENGTH = NRECMAX
C   WITH FAST I/O
C-----------------------------------------------------------------------
       IF ((NSTOR.NE.1).AND.(NREC2.EQ.NRECMAX2)) THEN
       LTAB = (4+MXEF_USED)*NREC2
       WRITE(7) NREC2,LTAB,
     +  ((blockb2%info2(i,j),i=1,4),j=1,nrecmax2),
     +  ((blockb2%idata2(i,j),i=1,mxef_used),j=1,nrecmax2),
     +	((blockb2%xdata2(i,j),i=1,mxef_used),j=1,nrecmax2)
       NREC2=0
       ENDIF
C
       GOTO 400
  499   CLOSE(3)
C
C
C-----------------------------------------------------------------------
C   STORAGE ON DISK IF NSTOR = 1 AND LAST BLOCK
C-----------------------------------------------------------------------
       IF (NSTOR.NE.1) THEN
C         WRITE(7) NREC2,((blockb2%info2(J,I),J=1,4),I=1,NREC2),
C    +                ((blockb2%idata2(J,I),J=1+IR1,IR2+IR1),I=1,NREC2),
C    +                ((blockb2%xdata2(J,I),J=1,IR1),I=1,NREC2)
       LTAB = (4+MXEF_USED)*NRECMAX2
       IF (NREC2.NE.0) WRITE(7) NREC2,LTAB,
     +  ((blockb2%info2(i,j),i=1,4),j=1,nrecmax2),
     +  ((blockb2%idata2(i,j),i=1,mxef_used),j=1,nrecmax2),
     +	((blockb2%xdata2(i,j),i=1,mxef_used),j=1,nrecmax2)
       CLOSE(7)
       ENDIF
      ENDIF
C-----------------------------------------------------------------------
C   DEFINITION OF CONSTRAINTS IF NCONS = 0
C-----------------------------------------------------------------------
      NRAND = IGAM(0,1) + INOR(0,1)
      IF (NCONS.EQ.0) THEN
       DO 430 I = 1,NCOVMOD
       II = IMOD(I)
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on September 26, 1997
        IF (ISAME(II).NE.0) GOTO 430
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       JJ= 0
       IF (NRAND.NE.0) THEN
            DO 432 K = 1,NCOVREAD+NPOW
             IF (II.EQ.K) THEN
               IF (IGAM(K,1).GE.1.OR.INOR(K,1).GE.1) JJ=1
               IF (NRULE.EQ.3.AND.NRELMAT2.EQ.K-1) JJ=1
             ENDIF
  432       CONTINUE
       ENDIF
       IF (JJ.EQ.1.OR.ICOVTYP(II).LE.0) GOTO 430
       JJ= 0
       J = 0
       DO 435 K = IFIRST(II),ILAST(II)
            IF (NFAIL(K).GT.JJ) THEN
             JJ = NFAIL(K)
             J = K
            ENDIF
  435     CONTINUE
       ICONS(0) = ICONS(0) + 1
       IF (ICONS(0).GT.NDIMAX) THEN
            WRITE(6,9260) ICONS(0),NDIMAX
            STOP
       ENDIF
       ICONS(ICONS(0)) = J
  430   CONTINUE
C-----------------------------------------------------------------------
C   NO CONSTRAINTS IF NCONS = -2
C-----------------------------------------------------------------------
      ELSE IF (NCONS.EQ.-2) THEN
       ICONS(0) = 0
C-----------------------------------------------------------------------
C   RECALCULATION OF CONSTRAINTS LEVELS IF NCONS > 0
C-----------------------------------------------------------------------
      ELSE IF (NCONS.GT.0) THEN
        DO 440 I=1,ICONS(0)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on October 21, 1996
          IF (ICONS(I).LT.0) THEN
            J = -ICONS(I)
            JJ = MOD(J,MXEF)
            K = -J / MXEF
            ICONS(I) = ILAST(JJ) + K + 1
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          ELSE
            JJ = MOD(ICONS(I),MXEF)
            K = ICONS(I) / MXEF
            ICONS(I) = IFIRST(JJ) + K - 1
          ENDIF
  440   CONTINUE
      ENDIF
C-----------------------------------------------------------------------
C   IF NFAIL = 0, THE SOLUTION IS KNOWN = -INFINITY |||
C-----------------------------------------------------------------------
c      DO 450 I=1,NDIM1
c       IF (NFAIL(I).EQ.0) BETA1(I) = -999.99D0
c  450 CONTINUE
C-----------------------------------------------------------------------
C   IF THERE IS (ARE) RANDOM VARIABLE(S), SET BACK ALL BETA1'S TO 0
C      = ALL ELEMENTS BETWEEN IFIRST(I) AND ILAST(I)
C-----------------------------------------------------------------------
      IF (IGAM(0,1).NE.0) THEN
        DO 452 I=1,NCOVREAD
          IF (IGAM(I,1).NE.0) THEN
            DO 454 J=IFIRST(I),ILAST(I)
              BETA1(J)=0.D0
  454       CONTINUE
          ENDIF
  452    CONTINUE
      ENDIF
      IF (INOR(0,1).NE.0) THEN
        DO 462 I=1,NCOVREAD
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26,1997
          IF (INOR(I,1).NE.0) THEN
            IF (ISAME(I).NE.0)  THEN
               JJ=ILAST(I)
            ELSE IF (NRULE.EQ.3.AND.NRELMAT2.EQ.I) THEN
               JJ=ILAST(I+1)
            ELSE
               JJ=0
            ENDIF
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            DO 464 J=IFIRST(I),JJ
              BETA1(J)=0.D0
  464       CONTINUE
          ENDIF
  462    CONTINUE
      ENDIF

C-----------------------------------------------------------------------
C   READ CORRESPONDENCE OLD CODE <--> NEW CODE
C-----------------------------------------------------------------------
C
      OPEN(1,file=file(2),status='old',FORM='FORMATTED')
  500 READ(1,502,END=600) EFFECT,JJ,KK,J1,J2,J3,IW,J
  502 FORMAT(1X,A8,I5,I2,3I10,2I8)
      DO 510 K=1,NCOVMOD
       II = IMOD(K)
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26,1997
       IF (ISAME(II).NE.0) GOTO 510
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF (LABEL(II).EQ.EFFECT) THEN
       NCOL(II) = KK
       IF (J.GT.0) THEN
        I = IFIRST(II) + J - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21, 1996
       ELSE
         I = ILAST(II) + J +1
       ENDIF
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IOLDCODE(I,1) = J1
       IOLDCODE(I,2) = J2
       IOLDCODE(I,3) = J3
       IOLDCODE(I,4) = J
       ENDIF
  510 CONTINUE
C SAME THING FOR STRATA
      IF (NSTRATA.GT.1) THEN
        IF (LABEL(ISTRVAR).EQ.EFFECT) THEN
          NCOL(0)=KK
          IOLCODST(J,1) = J1
          IOLCODST(J,2) = J2
          IOLCODST(J,3) = J3
        ENDIF
      ENDIF
      GOTO 500
C-----------------------------------------------------------------------
C   SORTING OF MATRIX IOLDCODE
C-----------------------------------------------------------------------
C
  600 CLOSE(1)
      DO  610 K= 1,NCOVMOD
       II = IMOD(K)
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on September 26,1997
       IF (ISAME(II).NE.0) GOTO 610
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       J1 = IFIRST(II)
       J2= ILAST(II) - J1 + 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21, 1996
       IF (II.EQ.NRELMAT) J2=J2-NUNK
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       J3 = J2 * J2
       IF (ICOVTYP(II).LE.0) THEN
         NCOL(II) =1
         IOLDCODE(J1,1) = 1
         IOLDCODE(J1,4) = 1
       ENDIF
       CALL JRANK(IOLDCODE(J1,1),J2,IRKC(J1,1),IWORK,'A')
       IF (NCOL(II).GT.1) THEN
         CALL JRANK(IOLDCODE(J1,2),J2,IRKC(J1,2),IWORK,'A')
         IF (NCOL(II).GT.2) THEN
           CALL JRANK(IOLDCODE(J1,3),J2,IRKC(J1,3),IWORK,'A')
           DO 618 M1=J1,J1+J2-1
             IRKC(M1,1)= IRKC(M1,1)*J3+IRKC(M1,2)*J2+IRKC(M1,3)
  618     CONTINUE
         ELSE
           DO 620 M1=J1,J1+J2-1
             IRKC(M1,1)= IRKC(M1,1)*J2 + IRKC(M1,2)
  620     CONTINUE
         ENDIF
       ENDIF
       CALL JRANK(IRKC(J1,1),J2,IRANK(J1),IWORK,'A')
c
       DO 625 M1=J1,J1+J2-1
         M2 = IRANK(M1)+ J1-1
         IF (M1.EQ.M2.OR.IRANK(M1).EQ.0) GOTO 625
         DO 635 JJ=1,4
           IWORK(JJ)=IOLDCODE(M2,JJ)
           IOLDCODE(M2,JJ) = IOLDCODE(M1,JJ)
  635    CONTINUE
  638    KK = IRANK(M2)
         IRANK(M2)=0
         M2 = KK + J1-1
         IF (M2.EQ.M1) THEN
           DO 640 JJ=1,4
             IOLDCODE(M1,JJ) = IWORK(JJ)
  640      CONTINUE
         ELSE
           DO 642 JJ=1,4
             KK= IOLDCODE(M2,JJ)
             IOLDCODE(M2,JJ)=IWORK(JJ)
             IWORK(JJ)=KK
  642      CONTINUE
           GOTO 638
         ENDIF
  625 CONTINUE
  610 CONTINUE
      DO 660 J=1,NCOVMOD
        II=IMOD(J)
        KK = II-1
        DO 665 K=IFIRST(II),ILAST(II)
          JJ = IFIRST(II) + IOLDCODE(K,4) - 1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c added on october 21, 1996
          IF (IOLDCODE(K,4).LT.0) JJ = ILAST(II) + IOLDCODE(K,4) +1
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          IRANK(JJ)=K
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on June 27,1997
          IF (NRULE.EQ.3.AND.KK.EQ.NRELMAT2) GOTO 665
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          IF (IGAM(II,1).EQ.0.AND.INOR(II,1).EQ.0.AND.NFAIL(K).EQ.0.
     +        .AND.ISAME(II).EQ.0)   BETA1(K)=-999.99D0
  665   CONTINUE
  660 CONTINUE

C
C-----------------------------------------------------------------------
C FORMATS
C-----------------------------------------------------------------------
 9000 FORMAT(/10X,72A)
 9001 FORMAT(/1X,' FILES USED :',
     +  /5X,'RECODED DATASET    :  ',A20,
     +  /5X,'NEW/OLD CODES      :  ',A20,
     +  /5X,'OUTPUT             :  ',A20)
 9002 FORMAT(5X,'RECODED PEDIGREE   :  ',A20)
 9003 FORMAT(5X,'SOLUTIONS READ IN  :  ',A20)
 9004 FORMAT(5X,'SOLUTIONS STORED IN:  ',A20)
 9005 FORMAT(/1X,' NO STRATIFICATION')
 9006 FORMAT(/1X,' FUTURE RECORDS :',
     +  /5X,'RECODED DATASET    :  ',A20,
     +  /5X,'OUTPUT             :  ',A20)
 9007 FORMAT(/1X,' RESIDUALS :',
     +  /5X,'RECODED DATASET    :  ',A20,
     +  /5X,'OUTPUT             :  ',A20)
 9010 FORMAT(/1X,' NUMBER OF STRATA =                ',16X,I5,/
     +       1X, ' STRATUM NUMBER READ IN COLUMN :   ',16X,I5)
 9015 FORMAT(/1X,' FAILURE TIME READ IN COLUMN :     ',16X,I5,/
     +       1X,' CENSORING CODE READ IN COLUMN :   ',16X,I5)
 9016 FORMAT(/1X,' IDENTIFICATION NUMBER READ IN COLUMN : ',11X,I5)
 9020 FORMAT(1X,' TOTAL NUMBER OF COVARIATES =      ',16X,I5,
     + /1X,' CONTINUOUS COVARIATES INCLUDED IN THE ANALYSIS =  ',I5,
     + /1X,' DISCRETE COVARIATES INCLUDED IN THE ANALYSIS =    ',I5,
     + /1X,' COVARIATES READ BUT NOT INCLUDED IN THE ANALYSIS =',I5,
     + /1X,' POWERS OF CONTINUOUS COVARIATES                  =',I5/,
     + /5X,'  ************** COX MODEL **************** ',
     +//1X,' COVARIATE            CHARACTERISTICS       '/)
 9029 FORMAT(1X,' ... WELL, NO COVARIATES ... ')
 9030 FORMAT(1X,I2,1X,A8,': CONTINUOUS TIME-INDEPENDENT',
     +     ' READ IN COLUMN ',I3)
 9031 FORMAT(1X,I2,1X,A8,': CONTINUOUS TIME-DEPENDENT',
     +     ' READ IN COLUMNS  ',I3,' (BEFORE T) AND ',I3,' (AFTER T)')
 9032 FORMAT(1X,I2,1X,A8,': DISCRETE TIME-INDEPENDENT',
     +     ' READ IN COLUMN ',I3)
 9033 FORMAT(1X,I2,1X,A8,': DISCRETE TIME-DEPENDENT',
     +     ' READ IN COLUMNS  ',I3,' (BEFORE T) AND ',I3,' (AFTER T)')
 9034 FORMAT(1X,I2,1X,A8,': CONTINUOUS TIME-INDEPENDENT',
     +     ' = POWER ',I1,' OF COVARIATE ',A8)
 9035 FORMAT(1X,I2,1X,A8,': CONTINUOUS TIME-DEPENDENT',
     +     ' = POWER ',I1,' OF COVARIATE ',A8)
 9038 FORMAT(3X,' COVARIATES ',A8,' AND ',
     +     A8,' WERE CODED TOGETHER (THEY REPRESENT THE SAME EFFECT)')
 9040 FORMAT(1X,' FATAL ERROR : THE COVARIATE ',A8,' CANNOT APPEAR',
     + ' ALONE IN THE MODEL ',/5X,'UNLESS YOU RERUN "PREPARE" ',
     + 'WITHOUT THE "JOINCODE" STATEMENT')
 9042 FORMAT(3X,'NOTE: THE COVARIATE ',A8,' IS MULTIPLIED BY A ',
     + 'COEFFICIENT ',F8.5)
 9050  FORMAT(/1X,' NO GIVEN FILE NAME WHERE SOLUTIONS SHOULD BE ',
     +  'STORED',/1X,' CHECK "FILE" STATEMENT IN PARAMETER FILE')
 9055  FORMAT(/1X,' NO FILE NAME FROM WHERE OLD SOLUTIONS SHOULD',
     +  ' BE READ',/1X,' CHECK "FILE" STATEMENT IN PARAMETER FILE')
 9060  FORMAT(/1X,' SOLUTIONS AT CONVERGENCE WILL BE STORED',
     +    ' IN FILE ',A40,/1x)
 9065  FORMAT(/1X,' OLD SOLUTIONS WILL BE READ FROM FILE ',A40)

C
 9100 FORMAT(/1X,' ELEMENTARY RECORDS ARE NOT SORTED IN THE RIGHT ORDER'
     + /1X,'IN STRATUM ',I4,' TIME = ',I5,' FOUND AFTER TIME = ',I5)
 9110 FORMAT(/1X,' ELEMENTARY RECORDS ARE NOT SORTED IN THE RIGHT ORDER'
     + /1X,'IN STRATUM ',I4,' AT TIME = ',I5,' CODE = ',I5,
     + ' FOUND AFTER CODE = ',I5)
 9120 FORMAT(/1X,' LEFT TRUNCATED RECORD FOUND FOR ANIMAL ',I8,
     + ' IN FILE IN UNIT 4',1X,' LEFT CENSORED RECORDS ARE NOT ALLOWED',
     + ' FOR THE COMPUTATION OF THE SURVIVOR CURVE')
C
 9150 FORMAT(/5X,'  ********** SIMPLE STATISTICS ************ ',//1X,
     + ' TOTAL NUMBER OF STRATA =                 ',I4,/1X,
     + ' TOTAL NUMBER OF ELEMENTARY RECORDS = ',I8)
 9200 FORMAT(/1X,' RIGHT CENSORED RECORDS : ',I8,' (',F8.3,'%)',
     + /1X,' MINIMUM CENSORING TIME : ',I8,
     + /1X,' MAXIMUM CENSORING TIME : ',I8,
     + /1X,' AVERAGE CENSORING TIME :     ',F8.3)
 9201 FORMAT(/1X,' LEFT TRUNCATED RECORDS : ',I8,' (',F8.3,'%)',
     + /1X,' MINIMUM TRUNCATION TIME :',I8,
     + /1X,' MAXIMUM TRUNCATION TIME :',I8,
     + /1X,' AVERAGE TRUNCATION TIME :    ',F8.3)
 9202 FORMAT(/1X,' UNCENSORED RECORDS :     ',I8,
     + /1X,' MINIMUM FAILURE TIME :   ',I8,
     + /1X,' MAXIMUM FAILURE TIME :   ',I8,
     + /1X,' AVERAGE FAILURE TIME :       ',F8.3/)
 9204 FORMAT(/1X,' MORE ELEMENTARY RECORDS ',I8,' THAN ALLOWED (',
     + I8,') FOR STORAGE OF THE WHOLE DATA FILE IN CORE',/1x,
     +' INCREASE NRECMAX IN THE PARAMETER FILE')
 9205 FORMAT(/1X,' MORE ELEMENTARY RECORDS ',I8,' THAN ALLOWED (',
     + I8,') FOR STORAGE OF THE WHOLE DATA FILE2 IN CORE',/1x,
     +' INCREASE THE SIZE OF THE PARAMETER NRECMAX2')
 9206 FORMAT(1X,' CONTINUOUS COVARIATES ARE CENTERED')
 9210 FORMAT(1X,' EFFECT : ',A8,' MIN =  ',G12.5,' MAX = ',G12.5,
     +            /19X,' MEAN = ',G12.5,' STD = ',G14.7)
 9212 FORMAT(1X,' EFFECT : ',A8,' MIN = ',I6,6X,' MAX = ',I6)
 9220 FORMAT(1X,' SIZE OF THE VECTOR OF EFFECTS (',I8,') LARGER ',
     +'THAN THE MAXIMUM ALLOWED (',I8,')'/1X,
     +'INCREASE THE SIZE OF THE PARAMETER NEFMAX')
 9230 FORMAT(/1X,' NUMBER OF ELEMENTARY RECORDS KEPT = ',I8)
 9248 FORMAT(/1X,' CONVERGENCE CRITERION USED = ',D12.5/)
 9249 FORMAT(/1X,' CONVERGENCE CRITERION USED = ',D12.5,
     + ' (= DEFAULT VALUE)')
 9250 FORMAT(1X,' SIZE OF THE VECTOR OF COVARIATES (',I8,') LARGER ',
     +'THAN THE MAXIMUM ALLOWED (',I8,')'/1X,
     +'INCREASE THE SIZE OF THE PARAMETER NDIMAX')
 9260 FORMAT(1X,' SIZE OF THE VECTOR OF CONSTRAINTS(',I8,') LARGER ',
     +'THAN THE MAXIMUM ALLOWED (',I8,')'/1X,
     +'INCREASE THE SIZE OF THE PARAMETER NDIMAX')
 9265 FORMAT(1X,' A LOG-GAMMA DISTRIBUTION IS ASSUMED FOR EFFECT : ',
     +        A8,' (GAMMA   : ',F8.4,')')
 9270 FORMAT(1X,' A NORMAL DISTRIBUTION IS ASSUMED FOR EFFECT :    ',
     +        A8,' (VARIANCE : ',F8.4,')')
 9271 FORMAT(1X,' A RELATIONSHIP MATRIX IS USED FOR THIS EFFECT USING',
     +        ' THE USUAL HENDERSON S RULES',
     +        /5X,I8,' RECORDS READ IN PEDIGREE FILE')
 9272 FORMAT(1X,' A RELATIONSHIP MATRIX IS USED FOR THIS EFFECT USING',
     +        ' THE SIRE-MATERNAL GRAND SIRE RULES',
     +        /5X,I8,' RECORDS READ IN PEDIGREE FILE')
 9273 FORMAT(1X,' A BINORMAL DISTRIBUTION IS ASSUMED FOR EFFECTS :',
     +       2(/8X,A8,' (VARIANCE : ',F8.4,')'))
 9274 FORMAT(1X,' THE CORRELATION BETWEEN THE TWO IS: ',F8.4)
 9275 FORMAT(1X,' A RELATIONSHIP MATRIX IS USED FOR BOTH EFFECTS',
     +        ' USING THE USUAL HENDERSON S RULES',
     +        /5X,I8,' RECORDS READ IN PEDIGREE FILE')
 9276 FORMAT(1X,' A RELATIONSHIP MATRIX IS USED FOR THESE EFFECTS',
     +        ' USING THE SIRE-MATERNAL GRAND SIRE RULES',
     +        /5X,I8,' RECORDS READ IN PEDIGREE FILE')
 9280 FORMAT(1X,' THE VARIANCE PARAMETER WILL BE ESTIMATED AS THE',
     +  ' MARGINAL POSTERIOR MODE',/1X,
     + ' THE FINAL ESTIMATE IS EXPECTED TO LIE BETWEEN ',F10.5,' AND ',
     + F10.5,/1X,' THE INTERVAL BRACKETTING THE FINAL SOLUTION ',
     + 'SHOULD BE SMALLER THAN ',F10.5)
 9290  FORMAT(1X,' THE FIRST THREE MOMENTS OF THE MARGINAL POSTERIOR ',
     + ' DISTRIBUTION ',/1X,' WILL BE CALCULATED BY GAUSS-HERMITE ',
     + ' INTEGRATION BASED ON ',I2,' POINTS')
 9425 FORMAT(/1X,' THE TEMPORARY FILE IS STORED IN :',A50)
 9426 FORMAT(/1X,' THE TEMPORARY FILES ARE STORED IN: ',/1X,
     +A50,' FOR THE DATA SET',/1X,' FOR THE "FUTURE RECORDS"')
 9427 FORMAT(/1X,' THE TEMPORARY FILES ARE STORED IN: ',/1X,
     +A50,' FOR THE DATA SET',/1X,' FOR THE RESIDUALS"')
 9890 FORMAT(/7X,'***************************************** ',//1X,
     + ' RECORDS IN WORKING DATA SET ',/1X)
 9900 FORMAT(1X,8I6,4(F6.1,1X))
 9901 FORMAT(1X,11I6,6(F6.2,1X))
 9999 FORMAT(/7X,'***************************************** ')

      deallocate(IRKC,IWORK)
      deallocate(IBEF,IAFT,IREC,ITIMDEP,JSAME,ILEV,INCLUD,IREAD1)
      deallocate(IREAD2,ITEMP,MA,MI,IPOW,KRR,ITABL,XTABL)
      deallocate(REC,TEMP,XMA,XMI,YCOEF) 
	   
 
      RETURN
C***********************************************************************
      END
