      SUBROUTINE FWEIB(BETA1,F,GRADF,NDIM1,NSTATE,IUSER)
C***********************************************************************
C  FWEIB         *                                    *  27 / 03 /1995 *
C***********************************************************************
C  COMPUTE THE FINAL VALUE OF - LOG LIKELIHOOD AND ITS VECTOR OF FIRST *
C       DERIVATIVES                                                    *
C***********************************************************************
c
      use parinclu
      implicit none
	  
      integer,allocatable:: kfirst(:),klast(:),listys(:),point(:)  !all NDIMAX
      real*8,allocatable:: domeg(:)                       !all NDIMAX
      real*8 gradf(*)
	  
      INTEGER NSTATE,IUSER(3)
C
      INTEGER NDIM1,LAST,LAST1
      INTEGER I,I2,IS,J,JJ,K,KK,ICODE,IPRETIM,ITIM,IQ,IVALQ
      integer ix,jx,iy,jy
      INTEGER IPRESTR,LTAB,idel,J2,K2
      INTEGER IA,IP,IM,IGPM,IGMM,ISTR,IDF,NDCOV0,NDCOV1,NDCOVP1
      INTEGER NDIMBPS
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on December 10, 1996
      INTEGER IDHERD,NH,N1,I1,MAXYS,NLISTYS,NCOND
      INTEGER IERR
      CHARACTER*15 FILENAMC
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added on October 20,2003

C
      REAL*8 GAM0,XNQGAM,OMQGAM,R1GAM,OMEG,CONST
      REAL*8 F,U,W,W1,W2,W3,W4,W5,W6,W7,XNS,XNQ,XCOV,X,X2,DM1(7)
      REAL*8 RHO,TRHO,TPRERHO,LRHO,DLTIM,DLPRETIM
      REAL*8 GAMLOG,XGAINV,DIGAMA,GAMVAR,XNSFIX,BETA1(*),Y,Y2
C
      CHARACTER*100 FILENAM
C
      EQUIVALENCE(FILENAM,FILENAMC)

      DATA (DM1(I),I=1,7)/1.D0,1.33333333333333D0,2.D0,
     +  1.D0,1.3333333333D0,1.06666666667D0,1.4545454545455D0/
	  
      if (.not.allocated(kfirst)) then
        allocate( kfirst(NDIMAX),klast(NDIMAX),listys(NDIMAX), 
     +            point(NDIMAX), domeg(NDIMAX) )
      endif
C
C----------------------------------------------------------------------
C  INITIALIZATION
C-----------------------------------------------------------------------
C
      do i = 1, NDIMAX
        kfirst(i) = 0
        klast(i) = 0
      enddo
	  
      NDCOV0 = NCCOV + 1
      NDCOV1 = NCCOV + NDCOV
      NDCOVP1 = NDCOV1 + 1
 800  format(1x,a10,20F8.3)
      I2=0
      F = 0.D0
      XNQ = 0.D0
      XNS = 0.D0
      XNSFIX = 0.D0
      OMEG=0.D0
      NDIMBPS= NDIMB + NSTRATA
      MAXYS=1000
      IPRESTR=0
      IF (INTEGAM.NE.0) THEN
        IF (NJOINT.EQ.0) THEN
          GAMVAR = XGAM(INTEGAM)
        ELSE
          GAMVAR=DEXP(BETA1(NDIM1))
        ENDIF
      ENDIF
      DO 10 I = 1,NDIM1
        GRADF(I) = 0.D0
        DOMEG(I) = 0.D0
        POINT(I) = 0
   10 CONTINUE
      IPRETIM = 0
C-----------------------------------------------------------------------
c<<<<<<<< modified on April 17, 1997 for ICRHO=0 >>>>>>>>>>>>>>>>>>>>>>>
C  READ THE VALUE(S) OF RHO IF ICRHO=1
C-----------------------------------------------------------------------
      IF (ICRHO.EQ.1) THEN
        K = NSTRATA
        IF (NO_LOG.EQ.1) THEN
          DO 11 I=1,NSTRATA
            VALRHO(I) = BETA1(NDIMBPS+I)
c           print*,'strata',I,valrho(i),BETA1(NDIMB+I)
            IF (VALRHO(I).LT.0.D0) THEN
              write(6,9912)
 9912         FORMAT(1X,' RHO is negative here. If the program ',
     +        'does not converge',/1X,
     +        'use NO_LOGARITHM 0; in your parameter file')
              VALRHO(I)=1.D-5
            ENDIF
            DLOGRHO(I) = DLOG(VALRHO(I))
  11      CONTINUE
        ELSE
          DO 12 I=1,NSTRATA
            DLOGRHO(I) = BETA1(NDIMBPS+I)
            VALRHO(I) = DEXP(DLOGRHO(I))
  12      CONTINUE
        ENDIF
      ELSE IF (ICRHO.EQ.99) THEN
        DO 16 I=1,NSTRATA
          DLOGRHO(I) = 0.D0
          VALRHO(I) =  1.D0
  16    CONTINUE
      ENDIF
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO 13 I=1,NSTRATA
         VECEXP(1,I) =  1.D0
	 DO 14 J=2,MAXTIM(1)
          IF (ICRHO.EQ.99) THEN
             VECEXP(J,I)=DBLE(J)
          ELSE
            IF (VECLOG(J).NE.0.D0) THEN
              VECEXP(J,I) =  DEXP(VALRHO(I)*VECLOG(J))
	    ENDIF
	  ENDIF
  14     CONTINUE
  13  CONTINUE
C
C CONSTRAINTS
C
       DO 19 I=1,ICONS(0)
          BETA1(ICONS(I)) =0.D0
  19   CONTINUE
C-----------------------------------------------------------------------
C   RANDOM EFFECTS
C-----------------------------------------------------------------------
C
c In case of CORRELATED random effects creates the inverse of the V matrix - VM1
c  computes the determinant and the off-diagonal elements using the correlation
c  from init_c.f
      if (corrflag) then
        do i=1,maxrand
C compute corr form zeta
          X=exp(zeta)
          corr= (1.d0-2.d0*X)/(1.d0+2.d0*X)    
          if ((inor(i,1).ge.1).and.(icorr(i,1).eq.i)) then
            detv=(1-corr*corr)*xnor(i)*xnor(icorr(i,2))
            VM1(1,1)= xnor(icorr(i,2))/detv
            VM1(2,2)= xnor(i)/detv
!              VM1(1,1)= xnor(i)/detv
!              VM1(2,2)= xnor(icorr(i,2))/detv
            VM1(1,2)=(-corr*sqrt(xnor(i))*sqrt(xnor(icorr(i,2))))/detv
            VM1(2,1)=VM1(1,2)
            exit
          endif
        enddo
      endif	 


C computations for the RANDOM effect	 
      IF (NRAND.NE.0) THEN
       DO 300 I = 1,MAXRAND
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on November 26, 1996
       IF (ISAME(I).NE.0) GOTO 300
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       IF (IGAM(I,1).GE.1.AND.IGAM(I,2).NE.0.AND.I.NE.INTEGAM) THEN
c modfied on Decembre 16 2013
         XGAINV=1.D0/XGAM(I)
c         U = XGAM(I) * DLOG(XGAM(I)) - GAMLOG(XGAM(I))
         U = -XGAINV * DLOG(XGAM(I)) - GAMLOG(XGAINV)
         F = F - (IGAM(I,3) - IGAM(I,2) +1 ) * U
         DO 310 J = IGAM(I,2),IGAM(I,3)
             IF (BETA1(J).LT.-80.D0) THEN
               W=0.D0
             ELSE
               W = DEXP(BETA1(J))
             ENDIF
c       F = F - XGAM(I) * (BETA1(J) - W)
c       GRADF(J) = GRADF(J) - XGAM(I) * (1.D0 - W)
c modified on Decembre 16 2013
             F = F - XGAINV * (BETA1(J) - W)
             GRADF(J) = GRADF(J) - XGAINV * (1.D0 - W)

  310    CONTINUE
       ELSE IF (INOR(I,1).GE.1) THEN
!!!! correlated random effects - this part remains as it was before 
!    
            if (icorr(i,2).eq.0) then
!!!!
         CONST = - 0.5D0 * DLOG(XNOR(I))
         IF (NRELMAT.EQ.0.or.I.ne.nrelmat2) Then
           U = 1.D0 / XNOR(I)
           DO 312 J = INOR(I,2),INOR(I,3)
              W = U * BETA1(J)
              F = F -CONST + 0.5D0 * W * BETA1(J)
              GRADF(J) = GRADF(J) + W
  312      CONTINUE
         ELSE
           U = 1.D0 / XNOR(NRELMAT2)
           IF (NRULE.EQ.1) THEN
             DO 320 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
                   IF (IPEDIG(2,K).LE.0) GOTO 320
                   F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IM = IPEDIG(4,K)
                   X = BETA1(IA)
                   IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                   IF (IM.GT.0) X = X - 0.5D0 * BETA1(IM)

                   W = U * DM1(IPEDIG(2,K))
                   X = W * X
                   GRADF(IA) = GRADF(IA) + X
                   IF (IP.GT.0) GRADF(IP) = GRADF(IP) - 0.5D0 * X
                   IF (IM.GT.0) GRADF(IM) = GRADF(IM) - 0.5D0 * X
  320        CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on June 27, 1997
             J=I
             DO 322 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               F = F + 0.5D0 * BETA1(K) * GRADF(K)
  322        CONTINUE
c
           ELSE IF (NRULE.EQ.2) THEN
             DO 330 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
c                  IF (IPEDIG(2,K).LT.0) GOTO 330
                   F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IF (IPEDIG(2,K).LT.0) THEN
                     IP=0
                     IGPM=0
                     IGMM=0
                   ELSE
                     IP = IPEDIG(3,K)
                     IGPM = IPEDIG(4,K)
                     IF (NCOLPED.EQ.4) THEN
                       IGMM = IPEDIG(NCOLPED+1,K)
                     ELSE
                       IGMM = 0
                     ENDIF
                   ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   X = BETA1(IA)
                   IF (IP.GT.0) X = X - 0.5D0 * BETA1(IP)
                   IF (IGPM.GT.0) X = X - 0.25D0 * BETA1(IGPM)
                   IF (IGMM.GT.0) X = X - 0.25D0 * BETA1(IGMM)
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IF (IPEDIG(2,K).LE.0) THEN
                     W = U
                   ELSE
                     W = U * DM1(IPEDIG(2,K))
                   ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   X = W * X
                   GRADF(IA) = GRADF(IA) + X
                   IF (IP.GT.0) GRADF(IP) = GRADF(IP) - 0.5D0 * X
                   IF (IGPM.GT.0) GRADF(IGPM)= GRADF(IGPM) -0.25D0 * X
                   IF (IGMM.GT.0) GRADF(IGMM)= GRADF(IGMM) -0.25D0 * X
  330            CONTINUE
               DO 332 K=INOR(I,2),INOR(I,3)
                 F = F + 0.5D0 * BETA1(K) * GRADF(K)
  332          CONTINUE
             ENDIF
             ENDIF
!!!! correlated random effects - beginning
            else if (icorr(i,1).gt.0) then
!!!!
             I2=icorr(i,2)
             CONST = -0.5D0 * (DLOG(XNOR(I))+DLOG(XNOR(I2))+
     +                    DLOG(1.d0-corr*corr))
! difference between positions of the 2 random effects in the whole list	 
             IDEL=INOR(I2,2)-INOR(I,2)
! in case of no relationship matrix
         IF (NRELMAT.EQ.0.or.I.ne.nrelmat2) Then
           DO 412 J = INOR(I,2),INOR(I,3)
                  J2=J+IDEL
                  F = F -CONST+ 0.5D0 * ( VM1(1,1)*BETA1(J)*BETA1(J)
     +                        + 2.D0 * VM1(1,2)*BETA1(J)*BETA1(J2)
     +                        + VM1(2,2) * BETA1(J2)*BETA1(J2) )
                  GRADF(J) = GRADF(J) + VM1(1,1)*BETA1(J)
     +                                + VM1(1,2)*BETA1(J2)
                  GRADF(J2) = GRADF(J2) + VM1(2,1)*BETA1(J)
     +                                  + VM1(2,2)*BETA1(J2)
  412      CONTINUE
         ELSE
! with relationship matrix 
           IF (NRULE.EQ.1) THEN
             DO 420 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
                   IF (IPEDIG(2,K).LE.0) GOTO 420
                   F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
                   IP = IPEDIG(3,K)
                   IM = IPEDIG(4,K)
                   X = BETA1(IA)
                   X2= BETA1(IA+IDEL)
                   IF (IP.GT.0) THEN
                      X = X - 0.5D0 * BETA1(IP)
                      X2= X2 - 0.5D0 * BETA1(IP+IDEL)
                   ENDIF
                   IF (IM.GT.0) THEN
                      X = X - 0.5D0 * BETA1(IM)
                      X2 = X2 - 0.5D0 * BETA1(IM+IDEL)
                   ENDIF
                   Y = DM1(IPEDIG(2,K)) * (VM1(1,1)*X + VM1(1,2)*X2)
                   Y2 = DM1(IPEDIG(2,K)) * (VM1(1,2)*X + VM1(2,2)*X2)
                   GRADF(IA) = GRADF(IA) + Y
                   GRADF(IA+IDEL) = GRADF(IA+IDEL) + Y2
                   IF (IP.GT.0) THEN
                      GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                      GRADF(IP+IDEL) = GRADF(IP+IDEL) - 0.5D0 * Y2
                   ENDIF
                   IF (IM.GT.0) THEN
                      GRADF(IM) = GRADF(IM) - 0.5D0 * Y
                      GRADF(IM+IDEL) = GRADF(IM+IDEL) - 0.5D0 * Y2
                   ENDIF
  420        CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C Modified on June 27, 1997
             J=I
             DO 422 K=INOR(I,2),INOR(J,3)
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
               K2=K+IDEL
               F = F +0.5d0*(BETA1(K)*GRADF(K)+ BETA1(K2)*GRADF(K2))
  422        CONTINUE
c
           ELSE IF (NRULE.EQ.2) THEN
             DO 430 K=1,NANI
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C This line was added on October 21, 1996
c                  IF (IPEDIG(2,K).LT.0) GOTO 430
                   F = F - CONST
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                   IA = IPEDIG(1,K)
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IF (IPEDIG(2,K).LT.0) THEN
                     IP=0
                     IGPM=0
                     IGMM=0
                   ELSE
                     IP = IPEDIG(3,K)
                     IGPM = IPEDIG(4,K)
                     IF (NCOLPED.EQ.4) THEN
                       IGMM = IPEDIG(NCOLPED+1,K)
                     ELSE
                       IGMM = 0
                     ENDIF
                   ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   X = BETA1(IA)
                   X2 = BETA1(IA+IDEL)
                   IF (IP.GT.0) THEN 
                     X = X - 0.5D0 * BETA1(IP)
                     X2 = X2 - 0.5D0 * BETA1(IP+IDEL)
                   ENDIF
                   IF (IGPM.GT.0) THEN
                     X = X - 0.25D0 * BETA1(IGPM)
                     X2 = X2 - 0.25D0 * BETA1(IGPM+IDEL)
                   ENDIF
                   IF (IGMM.GT.0) THEN
                     X = X - 0.25D0 * BETA1(IGMM)
                     X2 = X2 - 0.25D0 * BETA1(IGMM+IDEL)
                   ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   IF (IPEDIG(2,K).LE.0) THEN
                     Y=VM1(1,1)*X+VM1(1,2)*X2
                     Y2=VM1(1,2)*X+VM1(2,2)*X2
                   ELSE
                     Y=DM1(IPEDIG(2,K)) * (VM1(1,1)*X+VM1(1,2)*X2)
                     Y2=DM1(IPEDIG(2,K)) * (VM1(1,2)*X+VM1(2,2)*X2)
                   ENDIF
c wwwwwwwwwwwwwwwwwwwwwwwwwwwwww
                   GRADF(IA) = GRADF(IA) + Y
                   GRADF(IA+IDEL) = GRADF(IA+IDEL) + Y2
                   IF (IP.GT.0) THEN
                     GRADF(IP) = GRADF(IP) - 0.5D0 * Y
                     GRADF(IP+IDEL) = GRADF(IP+IDEL) - 0.5D0 * Y2
                   ENDIF
                   IF (IGPM.GT.0) THEN
                     GRADF(IGPM)= GRADF(IGPM) -0.25D0 * Y
                     GRADF(IGPM+IDEL)= GRADF(IGPM+IDEL) -0.25D0 * Y2
                   ENDIF
                   IF (IGMM.GT.0) THEN
                     GRADF(IGMM)= GRADF(IGMM) -0.25D0 * Y
                     GRADF(IGMM+IDEL)= GRADF(IGMM+IDEL) -0.25D0 * Y2
                   ENDIF
  430            CONTINUE
               DO 432 K=INOR(I,2),INOR(I,3)
                   K2=K+IDEL
                   F = F +0.5d0*(BETA1(K)*GRADF(K)+ BETA1(K2)*GRADF(K2))
  432          CONTINUE
             ENDIF
             ENDIF
!!!! correlated random effects - end
            endif
!!!!
       ENDIF
  300   CONTINUE
      ENDIF
C
C-----------------------------------------------------------------------
C   READS BLOCK ON DISK IF NSTOR = 1
C-----------------------------------------------------------------------
      IF (nstor.ne.1) THEN
        IF (IOMODE.NE.4) THEN
           OPEN(4,file=FILE(9),FORM='UNFORMATTED')
c       ELSE
c          FILENAM=FILE(9)
c          CALL f77openr(IDFILE,FILENAMC)
c          IERR=1
        ENDIF
      ENDIF
C-----------------------------------------------------------------------
C   FOR EACH ELEMENTARY RECORD I :
C-----------------------------------------------------------------------
      IQ = 0
      LAST = -1
      IPRETIM = 0
      DLPRETIM = 0.D0
      TPRERHO = 0.D0
C
  100 IF (NSTOR.NE.1) THEN
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c Modified on December 12, 1996
cc##################################################
        IF (IOMODE.NE.4) THEN
           DO 766 I=1,NRECMAX
             DO 766 J=1,INTE_ST1
                blockb%info(I,J)=0
  766      CONTINUE
           do i=1,nrecmax
              do j=1,mxef_used
               blockb%idata(i,j)=0
               blockb%xdata(i,j)=0.d0
              end do
           end do
		   
	           do i=1,nrecmax
              do j=1,mxef_used
              end do
           end do  	   
		   
          READ(4,END=199) NREC,LTAB,
     + ((blockb%info(i,j),i=1,nrecmax),j=1,inte_st1),
     + ((blockb%idata(ix,jx),ix=1,nrecmax),jx=1,mxef_used),
     + ((blockb%xdata(iy,jy),iy=1,nrecmax),jy=1,mxef_used)
c       ELSE
c  IOMODE = 4 <==> compressed
c          DO 767 I=1,NRECMAX
c            DO 767 J=1,INTE_ST1
c               blockb%info(I,J)=0
c 767      CONTINUE
c          CALL f77cread(idfile,nrec,ltab,krec,ierr)
c          IF (ierr.EQ.0) GOTO 199
        ENDIF
      ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C added or modified on December 10, 1996
C  IF KEYWORD 'WITHIN' WAS USED WITH 'INTEGRATE_OUT', THIS PART
C  LOOKS AT THE TABLE OF RECORDS AND DETERMINES THE ORDER SUITABLE
C  FOR THE INTEGRATION: eg: year-season WITHIN herd. THIS ORDER IS
C  STORED IN blockb%info(*,KCOLWITH) AND blockb%info(*,KCOLINT) IS UPDATED
C  SO blockb%info(*,KCOLINT) CORRESPONDING
C  TO DIFFERENT 'herds' ARE DIFFERENT. IT IS ASSUMED THAT THERE ARE
C  LESS THAN MAXYS 'year-seasons' per 'herd'.
      NCOND = NINTTDEP + NWITHIN + ITDEPSTR
      IF (NWITHIN.NE.0) THEN
        IF (blockb%info(1,KCOLINT).GT.MAXYS) GOTO 909
        NH = MAXYS
        IDHERD = blockb%info(1,KCOLWITH)
        JJ = blockb%info(1,KCOLINT)
        KFIRST(JJ) = 1
        KLAST(JJ) = 1
        NLISTYS= 1
        LISTYS(1)= JJ
        blockb%info(1,KCOLINT)= NH +  JJ
        DO 900 I=2, NREC
           IF (blockb%info(I,KCOLWITH).NE.IDHERD) THEN
              DO 910 I1 = 1,NLISTYS-1
                 JJ = LISTYS(I1)
                 KK = LISTYS(I1+1)
                 blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
                 KFIRST(KK) = 0
                 KLAST(JJ) = 0
  910         CONTINUE
              NH = NH + MAXYS
              IDHERD = blockb%info(I,KCOLWITH)
                KK = LISTYS(NLISTYS)
                blockb%info(KLAST(KK),KCOLWITH)= I
                KLAST(KK) = 0
              NLISTYS= 0
           ENDIF
           JJ = blockb%info(I,KCOLINT)
           blockb%info(I,KCOLINT)= NH + JJ
           K = KLAST(JJ)
           IF (K.NE.0) THEN
              blockb%info(K,KCOLWITH) = I
           ELSE
              NLISTYS= NLISTYS + 1
              LISTYS(NLISTYS)= JJ
              KFIRST(JJ)= I
           ENDIF
           KLAST(JJ)= I
 900    CONTINUE
        DO 930 I1 = 1,NLISTYS-1
          JJ = LISTYS(I1)
          KK = LISTYS(I1+1)
          blockb%info(KLAST(JJ),KCOLWITH) = KFIRST(KK)
          KLAST(JJ) = 0
  930   CONTINUE
c       IF (NLISTYS.NE.0) THEN
          KK = LISTYS(NLISTYS)
          blockb%info(KLAST(KK),KCOLWITH)= 0
          KLAST(KK) = 0
        ENDIF
C
 909  I=1
      DO 190 I1=1,NREC
        I2=I2+1
        IF (NWITHIN.EQ.0) THEN
          I=I1
        ELSE IF (I1.NE.1) THEN
          IF (I.EQ.0) THEN
             GOTO 190
          ENDIF
          I = blockb%info(I,KCOLWITH)
          IF (I.EQ.0) GOTO 190
        ENDIF
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        IVALQ = blockb%info(I,KCOLINT)
C <<<<<<<<<<<<<<<<<<<<<<
C added October 16, 1996, modified (NCOND) December 10, 1996
        ICODE = blockb%info(I,2)
        IF (NCOND.NE.0.AND.ICODE.EQ.-2) GOTO 190
C <<<<<<<<<<<<<<<<<<<<<<
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD WAS THE LAST RECORD WITH IVALQ = IQ
C   UPDATE F (WEIBULL LIKELIHOOD) AND GRADF (ITS GRADIENT)
C   NQ IS THE NUMBER OF OBSERVED FAILURES WITH IVALQ = IQ
c
c IF INTEGAM=0 ==> THERE IS NO INTEGRATION OF ANY RANDOM (LOGGAMMA) EFFECT
c             ==> = REGULAR WEIBULL MODEL and LIKELIHOOD
c IF INTEGAM >0 ==> the fixed effect indicated by IVALQ is integrated out
c          assuming a gamma distribution
C   + NJOINT=1 ==> and the corresponding parameter is estimated
C            maximizing the posterior density jointly with the location parameters
C we need the first derivative of F with respect to this parameter too
C-----------------------------------------------------------------------
        IF (IQ.NE.0.AND.IVALQ.NE.IQ.AND.INTEGAM.NE.0) THEN
           IF (IQ.GT.0) THEN
             GAM0= GAMVAR
             XNS=XNS+1.D0
           ELSE
             GAM0=XINCLU
             XNSFIX=XNSFIX+1.D0
           ENDIF
           XNQGAM = XNQ + GAM0
           OMQGAM = OMEG + GAM0
           R1GAM = XNQGAM / OMQGAM
           F = F -GAMLOG(XNQGAM) + XNQGAM * DLOG(OMQGAM)
           IF (NJOINT.EQ.1.AND.IQ.GT.0)  GRADF(NDIM1) = GRADF(NDIM1)
     +       - DIGAMA(XNQGAM) + DLOG(OMQGAM)+ R1GAM
C
   20    GRADF(LAST) = GRADF(LAST) + R1GAM * DOMEG(LAST)
         DOMEG(LAST) = 0.D0
         LAST1 = POINT(LAST)
         POINT(LAST) = 0
         LAST = LAST1
         IF (LAST.GT.0) GOTO 20
C
         XNQ = 0.D0
         OMEG = 0.D0
         LAST = -1
       ENDIF
C-----------------------------------------------------------------------
C   IF THE PREVIOUS RECORD HAS A DIFFERENT STRATUM ID ==> NEW STRATUM
C   INITIALIZE CUM_RISK (CUMULATIVE RISK FOR ALL INDIVIDUALS) AND VECTOR
C   DC_RISK (CUMULATED CONTRIBUTION FOR EACH LEVEL TO BE USED IN
C   COMPUTING GRADF) + D2C_RISK (TO BE USED IN COMPUTING HESSIAN)
C
C  IF NINTTDEP=1  , blockb%info(I,KCOLPRE) CONTAINS PREVIOUS TIME
C-----------------------------------------------------------------------
       ITIM =blockb%info(I,1)
       ICODE = blockb%info(I,2)
c       IF (NCOND.EQ.0.OR.(NWITHIN.NE.0.AND.INTE_ST1.GE.4)) THEN
       IF (NSTRATA.GT.1) THEN
          ISTR = blockb%info(I,KCOLSTR)
       ELSE
          ISTR=1
       ENDIF
c       IF (ICRHO.EQ.99) THEN
c         IF (ITIM.EQ.MAXTIM(ISTR).AND.JMAXTIM(ISTR).EQ.999) GOTO 190
c       ENDIF
       RHO = VALRHO(ISTR)
       LRHO = DLOGRHO(ISTR)
       IQ = IVALQ
C-----------------------------------------------------------------------
C     W1 = SUM OF Z'*BETA1 FOR TIME-INDEPENDENT BEFORE CHANGE
C     FIRST, NCCOV CONTINUOUS COVARIATES, THEN NDCOV DISCRETE COVARIATES
C     BETA1 = -999 = - INFINITY => W2 = EXP(W1) WILL BE = 0
C-----------------------------------------------------------------------
       K = 0
       W1 = 0.D0
       DO 25 J=1,NCCOV
         IF (IANAL(J).NE.0) THEN
           XCOV = blockb%xdata(I,J)
           W1 = W1 + BETA1(J) * XCOV
           IF (BETA1(J).LE.-999.D0) W1 = -999.9D0
         ENDIF
   25  CONTINUE
       DO 30 J=NDCOV0,NDCOV1
         IF (IANAL(J).NE.0) THEN
           K = blockb%idata(I,J)
           IF (K.NE.0) W1 = W1 + BETA1(K)
         ENDIF
   30  CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       DO 31 J=1,NCOEF(0)
         JJ=NCOEF(J)
         IF (IANAL(JJ).NE.0) THEN
            K = blockb%idata(I,JJ)
            IF (K.NE.0) W1 = W1 + (XCOEF(JJ) - 1.D0) * BETA1(K)
         ENDIF
   31  CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       W1 = W1 + BETA1(NDIMB+ISTR)
C
C-----------------------------------------------------------------------
C   DIVERGENCE ==> STOP
C-----------------------------------------------------------------------
       IF (W1.GT.100.D0) THEN
         K = MIN(5000,NDIM1)
         IA = NDIM1+1
         IF (K.LT.NDIM1) IA=NDIM1-3
         WRITE(6,*) 'OVERFLOW '
         WRITE(6,*) 'BETA1 =   '
         WRITE(6,32) (J,BETA1(J),J=1,K),(J,BETA1(J),J=IA,NDIM1)
  32     FORMAT(1x,4(I5,G12.5),/1x)
         WRITE(6,*) 'W1    =   ',W1
         STOP
       ENDIF
C
C-----------------------------------------------------------------------
C   COMPUTE W2 = EXP(W1) AND W3 = W2 * (ITIM**RHO - IPRETIM**RHO)
C  IF ICRHO=1  COMPUTE:
C      IF NO_LOG=1    (MAXIMIZATION IS ON RHO):
c    W4 = W2 * (ITIM**RHO * (LOG ITIM) - IPRETIM**RHO * (LOG IPRETIM))
C      IF NO_LOG^=1    (MAXIMIZATION IS ON LOG(RHO)):
C    W4 = RHO * W4 ABOVE
C-----------------------------------------------------------------------
       W2 = 0.D0
C
       IF (W1.GT.-80.D0) W2 = DEXP(W1)
       DLTIM = VECLOG(ITIM)
       TRHO = VECEXP(ITIM,ISTR)
C <<<<<<<<<<<<<<<<<<<<<<
C added October 16, 1996, modified (NCOND) December 10, 1996
      IF (ICODE.EQ.-2) THEN
         IPRETIM= ITIM
         DLPRETIM = DLTIM
         TPRERHO = TRHO
         GOTO 190
      ENDIF
      IF (NCOND.NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<
C
C BECAUSE THE ORDERING OF THE RECORDS DOES NOT PERMIT TO KEEP OLD
C VALUES OF DLTIM AND TRHO , THEY HAVE TO BE RECALCULATED
C
       IF (NINTTDEP.NE.0.OR.ITDEPSTR.NE.0) THEN
          IPRETIM= blockb%info(I,KCOLPRE)
          IF (IPRETIM.EQ.0) THEN
              DLPRETIM=0.D0
              TPRERHO=0.D0
           ELSE
	      DLPRETIM=VECLOG(IPRETIM)
              TPRERHO=VECEXP(IPRETIM,ISTR)
           ENDIF
C <==> NWITHIN <> 0
C <<<<<<<<<<<<<<<<<<<<<<
C added February 27 1997
        ELSE IF (NWITHIN.NE.0) THEN
C <<<<<<<<<<<<<<<<<<<<<<
C added December 10, 1996
          IF (I.EQ.1) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            DLPRETIM=0.D0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).GE.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO ANOTHER ANIMAL
            IPRETIM=0
            DLPRETIM=0.D0
            TPRERHO=0.D0
          ELSE IF (blockb%info(I-1,2).LT.0) THEN
C THE PREVIOUS RECORD CORRESPONDS TO THE SAME ANIMAL
            IPRETIM= blockb%info(I-1,1)
            DLPRETIM=VECLOG(IPRETIM)
            TPRERHO=VECEXP(IPRETIM,ISTR)
          ENDIF
C <<<<<<<<<<<<<<<<<<<<<<
         ENDIF
        ENDIF
        W3 = W2 * (TRHO - TPRERHO)
        IF (TRHO.EQ.0d0.AND.TPRERHO.GT.0d0) W3=0
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        IF (ICRHO.EQ.99.AND.ICODE.GT.0) GOTO 7878
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
c 
       IF (W3.LT.0.) THEN
         print*,'w3,',W3,TRHO,TPRERHO,ITIM,IPRETIM,I1,I2
       ENDIF
       OMEG = OMEG + W3
c
       DO 55 J=1,NCCOV
         IF (IANAL(J).NE.0) THEN
           XCOV = blockb%xdata(I,J)
           IF (POINT(J).EQ.0) THEN
             POINT(J) = LAST
             LAST = J
           ENDIF
           DOMEG(J) = DOMEG(J) +  W3 * XCOV
         ENDIF
   55  CONTINUE
       DO 70 J=NDCOV0,NDCOVP1
         IF (J.LE.NDCOV1) THEN
           IF (IANAL(J).EQ.0) GOTO 70
           K = blockb%idata(I,J)
           IF (K.EQ.0) GOTO 70
         ELSE
           K = NDIMB+ISTR
         ENDIF
         IF (POINT(K).EQ.0) THEN
           POINT(K) = LAST
           LAST = K
         ENDIF
         DOMEG(K) = DOMEG(K) +  W3
   70  CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
       DO 72 J=1,NCOEF(0)
         JJ=NCOEF(J)
         IF (IANAL(JJ).NE.0) THEN
           K = blockb%idata(I,JJ)
           IF (K.NE.0)
     +      DOMEG(K) = DOMEG(K) + (XCOEF(JJ) - 1.D0) * W3
         ENDIF
   72  CONTINUE
c <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c
C-----------------------------------------------------------------------
c elements in first and 2nd derivatives with respect to rho's
C-----------------------------------------------------------------------
c
       IF (ICRHO.EQ.1) THEN
          W4 = W2 * (TRHO * DLTIM - TPRERHO * DLPRETIM)
          IF (NO_LOG.NE.1) W4 = RHO * W4
          K = NDIMBPS + ISTR
          IF (POINT(K).EQ.0) THEN
            POINT(K) = LAST
            LAST = K
          ENDIF
          DOMEG(K) = DOMEG(K) + W4
       ENDIF
C
C-----------------------------------------------------------------------
C   IF UNCENSORED RECORD, UPDATE F AND GRADF
C-----------------------------------------------------------------------
 7878  K = 0
       IF (ICODE.GE.1) THEN
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         XNQ = XNQ + 1.D0
         IF (ICRHO.EQ.99) THEN
           W6= DEXP(- W2)
           W7= 1.D0 - W6
	   F = F - DLOG(W7)
           W7= DEXP(W1-W2)/W7
	 ELSE
           F = F - LRHO - (RHO - 1.D0) * DLTIM - W1
         ENDIF
c
         DO 75 J=1,NCCOV
           IF (IANAL(J).NE.0) THEN
             IF (ICRHO.EQ.99) THEN
                GRADF(J) = GRADF(J) - blockb%xdata(I,J) * W7
             ELSE
                GRADF(J) = GRADF(J) - blockb%xdata(I,J)
             ENDIF
           ENDIF
   75    CONTINUE
         DO 80 J=NDCOV0,NDCOVP1
           IF (J.LE.NDCOV1) THEN
             IF (IANAL(J).NE.0) THEN
               K = blockb%idata(I,J)
               IF (K.EQ.0) GOTO 80
             ELSE
               K=0
             ENDIF
           ELSE
             K = NDIMB+ISTR
           ENDIF
           IF (K.GT.0) THEN
             IF (ICRHO.EQ.99) THEN
                GRADF(K) = GRADF(K) - W7
             ELSE
                GRADF(K) = GRADF(K) - 1.D0
             ENDIF
           ENDIF
   80    CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C  added on November 26, 1996
         DO 82 J=1,NCOEF(0)
           JJ=NCOEF(J)
           IF (IANAL(JJ).NE.0) THEN
              K = blockb%idata(I,JJ)
           ELSE
              K=0
           ENDIF
           IF (K.GT.0) THEN
             IF (ICRHO.EQ.99) THEN
                GRADF(K) = GRADF(K) + (1.D0 -XCOEF(JJ)) * W7
             ELSE
                GRADF(K) = GRADF(K) + 1.D0 - XCOEF(JJ)
             ENDIF
           ENDIF
   82    CONTINUE
C <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         IF (ICRHO.EQ.1) THEN
           K = NDIMBPS + ISTR
           IF (NO_LOG.EQ.1) THEN
             GRADF(K) = GRADF(K) - (1.D0/RHO) - DLTIM
           ELSE
             GRADF(K) = GRADF(K) - 1.D0 - RHO * DLTIM
           ENDIF
         ENDIF
       ENDIF
  189  IF (NCOND.EQ.0) THEN
         IF (ICODE.GE.0) THEN
           IPRETIM = 0
           TPRERHO = 0.D0
           DLPRETIM = 0.D0
         ELSE
           IPRETIM = ITIM
           TPRERHO = TRHO
           DLPRETIM = DLTIM
         ENDIF
       ENDIF
c
  190 CONTINUE
      IF (NSTOR.NE.1) GOTO 100
  199 IF (NSTOR.NE.1) THEN
         IF (IOMODE.NE.4) THEN
           CLOSE(4)
c        ELSE
c          call f77close(idfile)
         ENDIF
      ENDIF
C-----------------------------------------------------------------------
C   LAST CONTRIBUTION TO F AND GRADF
C-----------------------------------------------------------------------
      IF (INTEGAM.EQ.0) THEN
C-----------------------------------------------------------------------
C   REGULAR WEIBULL MODEL
C-----------------------------------------------------------------------
        F = F + OMEG
        R1GAM = 1.D0
      ELSE
C-----------------------------------------------------------------------
C   WEIBULL MODEL WITH INTEGRATION OF A FRAILTY TERM
C-----------------------------------------------------------------------
        IF (IQ.GT.0) THEN
          GAM0= GAMVAR
          XNS=XNS+1.D0
        ELSE
          GAM0=XINCLU
          XNSFIX=XNSFIX+1.D0
        ENDIF
        XNQGAM = XNQ + GAM0
        OMQGAM = OMEG + GAM0
        R1GAM = XNQGAM / OMQGAM
c  (note: some of these terms are constant when GAM0=constant)
        IF (NINCLU.NE.0)
     +    F = F - XNSFIX *(XINCLU* DLOG(XINCLU) - GAMLOG(XINCLU))
        F = F - XNS * (GAMVAR * DLOG(GAMVAR) - GAMLOG(GAMVAR))
        F = F -GAMLOG(XNQGAM) + XNQGAM * DLOG(OMQGAM)
C derivative with respect to GAM0
        IF (NJOINT.EQ.1.AND.IQ.GT.0)
     +          GRADF(NDIM1) = GRADF(NDIM1)
     +            - DIGAMA(XNQGAM) + DLOG(OMQGAM)+ R1GAM
        IF (NJOINT.EQ.1) THEN
           GRADF(NDIM1) = GRADF(NDIM1)
     +            - XNS * (1.D0 + DLOG(GAMVAR) - DIGAMA(GAMVAR))
           GRADF(NDIM1) = GAMVAR * GRADF(NDIM1)
        ENDIF
      ENDIF
c
  220 X = DOMEG(LAST)
      GRADF(LAST) = GRADF(LAST) + R1GAM * X
      DOMEG(LAST) = 0.D0
      LAST1 = POINT(LAST)
      POINT(LAST) = 0
      LAST = LAST1
      IF (LAST.GT.0) GOTO 220
c
      XNQ = 0.D0
      OMEG = 0.D0
      LAST = -1
C-----------------------------------------------------------------------
C   CONSTRAINTS ON GRADF + COUNT NON ZERO PARAMETERS
C-----------------------------------------------------------------------
      DO 250 I = 1,ICONS(0)
        GRADF(ICONS(I)) = 0.D0
  250 CONTINUE
      IDF=0
      DO 260 J=1,NDIM1
        IF (GRADF(J).NE.0.D0) IDF = IDF + 1
  260 CONTINUE
      IUSER(1) = IDF
      IF (NSTATE.EQ.1) THEN
        IUSER(2) = 1
      ELSE
        IUSER(2) = IUSER(2) + 1
      ENDIF
c
c     print*,'F0=',F
      NPR_XNS=NPR_XNS+1
      IF (IUSER(2).EQ.1.AND.XNS.GT.0.AND.NPR_XNS.EQ.1) THEN
         write(6,*)
     +  ' LEVELS OF THE EFFECT INTEGRATED OUT  = ',INT(XNS)
         write(12,*)
     +  ' LEVELS OF THE EFFECT INTEGRATED OUT  = ',INT(XNS)
 !     mxlvout=xns
      ENDIF

c      deallocate(kfirst,klast,listys,point,domeg)
	 
      RETURN

C***********************************************************************
      END
