      SUBROUTINE RWBACKUP(ICODE,FILEBK)
C//////////////////////////////////////////////////////////////////////*
C  BACKUP        *                                    *  29 / 04 /1996 *
C//////////////////////////////////////////////////////////////////////*
c
      use parinclu
      implicit none
c
      real*8,allocatable :: valrhop(:)  !VALRHOP(MXSTRA)
      real*8,allocatable :: betaprev(:)  !BETAPREV(NDIMAX)
c
      INTEGER I,II,J,JJ,K,KK,L,ICODE
      INTEGER NEF,JM
      INTEGER ICRHO2,NDIM2,NDIMB2,NJOINT2,NSTRATA2
C
      REAL*8 X
      REAL*8 DIFF,SUM,NORM,CHMAX
C
      CHARACTER*8 LAB,DUMMY
      CHARACTER*100 FILEBK
C
      if (.not.allocated(VALRHOP)) then
        allocate(VALRHOP(MXSTRA),BETAPREV(NDIMAX) )
      endif
C
      OPEN(14,FILE=FILEBK,FORM='FORMATTED',RECL=200)
c***********************************************************************
C
C IF ICODE = 1 , WRITE SOLUTIONS
C
      IF (ICODE.NE.1) GOTO 100
      WRITE(14,*) 'WEIBULL PARAMETER FIXED ? (1 = NO) '
      WRITE(14,*)  ICRHO
      WRITE(14,*) 'NUMBER OF STRATA'
      WRITE(14,*) NSTRATA
      WRITE(14,*) 'JOINT ESTIMATION OF GAMMA PARAMETER ? (1 = YES) '
      WRITE(14,*) NJOINT
      WRITE(14,*) ' PROBLEM SIZE'
      WRITE(14,*) NDIMB,NDIM
c
      WRITE(14,*) 'WITH NO COVARIATE :'
      WRITE(14,*) 'INTERCEPT'
      DO 12 J=1,NSTRATA
        IF (NSTRATA.GT.1) THEN
          WRITE(14,13) BETAWOC(J),'   (STRATUM',J,'=',  
     +                             (IOLCODST(J,L),L=1,NCOL(0))
         ELSE
           WRITE(14,*) BETAWOC(J)
         ENDIF
  12  CONTINUE
  13  FORMAT(D20.14,2X,A,1X,I4,1X,A2,3(1X,I4))
      IF (ICRHO.EQ.1) THEN
         WRITE(14,*) 'WEIBULL PARAMETER(S)'
      ELSE
         WRITE(14,*) 'WEIBULL PARAMETER(S) (FIXED)'
      ENDIF
c        DO 14 I=NSTRATA+1,NDIM-NDIMB-NJOINT
c corrected on April 3, 2000 (before: J= NSTRATA + I +1)
      DO 14 I=1,NSTRATA
        J=NSTRATA+I+NJOINT
        IF (BETAWOC(J).EQ.0.D0) BETAWOC(J)=VALRHO(I)
        IF (NO_LOG.NE.1) THEN
           X = DEXP(VALRHO(I))
c          X = DEXP(BETAWOC(I))
           IF (NSTRATA.GT.1) THEN
             WRITE(14,13) X,'   (STRATUM',I,'=',  
     +                               (IOLCODST(I,L),L=1,NCOL(0))
           ELSE
             WRITE(14,*) X 
           ENDIF
         ELSE
           IF (NSTRATA.GT.1) THEN
             WRITE(14,13) BETAWOC(J),'   (STRATUM',I,'=',  
     +                               (IOLCODST(I,L),L=1,NCOL(0))
           ELSE
             WRITE(14,*) BETAWOC(J)
           ENDIF
         ENDIF
  14  CONTINUE
      IF (NJOINT.EQ.1) THEN
         WRITE(14,*) '(LOG) GAMMA PARAMETER FOR EFFECT ',
     +        INTEGAM,'= ',LABEL(INTEGAM)
         WRITE(14,*) BETAWOC(NDIM-NDIMB)
      ENDIF
C
      WRITE(14,*) 'WITH COVARIATES :'
      WRITE(14,*) 'INTERCEPT'
      DO 22 J=1,NSTRATA
        K=NDIMB+J
        IF (ITOEV.GT.1) DIFF=BETA(K) -BETAPREV(K)
        BETAPREV(K)=BETA(K)
        IF (DIFF.EQ.0.D0.OR.ITOEV.LE.1) THEN
          IF (NSTRATA.GT.1) THEN
             WRITE(14,13) BETA(K),'   (STRATUM',J,'=',  
     +                             (IOLCODST(J,L),L=1,NCOL(0))
           ELSE
             WRITE(14,*) BETA(K)
           ENDIF
        ELSE
          WRITE(14,*) BETA(K),'  LAST CHANGE:',DIFF
        ENDIF
  22  CONTINUE
      IF (ICRHO.EQ.1) THEN
         WRITE(14,*) 'WEIBULL PARAMETER(S)'
      ELSE
         WRITE(14,*) 'WEIBULL PARAMETER(S) (FIXED)'
      ENDIF
c      DO 25 I=NDIMB+NSTRATA+1,NDIM-NJOINT
      DO 25 I=1,NSTRATA
        IF (ITOEV.GT.1) DIFF=VALRHO(I)-VALRHOP(I)
        VALRHOP(I)=VALRHO(I)
        IF (DIFF.EQ.0.D0.OR.ITOEV.LE.1) THEN
          IF (NSTRATA.GT.1) THEN
             WRITE(14,13) VALRHO(I),'   (STRATUM',I,'=',  
     +                             (IOLCODST(I,L),L=1,NCOL(0))
           ELSE
             WRITE(14,*) VALRHO(I) 
           ENDIF
        ELSE
          WRITE(14,*) VALRHO(I),'  LAST CHANGE:',DIFF
          IF (DETAIL_IT)
     +     WRITE(6,*) 'RHO: ', VALRHO(I),' LAST CHANGE:',DIFF
        ENDIF
        VALRHOP(I)=VALRHO(I)
c        J = I - NDIMB -NSTRATA
c        IF (NO_LOG.NE.1) THEN
c          X = DEXP(BETA(I))
c          WRITE(14,*) X
c        ELSE
c          WRITE(14,*) BETA(I)
c        ENDIF
  25  CONTINUE
      IF (NJOINT.EQ.1) THEN
         WRITE(14,*) '(LOG) GAMMA PARAMETER FOR EFFECT ',
     +        INTEGAM,'= ',LABEL(INTEGAM)
         IF (ITOEV.GT.1) DIFF=BETA(NDIM)-BETAPREV(NDIM)
         BETAPREV(NDIM)=BETA(NDIM)
         IF (DIFF.EQ.0.D0.OR.ITOEV.LE.1) THEN
           WRITE(14,*) BETA(NDIM)
         ELSE
           WRITE(14,*) BETA(NDIM),' LAST CHANGE:',DIFF
          IF (DETAIL_IT)
     +     WRITE(6,*) 'LOGGAMMA: ', BETA(NDIM),' LAST CHANGE:',DIFF
         ENDIF
      ENDIF
      WRITE(14,*) 'SOLUTIONS (NOT SORTED) '
      WRITE(14,*) ' (SOL. FOR CONTINUOUS COVARIATES ARE STANDARDIZED) '
      DO 30 J=1,NCOVMOD
        II = IMOD(J)
        IF (II.EQ.INTEGAM.OR.ISAME(II).NE.0) GOTO 30
        JJ=ILAST(II)-IFIRST(II)+1
        SUM=0.D0
        NORM=0.D0
        NEF=0
        CHMAX=0.D0
        JM=0
        DO 32 K=IFIRST(II),ILAST(II)
          IF (BETA(K).NE.0.D0) THEN
            DIFF=BETA(K)-BETAPREV(K)
            IF (DABS(DIFF).GT.CHMAX) THEN
              CHMAX=DABS(DIFF)
              JM=K-IFIRST(II)+1
            ENDIF
            SUM=SUM+DABS(DIFF)
            NORM=NORM+DIFF*DIFF
            NEF=NEF+1
            BETAPREV(K)=BETA(K)
          ENDIF
  32    CONTINUE
        IF (ITOEV.GT.1) THEN
           SUM=SUM/MAX(1.D0,DBLE(NEF))
           NORM=DSQRT(NORM)/MAX(1.D0,DBLE(NEF))
        ENDIF
        IF (CHMAX.GT.0.D0) THEN
         WRITE(14,94) LABEL(II),ICOVTYP(II),JJ,SUM,NORM,CHMAX,JM
          IF (DETAIL_IT)
     +   WRITE(6,94) LABEL(II),ICOVTYP(II),JJ,SUM,NORM,CHMAX,JM
        ELSE
         WRITE(14,*) LABEL(II),ICOVTYP(II),JJ
        ENDIF
  94    FORMAT(1X,A8,I2,I8,' ABS_CHANGE: ',D10.3,' NORM: ',D10.3,
     +   ' MAX: ',D10.3,' (',I4,')')
        WRITE(14,90) (BETA(K),K=IFIRST(II),ILAST(II))
  90    FORMAT(1X,6F12.6)
  30  CONTINUE
      WRITE(14,92) ITOEV
  92  FORMAT(1X,'F_EVAL ',I5,' 0')
C
      CLOSE(14)
      RETURN
C
C ICODE <> 1 ==> READ SOLUTIONS
c
  100 CONTINUE
c WEIBULL PARAMETER FIXED ? (1 = NO)
      READ(14,*) dummy
      READ(14,*) ICRHO2
c      write(6,*) dummy,ICRHO2
C NUMBER OF STRATA
      READ(14,*) dummy
c      write(6,*) dummy
      READ(14,*) NSTRATA2
c      write(6,*) dummy,NSTRATA2
c JOINT ESTIMATION OF GAMMA PARAMETER ? (1 = YES)
      READ(14,*) dummy
c      write(6,*) dummy
      READ(14,*) NJOINT2
c      write(6,*) NJOINT2
C PROBLEM SIZE
      READ(14,*) dummy
c      write(6,*) dummy
      READ(14,*) NDIMB2,NDIM2
c      write(6,*) NDIMB2,NDIM2
c
C WITH NO COVARIATE
      READ(14,*) dummy
c      write(6,*) dummy
      READ(14,*) dummy
c      write(6,*) dummy
      DO 112 J=1,NSTRATA2
        READ(14,*) BETAWOC(J)
c        WRITE(6,*) 'BETAWOC',J,BETAWOC(J)
 112  CONTINUE
C WEIBULL PARAMETER
      READ(14,*) dummy
c      write(6,*) dummy
c      DO 114 I=NSTRATA2+1,NDIM2-NDIMB2-NJOINT2
      DO 114 I=1,MAX(NSTRATA,NSTRATA2)
         IF (I.LE.NSTRATA2) READ(14,*) X
c         write(6,*) X
         IF (ICRHO.EQ.1) THEN
            IF (NO_LOG.NE.1) X= DLOG(X)
            VALRHO(I)=X
         ELSE
            X=VALRHO(I)
         ENDIF
         IF (ICRHO.EQ.1) BETAWOC(I+NSTRATA) = X
 114  CONTINUE
C GAMMA PARAMETER
      IF (NJOINT2.EQ.1) THEN
        READ(14,*) dummy
        READ(14,*) X
        IF (NJOINT.EQ.1) BETAWOC(NDIM-NDIMB)=X
      ENDIF
      DO 116 I=1,NDIM-NDIMB+1
        BETA(I+NDIMB) = BETAWOC(I)
  116 CONTINUE
      IF (ICODE.EQ.2) THEN
         CLOSE(14)
         RETURN
      ENDIF
C
C WITH COVARIATES :
C      INTERCEPT
      READ(14,*) dummy
c      write(6,*) dummy
      READ(14,*) dummy
c      write(6,*) dummy
      DO 122 J=1,NSTRATA
        READ(14,*) BETA(NDIMB+J)
c        write(6,*) BETA(NDIMB+J)
  122 CONTINUE
C WEIBULL PARAMETER(S)
      READ(14,*) dummy
c      write(6,*) dummy
c      IF (ICRHO.EQ.1) THEN
c         DO 125 I=NDIMB2+NSTRATA2+1,NDIM2-NJOINT2
         DO 125 I=1,MAX(NSTRATA,NSTRATA2)
           IF (I.LE.NSTRATA2) READ(14,*) X
c           write(6,*) 'rho=',X
           IF (ICRHO.EQ.1) THEN
             VALRHO(I) = X
             IF (NO_LOG.NE.1) X=DLOG(X)
             BETA(NDIMB+I+NSTRATA) = X
           ELSE
             X = VALRHO(I)
           ENDIF
  125    CONTINUE
c      ENDIF
C GAMMA PARAMETER
      IF (NJOINT2.EQ.1) THEN
        READ(14,*) dummy
c        write(6,*) dummy
        READ(14,*) X
c        write(6,*) 'gamma=',x
        IF (NJOINT.EQ.1) BETA(NDIM)= X
      ENDIF
C SOLUTIONS (NOT SORTED)
      READ(14,*) dummy
c        write(6,*) dummy
      READ(14,*) dummy
c        write(6,*) dummy
  130 READ(14,*,END=199) LAB,KK,JJ
c      write(6,*) LAB,KK,JJ
      IF (LAB.EQ.'F_EVAL  ') GOTO 199
      II=0
      DO 140 J=1,NCOVMOD
        I=IMOD(J)
        IF (LABEL(I).EQ.LAB) II=I
  140 CONTINUE
      IF (II.NE.0) THEN
        IF (ISAME(II).NE.0) GOTO 130
        READ(14,90) (BETA(K),K=IFIRST(II),IFIRST(II)+JJ-1)
c        write(6,90) (BETA(K),K=IFIRST(II),IFIRST(II)+JJ-1)
      ELSE
        READ(14,*) X
      ENDIF
      GOTO 130

  199 CLOSE(14)

c     deallocate(valrhop,betaprev)
	 
      RETURN
c***********************************************************************
      END

