package at.boku.survivalkit.skonstructor.form.support;

import java.awt.Component;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class DialogUtils {

	public static File runFileChooser(Component component) {
		JFileChooser fc = new JFileChooser();
		if (fc.showOpenDialog(component) == JFileChooser.APPROVE_OPTION) {
			File f = fc.getSelectedFile();
			return f;
		}
		return null;
	}
	
	public static void displayInfoMessageDialog(Component component, String text) {
		JOptionPane.showMessageDialog(component, text, "Information", JOptionPane.INFORMATION_MESSAGE);
	}
	
	public static void displayErrorMessageDialog(Component component, String text) {
		JOptionPane.showMessageDialog(component, text, "Error", JOptionPane.ERROR_MESSAGE);
	}
}
