package at.boku.survivalkit.skonstructor.form.support;

import java.awt.Component;
import java.io.File;
import java.io.IOException;
import java.util.Map;

import at.boku.survivalkit.skonstructor.export.FileExporter;

public class ExportAction {

	public void exportToFile(Component comp, Map<String, String> params) {

		File file = DialogUtils.runFileChooser(comp);
		if (file != null) {
			FileExporter exporter = new FileExporter();
			try {
				exporter.doExport(file, params);
				DialogUtils.displayInfoMessageDialog(comp, "Successfuly saved.");
			} catch (IOException e) {
				e.printStackTrace();
				DialogUtils.displayErrorMessageDialog(comp,
						"Something went wrong, check the logs.");
			}
		}

	}
}
